<?php

/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * Example for class pmxDom
 */
class dom_admin {

    private static $_dom;

    function __construct($op) { 
        // damit können hier die verschiedenen Themen ausprobiert werden
        pmxDom::setTheme(false);

        switch ($op) {
            default :
                $this->_main();
                break;
        }
    }

    private function _main() {
        mxIncludeHeader();
        if (MX_IS_ADMIN) {
         GraphicAdmin(); // TODO
        pmxHeader::add_style_code('table, th, td {
            border: 1px solid;
          }');
        title("Dom - jQueryUI");
        echo implode("", [
            "<ol>",
            '<li>jQueryUI-CSS-STYLE geht beim Admin-Theme "admin-pmx" verloren</li>',
            "<li>Vieles ist optional einstellbar, dadurch könnte man theoretisch einen Button nur mit addButton() erstellen<ul><li>Die UNIQID ist fast überall optional - soll nur beim CSS + JS helfen<br>&nbsp;Der ganze CSS der hier gesetzt wurde ist eigendlich nicht erforderlich</li></ul></li>",
            '<li>Es muss nichts mehr includet werden, macht alles die Klasse</li>',
            "</ul>",
            "<ol>TODO:<ul>",
            '<li>Damit das Update von jQuery + UI vollzogen werden kann, müssen folgende Plugins entfernt ODER ersetzt werden:<ul>',
                "<li>OK - jquery.tinywatermark.js - fertig</li>",
                "<li>OK - jquery.sticky.js - fertig</li>",
                "<li>OK - jquery.epiclock.js - fertig</li>",
                "<li>jscroller.js - ersetzen mit addScrollContent()</li>", 
                "<li>ajaxupload.js - ersetzen mit jQuery ajax()</li>",
                "<li>ui/jquery.ui.tabs.noui.js - ersetzen mit addTabs()</li>",
                "<li>jquery.treeview.js</li>",
                "<li>lightbox.js.php</li>",
                "<li>superfish.js</li>",
                "<li>jquery.raty.js</li>", // hier schreiben wir ein eigenes
                "<li>jquery.prettyPhoto.js</li>",
                "<li>jquery.imagefit.js</li>", // letzte update 2015 - ersetzen mit jQueryUI dialog() (oder komplett raus) oder
                "<li>jquery.cookie.js - noch ok - könnte gegen pmxCookie() ersetzt werden</li>",
                "<li>jquery.password-checker.js - noch ok</li>", // - hier schreiben wir ein eigenes
            '</ul></li>',
            '<li>Tabs() - vertical</li>',
            '<li>Accordion() - vertical, cookie()</li>',
            '</ul></ol><hr>'
        ]);
        echo '<table width="100%">';
        self::_getChangeLog();
        self::_getUIThemes();
        self::_addMenuHover();
        self::_addCountDown();
        self::_addProgressbar();
        self::_addTabs();
        self::_addTabsInTabs();
        self::_addDatepicker();
        self::_addAccordion("accord1");
        self::_addDialog();
        self::_addButton();
        self::_addAccordion("accord2");
        self::_addTooltip();
        self::_addScrollContent();
        self::_addFeatures();
        self::_scrollTo();
        echo '</table>';
        }
        mxIncludeFooter();
    }

    private function _getChangeLog() {
        echo '<tr><td colspan="2"><ul>';
        echo implode("</li><li>", [
            '<b>CHANGELOG:</b>',
            'addCountDown(): jetzt auch mit Text möglich (Multilaguage)',
            'UNIQID regex(a-zA-Z0-9_) Der Bindestrich "-" ist nicht mehr möglich, wird auch für JS benötigt wird'
        ]);
        echo '</ul></td></tr>';
    }
    private function _addMenuHover() {
        echo '<tr><td><h3>MenuHover</h3>superfish.js</td>';
        echo '<td>' . pmxDom::_addMenuHover() . '<br><br><ul><li>NOCH IN DER MACHE</li><li><a href="https://api.jqueryui.com/theming/css-framework/" target="_blank">CSS-Framework</a></li></ul></td></tr>';
    }
    private function _addTabsInTabs() {
        echo '<tr><td><h3>Tabs in Tabs</h3></td>';
        echo '<td>' . pmxDom::addTabs(["items" => [
            array("menu 1", "text 1"),
            array("menu 2", pmxDom::addTabs(["items" => [
                array("menu 2-1", "text 2-1"),
                array("menu 2-2", "text 2-2"),
            ]])),
            array("menu 3", "text 3"),

        ]]) . '<br><br><ul><li>schaut doch ok aus ...</td></tr>';
    }

    private function _getUIThemes() {
        $juitheme = isset($_POST["juitheme"]) ? $_POST["juitheme"] : pmxBase::juitheme();
        pmxHeader::add_style('layout/jquery/ui/' . $juitheme . '/jquery-ui.min.css');
        $uthemes = "";
        $_counter = 0;
        foreach ((array)glob(PMX_LAYOUT_DIR . '/jquery/ui/*/jquery-ui.css', GLOB_NOSORT) as $filename) {
            $_counter++;
            $selected = "";
            $theme = basename(dirname($filename));
            if ($juitheme === $theme) {
                $selected = "selected";
            }
            $uthemes .= '<option value="' . $theme . '" ' . $selected . '>' . $theme . '</option>';
        }
        $_url = "//{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}";
        echo '<tr><td><h4>UI-Themen</h4></td><td><form action="' . $_url . '" method="post"><select name="juitheme" size="' . $_counter . '">' . $uthemes . '</select><br><br>' . 
        pmxDom::addButton(["type" => "submit", "text" => _EDIT, "styleClass" => "ui-button ui-widget ui-corner-all"]) . '<br><ul><li>Hat nur Auswirkung auf diese Seite</li><li>Übrigends ist das ein pmxDom->addButton()</li><li>Ein SELECT-Tag wurde erst mit jQuerUI 1.11 hinzugefügt</li><li>Beim Theme "pmx" werden 2 Bilder nicht gefunden</li><li>Mit jQueryUI update sind 25 Themen dabei</li><li>Beim Theme "admin-pmx" wird der Style überschieben</li></ul></form></td></tr>';
    }

    private function _addButton() {
        echo '<tr><td><h3>Button</h3></td>';
        echo '<td>' . pmxDom::addButton(["text" => "Ein Button ohne Funktion"]) . '<ul><li>addButton(["text" => "Ein Button ohne Funktion"])</li></ul></td></tr>';
    }

    private function _addAccordion($id) {
        echo '<tr><td><h3>Accordion</h3></td>';
        echo '<td>' . pmxDom::addAccordion(["uniqId" => $id, "items" => array([$id, "1 Lorem Ipsum"], ["2 title", "2 Lorem Ipsum"])], ["collapsible" => true, "icons" => ["header" => "ui-icon-circle-arrow-e", "activeHeader" => "ui-icon-circle-arrow-s"]]) . '<ul><li>addAccordion(["uniqId" => "' . $id . '", "items" => array(["' . $id . '", "1 Lorem Ipsum"], ["2 title", "2 Lorem Ipsum"])]</li></ul></td></tr>';
    }

    private function _addDialog() {
        pmxHeader::add_style_code('#clickMe {border: 1px solid red;padding:0.5em;border-radius:0.5em;}');
        echo '<tr><td><h3>Dialog</h3></td>';
        echo '<td><br><b id="clickMe">Klick mich</b><br><br>';
        echo pmxDom::addDialog(["uniqId" => "clickMe", "img" => "images/logo.gif", "title" => "the title dialog", "text" => "<br>the text dialog"]);
        echo '<ul><li>addDialog(["uniqId" => "clickMe", "img" => "images/logo.gif", "title" => "the title dialog", "text" => "the text dialog"])</li><li>Bild ist optional</li></ul></td></tr>';
    }
    
    private function _addProgressbar() {
        echo '<tr><td><h3>Progressbar</h3></td>';
        echo '<td>' . pmxDom::addProgressbar(["seconds" => 50, "ready" => [85, "Die Einstellungen wurden gespeichert!"], "addStyle" => true], true) . '<ul><li>addProgressbar(["seconds" => 50, "ready" => [85, "Die Einstellungen wurden gespeichert!"], "addStyle" => true], true);</li><li>Wenn zusätzlich noch eine URL angegeben wird, erscheint für den ADMIN eine Weiterleitung</li><li>Bei 100% passiert hier gar nichts, weil keine URL angegeben wurde</li><li>Wird ungefähr in Sekunden gerechnet</li><li>Die Zeit sollte mind. 30 Sekunden betragen</li><li>Damit hier die Prozentzahl nicht einfach einer hinzugfügt wird, habe ich hier ein random() gesetzt, das eine Zahl zwischen 2-3 addiert wird</li></ul></td></tr>';
    }

    private function _addTabs() {
        echo '<tr><td><h3>Tabs</h3>jquery.ui.tabs.noui.js,<br>pmxHeader::add_tabs()</td>';
        echo '<td>' . pmxDom::addTabs(["items" => array(["title 1", "text 1"], ["title 2", "text 2"], ["title 3", "text 3"], ["title 4", "text 4"]), "cookie" => "tab_dom"]) . '<ul><li>addTabs(["items" => array(["title 1", "text 1"], ["title 2", "text 2"], ["title 3", "text 3"]["title 4", "text 4"]), "cookie" => "tab_dom"])</li><li>Jetzt kann auch der Cookie gesetzt werden</li></ul></td></tr>';
    }

    private function _addTooltip() {
        echo '<tr><td><h3>Tooltip</h3></td>';
        echo '<td>Ein <u id="tooltipYes" title="Das ist ein Tooltip">Tooltip</u><br>
        Tooltip kann man auch <u id="tooltipNo" title="Sollte eigendlich nicht gehen">deaktivieren</u><br><u id="tooltipYes" title="Jaaaaaa">Dieser</u> wiederum geht wieder<br><ul><li>addTooltip(["uniqId" => "tooltipYes"])<br>addTooltip(["uniqId" => "tooltipNo"], ["disabled" => true])</li><li>Beim AdminTheme "admin-pmx" funktioniert es nicht</li><li>Generell hat tooltip() ein komisches Verhalten (Sie schauen unterschiedlich aus)</li></ul></td></tr>';
        pmxDom::addTooltip(["uniqId" => "#tooltipYes"]);
        pmxDom::addTooltip(["uniqId" => "#tooltipNo"], ["disabled" => true]);
    }

    private function _addCountDown() {
        echo '<tr><td><h3>CountDown</h3></td>';
        echo '<td>';
        // Beispiel 1
        echo pmxDom::addCountDown(["text" => str_replace("%d", "%0", _REDIRECTMESS1) ,"seconds" => 55]);
        /* Beispiel 2
        $_id = pmxDom::getUniqId();
        echo '<div>Irgenwas könnte man in <b id="' . $_id. '">55</b> Sekunden machen ...</div>';
        echo pmxDom::addCountDown(["uniqId" => $_id ,"seconds" => 45]);
        */
        echo '<ul><li>addCountDown(["text" => str_replace("%d", "%0", _REDIRECTMESS1) ,"seconds" => 55])</li><li>Wenn die Zeit abgelaufen ist, passiert gar nichts - weitere Einstellungen sind erforderlich</li><li>TEXT kann jetzt zusätzlich gesetzt werden (Multilaguage)</li><li>UNIQID ist jetzt optional</li><li>Damit 2 Counter gleichzeitig laufen können, muss der JS-Code angepasst werden</ul>'.
        '</td></tr>';
    }

    private function _scrollTo() {
        $_id = pmxDom::getUniqId();
        echo '<tr><td><h3>ScrollTo</h3></td>';
        echo '<td>' . pmxDom::addButton(["uniqId" => $_id, "text" => "Nach OBEN scrollen"]);
        pmxDom::scrollTo(["uniqId" => $_id, "milliseconds" => 2000], ["scrollTop" => 0]);
        echo '<ul><li>addButton(["uniqId" => "' . $_id . '", "text" => "Nach OBEN scrollen"])<br>scrollTo(["uniqId" => "' . $_id . '", "milliseconds" => 2000], ["scrollTop" => 0])</li><li>Ein Button kombiniert mit einem Srcoller</li></ul></td></tr>';
    }

    private function _addDatepicker() {
        $_id = pmxDom::getUniqId();
        $_id2 = pmxDom::getUniqId();
        echo '<tr><td><h3>Datepicker</h3>Datepicker</td>';
        pmxHeader::add_style_code('#' . $_id . ', #' . $_id2 . ' {border: 1px solid}');
        echo '<td>' . pmxDom::addDatepicker(["uniqId" => $_id, "value" => "Add your Dad Birthday"]);
        echo '&nbsp;&nbsp;' . pmxDom::addDatepicker(["uniqId" => $_id2, "value" => "Add your Mom Birthday"]);
        echo '<ul><li>addDatepicker(["uniqId" => "' . $_id . '", "value" => "Add your Dad Birthday"]);<br>addDatepicker(["uniqId" => "' . $_id2 . '", "value" => "Add your Mom Birthday"])</li><li>Hier kann man ganz einfach 2 Datepicker nehmen (Die UNIQID muss nur uniq sein)</li></ul></td></tr>';
    }

    private function _addFeatures() {
        echo '<tr><td><h3><em>Menu<br>Selectmenu<br>Checkboxradio<br>Controlgroup<br>Spinner<br>Autocomplete</em></h3></td>';
        echo '<td> - das geht erst mit Update - </td></tr>';
    }

    private function _addScrollContent() {
        /**
          @param string $content Inhalt, der gescrolled ausgegeben werden soll
 * @param string $direction optional, Richtung des Scrollens
 * - up = aufwaerts, down = abwaerts, left = von rechts nach links, right = von links nach rechts, default up
 * @param string $speed optional, Geschwindigkeit fuer das Scrolling, default 10
 * @param int $height optional, Hoehe in Pixel des scrollenden DIV-Containers, default 100px
 * @param int $width optional, Breite in Pixel des scrollenden DIV-Containers, default 0px (= 100%)
 * @param string $mousestop optional, Scrolling stoppt bei Mouseover
 * - true = ja, false = nein, default true
 * @param bool $focusstop optional, Scrolling stoppt, wenn das Fenster keinen Focus hat
 * - true = ja, false = nein, default true
 * @return string $out  gibt den kompletten Quelltext fuer die Ausgabe zurueck
 
        mxScrollContent($content, $direction = 'up', $speed = 4, $height = 60, $width = 0, $mousestop = true, $focusstop = true)

        overflow-y: hidden; /* Hide vertical scrollbar
         overflow-x: hidden; /* Hide horizontal scrollbar
         */
        // without jQuery
        $_lorem = 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.';
        echo '<tr><td><h3>ScrollContent</h3>mxScrollContent()</td>';
        echo '<td><div>Try scrolling:</div>';
        // Beispiel
        echo pmxDom::addScrollContent(["text" => $_lorem]);
        echo '<ul><li>addScrollContent(["text" => "Lorem ..."])</li><li>Komplett ohne jQuery</li></ul>';
        echo '</td></tr>';
    }

}

$tmp = new dom_admin($op);
$tmp = null;

?>