<?php

/**
 * This file is part of
 *
 * System
 *
 * for pragmamx (www.pragmamx.org)
 *

 * $Revision: 718 $
 * $Author: Nouvelle $
 * $Date: 2023-10-31 20:07:51 +0100 (Di, 31 Okt 2023) $

 */


/*
	1. check Schreibrechte
	2. Datei hochladen / Webupload nach tmp (ZIP)
	3. ZIP prüfen
	4. install.pmx.xml laden und infos anzeigen
	5. Start installation entsprechend Install.pmx.xml
	6. wenn ok, dann zip löschen
	7. anzeigen ergebnis






*/
defined('mxMainFileLoaded') or die('access denied');

include_once("includes/functions.php");

/**
 * plugins_admin
 *
 * @package
 * @author Olaf Herfurth

 * $Revision: 718 $
 * @copyright Copyright (c) 2014

 * @version $Id: index.php 718 2023-10-31 19:07:51Z Nouvelle $

 * @access public
 */
class manager_admin
{
  private $errors = array();
  private $form = null;
  private $homepage = '';
  private static $__set = array(); // Konfiguration
  static $kf = null;
  private $uninstallfile = "uninstall.json";
  private $installfile = "install.json";

  private static $_config = null;

  /**
   * class::__construct()
   *
   * @param string $parameter
   */
  function __construct($parameter = array())
  {
    global $prefix;
    list($this->act, $this->mod) = $parameter;
    mxGetLangfile(__DIR__);

    $this->modulname = PMX_MODULE;

    $this->config = $this->config_load();
    $this->main($this->act, $this->mod);
  }

  /**
   * class::__get()
   *
   * @param mixed $value_name
   * @return
   */
  public function __get($value_name)
  {
    if (isset(self::$__set[$value_name])) {
      return self::$__set[$value_name];
    }
    return false;
  }

  /**
   * class::__set()
   *
   * @param mixed $name
   * @param mixed $val
   * @return
   */
  public function __set($name, $val)
  {
    self::$__set[$name] = $val;
  }

  /**
   * class::main()
   *
   * @param string $action
   * @return
   */
  function main($act, $mod)
  {
    load_class('AdminForm', false);
    //mxDebugFuncVars($plugin,$act,$mod);
    $type = "start";
    $step = 0;
    switch ($act) {
      case "0":
        break;
    }


    $step = (isset($_POST['step'])) ? $_POST['step'] : $step;
    $type = (isset($_POST['type'])) ? $_POST['type'] : $type;

    switch (pmxAdminForm::CheckButton()) {
      case "cancel":
        $step = 0;
        $type = "start";
        break;
      case "next":
        $step++;
        break;
      case "back":
        $step--;
        break;
      case "package_add":
        $type = "installation";
        break;
      case "package_delete":
        $type = "deinstallation";
        break;
      default:
        $step = 0;
        $type = "start";
    }
    $this->config = $this->config_load();

    $this->{$type}($step, $act, $mod);
  }

  function start($step = 0, $act = "", $mod = "")
  {

    $value = "";
    $tb = load_class('AdminForm', "adminFormManagers");
    $tb->title = _AM_MANAGER;
    $tb->description = _AM_INFO;

    //$tb->tb_text = _AM_INFO;
    $tb->tb_direction = 'left';
    $tb->infobutton = false;
    $tb->tb_pic_heigth = 82;
    $tb->cssform = "a305020";
    $tb->homelink = true;
    $tb->target_url = adminUrl("manager");
    $tb->acceptbutton = false;

    $tb->addToolbar("package_add", _INSTALLATION);
    $tb->addToolbar("package_delete", _DEINSTALLATION);

    mxIncludeHeader();
    //echo "<h2>"._AM_MANAGER."</h2>";
    echo $tb->show();
    mxIncludeFooter();
  }


  function installation($step = 0, $act = "", $mod = "")
  {

    $value = "";
    $tb = load_class('AdminForm', "adminFormManagersInstall");
    $tb->title = _AM_MANAGER;
    $tb->description = _AM_INFO;

    //$tb->tb_text = _AM_INFO;
    $tb->tb_direction = 'right';
    $tb->infobutton = false;
    $tb->tb_pic_heigth = 36;
    $tb->cssform = "a305020";
    $tb->homelink = true;
    $tb->target_url = adminUrl("manager");
    $tb->acceptbutton = false;

    $tb->addToolbar("cancel");


    $tb->addFieldset("install", _INSTALLATION . "Step : " . $step);
    $tb->add("install", "hidden", "step", $step);
    $tb->add("install", "hidden", "type", "installation");
    switch ($step) {
      case 0:
        $tb->add("install", "file", "ifile", $value, _AM_FILEUPLOAD, _AM_FILEUPLOAD_INFO);
        $tb->add("install", "html", '<div class="align-center"><button type="submit" name="toolbarsubmit" value="forward" id="admininstall" class="button " title="' . _UPLOAD . '" onclick="javascript:hideMainMenu();">' . _UPLOAD . '</button></div>');

        break;
      case 1:
        $tb->add("install", "output", "Hallo");
        $tb->add(
          "install",
          "html",
          '<div class="align-center"><button type="submit" name="toolbarsubmit" value="forward" id="admininstall" class="button " title="' . _INSTALLATION . '" onclick="javascript:hideMainMenu();">' . _INSTALLATION . '</button></div>'
        );
        break;
    }


    mxIncludeHeader();
    //echo "<h2>"._AM_MANAGER."</h2>";
    echo $tb->show();
    mxIncludeFooter();
  }


  /**
   *  deinstallation
   *
   *  @param $step
   *  @param $act
   *  @param $mod
   *  @return $
   *
   *  @details
   */
  function deinstallation($step = 0, $act = "", $mod = "")
  {
    /* Voraussetzungen
		*  Modul/Plugin/Theme darf nicht aktiv sein
		*  ggf. Blöcke müssen deinstalliert werden/aus deaktiviert werden.
		*  Blöcke aus DB löschen
		*
		*/
    load_class("Install");
    $inst = new pmxInstall();


    if (!array_key_exists("extension", $_POST) or $_POST['extension'] == null) {
      $step = 0;
    }
    $value = "";
    $tb = load_class('AdminForm', "adminFormManagersInstall");
    $tb->title = _AM_MANAGER;
    $tb->description = _AM_INFO;

    //$tb->tb_text = _AM_INFO;
    $tb->tb_direction = 'right';
    $tb->infobutton = false;
    $tb->tb_pic_heigth = 36;
    $tb->cssform = "a305020";
    $tb->homelink = true;
    $tb->target_url = adminUrl("manager");
    $tb->acceptbutton = false;


    if ($step > 0) $tb->addToolbar("back");
    $tb->addToolbar("next");
    $tb->addToolbar("cancel");


    $tb->addFieldset("deinstall", "Deinstallation");

    /* Aufbereiten der Übergabewerte */
    switch (true) {
      case ($step == 0):
        $module = NULL;
        $file = "";
        break;

      case ($step != 0):
        $parray = $this->_checkPOST_UI();
        //if ($parray['module']==NULL ) mxRedirect(adminURL("manager"));
        $file = str_replace("//", "/", $parray['extension']);
        $file = str_replace(DS . DS, DS, $file);
        //$module=in_array($file,$selectfile)
        $module = basename(dirname(dirname(dirname($file))));
        break;
    }


    switch ($step) {      /* Schritt 1 - Auswahl der Komponente */
      case 0:
        $selectfile = array(_NONE => NULL);

        foreach ((array)glob(PMX_MODULES_DIR . DS . '*' .  DS . 'core' . DS . $this->uninstallfile, GLOB_NOSORT) as $filename) {
          $selectfile[_MODULES . " - " . basename(dirname(dirname($filename)))] = $filename;
        }

        foreach ((array)glob(PMX_PLUGIN_DIR . DS . '*' .  DS . 'core' . DS . $this->uninstallfile, GLOB_NOSORT) as $filename) {
          $selectfile[_PLUGINS . " - " . basename(dirname(dirname($filename)))] = $filename;
        }

        foreach ((array)glob(PMX_THEMES_DIR . DS . '*' .  DS . 'core' . DS . $this->uninstallfile, GLOB_NOSORT) as $filename) {
          $selectfile[_THEMES . " - " . basename(dirname(dirname($filename)))] = $filename;
        }
        $tb->add("deinstall", "optiongroup", "extension", NULL, _AM_DE_STEP1, _AM_DE_STEP1_INFO, 20, $selectfile, array("required" => "required"));

        break;

        /*  Schritt 1 - Vor erste Installation */
      case 1:


        $tb->add("deinstall", "info", _AM_DE_BACK_INFO);
        $tb->add("deinstall", "output", _AM_DE_STEP2);

        $options = NULL;

        /* Ausgabepuffer starten */

        $tb->add("deinstall", "output", "Step :" . $step);
        $tb->add("deinstall", "output", "Parray :" . print_r($parray, true));

        break;
        /* deinstallation und Ergebnis */
      case 2:
        //$tb->add("deinstall","info",_AM_DE_BACK_INFO);
        $tb->add("deinstall", "output", _AM_DE_STEP3);

        break;
        /* Abschluss der Deinstallation */
      case 3:
        //$tb->add("deinstall","info",_AM_DE_BACK_INFO);
        $tb->add("deinstall", "output", _AM_DE_STEP4);

        break;
    }

    /* restliche Felder ausgeben */

    $tb->add("deinstall", "hidden", "step", $step);
    $tb->add("deinstall", "hidden", "type", "deinstallation");
    if ($step > 0) {
      $tb->add("deinstall", "hidden", "file", $file);
      $tb->add("deinstall", "hidden", "extension", $module);
    }

    mxIncludeHeader();
    //echo "<h2>"._DEINSTALLATION."</h2>";
    echo $tb->show();
    mxIncludeFooter();
  }

  private function _checkPOST_UI()
  {
    $postarray = array("extension" => "3", "file" => "5", "type" => "installation");
    return array_merge($postarray, $_POST);
  }


  private function _checkFile_UI($file)
  {

    /* Ausgabepuffer starten */

    /* eventuelle ausgaben abfangen */
    ob_start();
    $result = true;
    switch (true) {
      case !file_exists($file):
        ///trigger_error('not found plugin-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !include($file):
        //trigger_error('not included plugin-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !$pmx_uninstall:
        //trigger_error('pmx_plugin not found in plugin-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !is_callable($pmx_uninstall):
        //trigger_error('pmx_plugin not callable in plugin-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
    }
    /* Ausgabepuffer wieder löschen */
    ob_get_clean();
    return $result;
  }

  private function _loadFile_UI($file)
  {
    /* eventuelle ausgaben abfangen */
    ob_start();
    $outcome = array();
    $result = true;
    switch (true) {
      case !file_exists($file):
        //trigger_error('not found uninstall-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !include($file):
        //trigger_error('not included uninstall-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !$pmx_uninstall:
        //trigger_error('pmx_uninstall not found in uninstall-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      case !is_callable($pmx_uninstall):
        //trigger_error('pmx_uninstall not callable in uninstall-file: ' . mx_strip_sysdirs($file), E_USER_NOTICE);
        $result = false;
        break;
      default;
        $pmx_uninstall($options, $outcome);
        break;
    }
    /* Ausgabepuffer wieder löschen */
    ob_get_clean();
    $outcome = $this->_checkUninstall($outcome);
    return $outcome;
  }

  private function _checkUninstall($data = array())
  {
    $temp = array(
      "files" => array(),      // zu löschende Dateien
      "tables" => array(),      // zu löschende Tabellen
      "dirs" => array(),      // zu löschende Pfade
      "config" => array(),      // zu löschende Konfigurationen
      "text_before" => array(),    // angezeigter Text vor der Deinstallation (HTML-Text)
      "text_after" => array(),    // angezeigter Text nach der deinstalltion (HTML-Text)
      "script_before" => array(),  // auszführendes Script vor der installation
      "script_after" => array(),  // auszuführendes Script nach der Installation

    );

    return array_merge($temp, $data);
  }

  /**
   * class::config_save()
   * Konfiguration auslesen ....
   *
   * @param array $temp
   * @return
   */
  function config_save($temp = array())
  {
  }

  /**
   * class::config_load()
   *
   * @return
   */
  function config_load()
  {


    return;
  }
}
if (!isset($mod)) $mod = "";
if (!isset($act)) $act = "";

$tmp = new manager_admin(array($act, $mod));
$tmp = null;
