<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 660 $
 * $Author: PragmaMx $
 * $Date: 2022-12-18 11:34:03 +0100 (So, 18. Dez 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

// TODO: Ajax-Konfiguration für die einzelnen Module direkt im Modul


if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
}

mxGetLangfile(dirname(__FILE__));

function modules()
{
    $img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
    $img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
    $img_edit = mxCreateImage("images/edit.gif", _EDIT, 0, 'title="' . _EDIT . '"');
    $img_home = mxCreateImage("images/inhome.gif", _PUTINHOME, 0, 'title="' . _PUTINHOME . '"');
    $img_view = mxCreateImage("images/view.gif", _SHOW, 0, 'title="' . _SHOW . '"');
    $img_admin = mxCreateImage("images/admin.gif", _ADMINISTRATION);
    $mainmod = pmxModules::getMainModuleName();

	pmxModules::checkModules();
	$dbmodlist = pmxModules::getModules();

    if (empty($dbmodlist)) {
        mxErrorScreen("no modules installed!");
    }
    ksort($dbmodlist);

    // start tabs
    $_tabs_items = array(
        array(_ACTIVEMODULES, ""),
        array(_DEFHOMEMODULE, ""),
        array(_NOACTIVEMODULES, "")
    );
    foreach ($dbmodlist as $module) {
        if (!is_array($module)) {
            // aus unerfindlichen Gründen kann $module auch leer sein.
            continue;
        }
        extract($module);
        $act = (empty($active)) ? 1 : 0;
        $change = (empty($active)) ? $img_activate : $img_deactivate;
        $custom_title = (empty($custom_title)) ? str_replace("_", " ", $title) : $custom_title;

        $main_id = (empty($main_id)) ? 'Modules' : $main_id;
        $main_id = ($main_id == "hided") ? "<span class=\"tiny\"><i>" . _COSTUMNAVIBLOCKHID . "</i></span>" : $main_id;

        switch ($view) {
            case 1:
                $who_view = _MVGROUPS2;
                break;
            case 2:
                $who_view = _MVADMIN;
                break;
            case 3:
                $who_view = _MVANON;
                break;
            case 4:
                $who_view = _MVSYSADMIN;
                break;
            default:
                $who_view = _MVALL;
        }

        $clickit2 = '';

        if (is_file(PMX_MODULES_DIR . DS . $title . '/admin/admin.php')) {
            $clickit2 = '<a href="admin.php?op=' . $title . '" target="_blank" title="' . $title . ' ' . _ADMINISTRATION . '">' . $img_admin . '</a>';
        }
        

        if ($title !== $mainmod) {
            $change = '<a href="' . adminUrl(PMX_MODULE, 'status', 'mid=' . $mid . '&amp;active=' . $act) . '">' . $change . '</a>';
            $puthome = '<a href="' . adminUrl(PMX_MODULE, 'set_home', 'mid=' . $mid) . '">' . $img_home . '</a>';
            $clickit = '<a href="modules.php?name=' . $title . '" target="_blank">' . $img_view . '</a>';

            if ($active) {
                $class_act = (empty($class_act)) ? 'class="alternate-a"' : '';
                $_tabs_items[0][1] .= '
                <tr ' . $class_act . '>
                    <td>' . $title . '</td>
                    <td>' . $custom_title . '</td>
                    <td>' . $main_id . '</td>
                    <td>' . $who_view . '</td>
                    <td nowrap><a href="' . adminUrl(PMX_MODULE, 'edit', 'mid=' . $mid) . '">' . $img_edit . '</a> &nbsp;' . $change . ' ' . $puthome . ' ' . $clickit . ' ' . $clickit2 . '</td>
                </tr>';
            } else {
                $class_deact = (empty($class_deact)) ? 'class="alternate-a"' : '';
                $_tabs_items[2][1] .= '
                <tr ' . $class_deact . '>
                    <td>' . $title . '</td>
                    <td>' . $custom_title . '</td>
                    <td>' . $main_id . '</td>
                    <td>' . $who_view . '</td>
                    <td nowrap><a href="' . adminUrl(PMX_MODULE, 'edit', 'mid=' . $mid) . '">' . $img_edit . '</a> &nbsp;' . $change . ' ' . $puthome . ' ' . $clickit . ' ' . $clickit2 . '</td>
                </tr>';
            }
        } else {
            $clickit = '<a href="index.php" target="_blank">' . $img_view . '</a>';
            $_tabs_items[1][1] .= '
            <tr>
                <td>' . $title . '</td>
                <td><b>' . _HOME . '</b></td>
                <td>' . $main_id . '</td>
                <td>' . _MVALL . '</td>
                <td nowrap><a href="' . adminUrl(PMX_MODULE, 'edit', 'mid=' . $mid) . '">' . $img_edit . '</a> &nbsp;' . $clickit . ' ' . $clickit2 . '</td>
            </tr>';
        }
    }
    unset($dbmodlist);
    $headline = '<tr>
        <th>' . _TITLE . '</th>
        <th>' . _CUSTOMTITLE . '</th>
        <th>' . _MODULESBLOCKS . '</th>
        <th>' . _VIEW . '</th>
        <th>' . _FUNCTIONS . '</th>
    </tr>';

    // create tabs
    $_empty = array();
    foreach ($_tabs_items as $key => $value) {
        if (strlen($value[1]) === 0) {
            $_empty[] = $key;
        } else {
            switch($key) {
                // active
                case 0:
                    $_note = '<p class="note align-left">' . _MODULESACTIVATION . '</p>';
                    break;
                // home
                case 1:
                    $_note = '<p class="note align-left">' . _MODULEHOMENOTE . '</p>';
                    break;
                // deactive
                default:
                    $_note = '';
                    break;
            }
            $_tabs_items[$key][1] = '<h3>' . $value[0] . '</h3><table class="full list">' . $headline . $value[1] . '</table>' . $_note;
        }
    }
 
    mxIncludeHeader();
    GraphicAdmin();
    title(_MODULESADMIN);
    if (isset($doublerror)) {
        OpenTableAl();
        echo '<center>' . implode("\n", $doublerror) . '<br /><b>' . _ADMIN_WARNDOUBLEMOD3 . '</b></center>';
        CloseTableAl();
        echo '<br>';
    }
    echo pmxDom::addTabs(["items" => $_tabs_items, "cookie" => "tab_modadmin"], ["disabled" => $_empty]);
    mxIncludeFooter();
}

/**
 */
function set_home($gvs)
{
    $ok = (empty($gvs['ok'])) ? 0 : 1;
    $mid = (int)$gvs['mid'];
    $old_m = pmxModules::getMainModuleName();
	$new_m = pmxModules::getModuleNameFromMid($mid);

    if (empty($ok)) {
        mxIncludeHeader();
        GraphicAdmin();
        title(_HOMEMODULE);
        OpenTable2();
        echo '
        <p class="align-center">
          <b>' . _DEFHOMEMODULE . '</b><br /><br />
          ' . _SURETOCHANGEMOD . ' <b>' . $old_m . '</b> ' . _TO . ' <b>' . $new_m . '</b>?<br /><br />
          [&nbsp;<a href="' . adminUrl(PMX_MODULE) . '">' . _NO . '</a> | <a href="' . adminUrl(PMX_MODULE, 'set_home', 'mid=' . $mid . '&amp;ok=1') . '">' . _YES . '</a>&nbsp;]
        </p>';
        CloseTable2();
        mxIncludeFooter();
    } else {
		pmxModules::setMainModuleName($new_m);
        mxRedirect(adminUrl(PMX_MODULE));
    }
}

function module_status($mid, $active)
{
	pmxModules::setModuleStatus($mid, $active);
	mxRedirect(adminUrl(PMX_MODULE));
}

function module_edit($mid)
{
    $mid = (int)$mid;
    $main_module = mxGetMainModuleName();
	$modul=pmxModules::getModuleFromMid($mid);
	extract($modul);
	
	$custom_title = (empty($custom_title)) ? str_replace('_', ' ', $title) : $custom_title;
    mxIncludeHeader();
   // GraphicAdmin();
    title(_MODULEEDIT);
    OpenTable();
    echo "<fieldset><legend>" . _CHANGEMODNAME . ": " . $title . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE, 'edit_save') . "\" method=\"post\">"
     . "<table style=\"margin:auto\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
     . "<tr valign=\"top\"><td>" . _CUSTOMMODNAME . "</td>";
    if ($title == $main_module) {
        echo "<td><b>" . _HOME . "</b><input type=\"hidden\" name=\"custom_title\" value=\"" . mxEntityQuotes($custom_title) . "\" /></td></tr>";
    } else {
        echo "<td><input type=\"text\" name=\"custom_title\" value=\"" . mxEntityQuotes($custom_title) . "\" size=\"50\" /></td></tr>";
    }
    echo "<tr valign=\"top\"><td>" . _VIEWPRIV . "</td><td>";
    if ($title == $main_module) {
        echo "<b>" . _MVALL . "</b> (" . _DEFHOMEMODULE . ")"
         . "<input type=\"hidden\" name=\"view\" value=\"0\" />"
         . "<input type=\"hidden\" name=\"active\" value=\"1\" />";
        // ."<input type=\"hidden\" name=\"main_id\" value=\"\" />";
    } else {
        echo getViewSelect($view)
         . "</td></tr>"
         . "<tr valign='top'><td><!-- " . _VIEWPRIV . " --></td><td>" . getGroupSelect($mid) . "</td></tr>"
         . "<tr valign=\"top\"><td>" . _ACTIVE . "</td>"
         . "<td>" . getActiveSelect($active) . "</td></tr>"
         . "<tr valign=\"top\"><td>&nbsp;</td>"
         . "<td><input type=\"checkbox\" name=\"putinhome\" value=\"1\" />&nbsp; " . _PUTINHOME . "</td></tr>";
    }
    echo "<tr valign=\"top\"><td>" . _COSTUMNAVIBLOCK . "</td>"
     . "<td>" . getModuleBlockSelect($main_id) . "</td></tr>";
    echo "</table><br /><br />"
     . "<input type=\"hidden\" name=\"mid\" value=\"" . $mid . "\" />"
     . "<input type=\"hidden\" name=\"title\" value=\"" . $title . "\" />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/edit_save\" />"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" />"
     . "</form></fieldset>"
     . "<br /><br /><center>" . _GOBACK . "</center>";
    CloseTable();
    mxIncludeFooter();
}

/**
 */
function module_edit_save($pvs)
{
    global $prefix;

    $userconfig = load_class('Userconfig');

    $pvs['mid'] = (int)$pvs['mid'];
    $pvs['putinhome'] = (empty($pvs['putinhome'])) ? 0 : 1;
    $pvs['active'] = ($pvs['putinhome']) ? 1 : (int)$pvs['active'];
    $pvs['view'] = ($pvs['putinhome']) ? 0 : (int)$pvs['view'];
    $pvs['custom_title'] = strip_tags($pvs['custom_title']);
    $pvs['custom_title'] = (empty($pvs['custom_title'])) ? str_replace("_", " ", $pvs['title']) : $pvs['custom_title'];
    $pvs['main_id'] = ($pvs['putinhome']) ? "" : $pvs['main_id'];
    $pvs['main_id'] = ($pvs['main_id'] == "Modules") ? "" : $pvs['main_id'];

	$result = pmxModules::update($pvs);
	
    if ($result) {
        // Gruppen aktualisieren
        pmxDatabase::system_query("DELETE FROM {$prefix}_groups_modules WHERE module_id=" . $pvs['mid']);
        if ($pvs['view'] == 1 && !$pvs['putinhome']) {
            // Sicherstellen, dass wirklich eine Gruppe selektiert wurde
            if (empty($pvs['groups'])) {
                // keine Gruppe gewaehlt > Standard eintragen
                $pvs['groups'] = array(intval($userconfig->default_group));
            } else if (!is_array($pvs['groups'])) {
                // die Gruppe nicht als Array, sonder ID uebergeben > diese ID als Arraywert deklarieren
                $pvs['groups'] = array(intval($pvs['groups']));
            }
            // immernoch keine Gruppe gewaehlt > Standard eintragen
            if (empty($pvs['groups'][0])) {
                $pvs['groups'] = array(intval($userconfig->default_group));
            }

            foreach ($pvs['groups'] as $groupid) {
                pmxDatabase::system_query("INSERT INTO {$prefix}_groups_modules (group_id, module_id) VALUES (" . $groupid . ", " . $pvs['mid'] . ")");
            }
        }
        if ($pvs['putinhome']) {
			pmxModules::setMainModuleName($pvs['title']);
        }
    }
    mxRedirect(adminUrl(PMX_MODULE), _ADMIN_SETTINGSAVED);
}

/**
 */
function getActiveSelect($active = 1)
{
    $active = (int)$active;
    $out = "<input type=\"radio\" name=\"active\" value=\"1\"" . (($active === 1) ? ' checked' : "") . " />" . _YES . " &nbsp;&nbsp;";
    $out .= "<input type=\"radio\" name=\"active\" value=\"0\"" . (($active === 0) ? ' checked' : "") . " />" . _NO . "\n";
    return $out;
}

/**
 */
function getViewSelect($view = 0)
{
    $view = (int)$view;
    $out = '<select name="view">'
     . '<option value="0"' . (($view == 0) ? ' class="current" selected' : '') . '>' . _MVALL . '</option>'
     . '<option value="1"' . (($view == 1) ? ' class="current" selected' : '') . '>' . _MVGROUPS . '</option>'
     . '<option value="2"' . (($view == 2) ? ' class="current" selected' : '') . '>' . _MVADMIN . '</option>'
     . '<option value="4"' . (($view == 4) ? ' class="current" selected' : '') . '>' . _MVSYSADMIN . '</option>'
     . '<option value="3"' . (($view == 3) ? ' class="current" selected' : '') . '>' . _MVANON . '</option>'
     . '</select>';
    return $out;
}

/**
 */
function getGroupSelect($modid = 0)
{
    global $prefix;

    $userconfig = load_class('Userconfig');

    if (!empty($modid)) {
        $qry = "SELECT group_id FROM {$prefix}_groups_modules WHERE module_id=" . intval($modid);
        $result = sql_query($qry);
        while (list($group_id) = sql_fetch_row($result)) {
            $groups[] = $group_id;
        }
    }
    $groups = (empty($groups)) ? $userconfig->default_group : $groups;
    $groupoptions = getAllAccessLevelSelectOptions($groups);
    $cnt = substr_count($groupoptions, '<option') + 1;
    $out = '<select name="groups[]" id="groups" size="' . $cnt . '" multiple>' . $groupoptions . '</select>';
    return $out;
}

/**
 */
function getModuleBlockSelect($main_id = '')
{
    global $prefix;
    $main_id = (empty($main_id)) ? "Modules" : $main_id;
    $result = sql_query("SELECT bid, title, blockfile FROM {$prefix}_blocks WHERE blockfile LIKE 'block-modules%.php'");
    while (list($bid, $btitle, $bfs) = sql_fetch_row($result)) {
        $dbblocks[$bfs] = $btitle;
    }
    $blocksdir = dir("blocks");
    while ($block = $blocksdir->read()) {
        if (strtolower(substr($block, 0, 13)) == "block-modules") {
            $mode = (isset($dbblocks[$block])) ? 1 : 0;
            $is = ($mode) ? " (" . $dbblocks[$block] . ")": "  *";
            $bl = str_replace("block-", "", $block);
            $bl = str_replace(".php", "", $bl);
            $sel = ($main_id == $bl) ? 'class="current" selected' : "";
            $options[$mode][strtolower($bl)] = "<option value=\"" . $bl . "\" " . $sel . ">" . $bl . $is . "</option>";
        }
    }
    closedir($blocksdir->handle);
    // if (empty($main_id)) $options[] = "<option value=\"\" selected></option>";
    $view = "";
    $sel = ($main_id == "hided") ? 'class="current" selected' : "";
    $options[1]["aaaaaa"] = "<option value=\"hided\" " . $sel . ">" . _COSTUMNAVIBLOCKHID . "</option>";
    if (isset($options[1])) {
        ksort($options[1]);
        $view .= implode("\n", $options[1]);
    }
    if (isset($options[0])) {
        ksort($options[0]);
        $view .= implode("\n", $options[0]);
    }
    $out = "\n<select name=\"main_id\">\n" . $view . "</select>\n";
    $out .= " <br />\n<span class=\"important tiny\">" . _COSTUMNAVIEXAMPLE . "</span>\n";
    return $out;
}

switch ($op) {
    case PMX_MODULE . '/status':
        module_status($mid, $active);
        break;

    case PMX_MODULE . '/edit':
        module_edit($mid);
        break;

    case PMX_MODULE . '/edit_save':
        module_edit_save($_POST);
        break;

    case PMX_MODULE . '/set_home':
        set_home($_GET);
        break;

    default:
        modules();
        break;
}

?>
