<?php
/**
 * This file is part of
 *
 * System
 *
 * for pragmamx (www.pragmamx.org)
 *
 * $Revision: 507 $
 * $Author: PragmaMx $
 * $Date: 2022-05-20 12:47:48 +0200 (Fr, 20. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

include_once("includes/functions.php");

/**
 * plugins_admin
 *
 * @package
 * @author Olaf Herfurth

 * $Revision: 507 $
 * @copyright Copyright (c) 2014

 * @version $Id: index.php 507 2022-05-20 10:47:48Z PragmaMx $

 * @access public
 */
class plugins_admin {
    private $errors = array();
    private $form = null;
    private $homepage = '';
    private static $__set = array(); // Konfiguration
    static $kf = null;
    private $_plugins = array();

    private static $_config = null;

    /**
     * class::__construct()
     *
     * @param string $parameter
     */
    function __construct ($parameter = array())
    {
        global $prefix;
		list($this->act,$this->plugin,$this->mod)=$parameter;
        mxGetLangfile(__DIR__);
		
        $this->modulname = PMX_MODULE;
        self::$kf= new plugins_functions();
        $this->config = $this->config_load();
        $this->main($this->act,$this->plugin, $this->mod);
    }

    /**
     * class::__get()
     *
     * @param mixed $value_name
     * @return
     */
    public function __get($value_name)
    {
        if (isset(self::$__set[$value_name])) {
            return self::$__set[$value_name];
        }
        return false;
    }

    /**
     * class::__set()
     *
     * @param mixed $name
     * @param mixed $val
     * @return
     */
    public function __set($name, $val)
    {
        self::$__set[$name] = $val;
    }

    /**
     * class::main()
     *
     * @param string $action
     * @return
     */
    function main ($act, $plugin,$mod)
    {
        //mxDebugFuncVars($plugin,$act,$mod);
        $plg = load_class('Plugin');
        $cache = load_class('Cache');
		switch ($act) 
		{
			case "activate":
				/* Plugin aktivieren */
                
				$plugina=$plg->get_PluginFromId($_GET['id']);
                $plg->setPluginActive($plugina);
				unset($plugina);
                $cache->delete("Plugin");
			break;
			case "deactivate":
				/* Plugin deaktivieren */
                
				$plugina=$plg->get_PluginFromId($_GET['id']);
                $plg->setPluginInActive($plugina);	
                unset($plugina);
                $cache->delete("Plugin");
			break;			
            case "admin":			
				$plugina=$plg->get_PluginFromId($_GET['id']);
				if ($plugina['admin_menu']==1) mxRedirect(adminUrl($plugina['plugin_name'])) ;				
				$this->plugin_admin ($plugin, $act,$mod,$_GET['id']);
			break;	
		}

        $info2 = _PLUGIN;
        $tb = load_class('AdminForm', "adminFormPlugins");

        switch (pmxAdminForm::CheckButton()) {
            case "save":
                foreach($_POST['subposition'] as $id=>$value){
                    $plg->updatePluginPosition($id,$value);
                }
                break;
        }
        
        /* alle Plugins komplett einlesen, neue ermitteln und in DB eintragen */
        //$plg->get_plugins();
        
        $vplugselect="nothing";
        
        
        
        if (array_key_exists('plugfilter',$_POST)) {
			$vplugselect=$_POST['plugfilter'];
			mxSessionSetVar("plugfilter",$vplugselect);
		} else {
			$vplugselect=mxSessionGetVar("plugfilter");
		}
        if (!$vplugselect)$vplugselect="nothing";
        
        $this->config = $this->config_load();
        
        
        $tb->tb_text = $info2;
        $tb->tb_direction = 'right';
        $tb->infobutton = false;
        $tb->tb_pic_heigth = 25;
        $tb->cssclass = "toolbar1";
        $tb->homelink = true;
        $tb->target_url = "admin.php?op=plugins";
        
        /* aktuelle Daten holen */

        $all=$plg->get_plugins();
        $vFilter= ($vplugselect=="nothing")?"nothing":$vplugselect;
        $dbplugins = $plg->get_all_plugins_from_db();//$vFilter
		
        mxSessionSetVar("plugfilter",$vFilter);
        
        /* Filter anzeigen */
        $dbtypes = $plg->get_types();
        $plugfilter =array(_NONE=>"nothing");
        foreach ($dbtypes as $key=>$value){
            $plugfilter[$value]=$value;     
        }

        if ($vplugselect && !array_key_exists($vplugselect, $plugfilter)) {
            $vplugselect = "nothing";
        }
		
        //mxDebugFuncVars($vplugselect,$plugfilter);
        $attributes=array("onchange"=>"this.form.submit()");
        $tb->add("","select","plugfilter",$vplugselect,_PLUGIN_FILTER,_PLUGIN_INFO,1,$plugfilter,$attributes);
 
		/* Bilder definieren */

		$img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
		$img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
		$img_edit = mxCreateImage("images/edit.gif", _EDIT, 0, 'title="' . _EDIT . '"');
		
		$img_view = mxCreateImage("images/view.gif", _SHOW, 0, 'title="' . _SHOW . '"');
		$img_admin = mxCreateImage("images/admin.gif", _ADMINISTRATION); 
		
	
        /* Tabellenspalten vorbereiten */
        
        $fieldname=array(
            array("name"=>mxText('_PLUGIN')),
            array("name"=>mxText('_DESCRIPTION'),"attr"=>"style='min-width:350px'"),
            array("name"=>mxText("_PLUGIN_TYPE")),
            array("name"=>''._PLUGIN_POSITION.'&nbsp;<button type="submit" value="save" name="toolbarsubmit" onclick="javascript:hideMainMenu();" title="'._PLUGIN_POSITION.'"> <img src="'.$tb->get_action_pic('save').'" title="'._PLUGIN_POSITION.'" alt="'._PLUGIN_POSITION.'" style="width:16px" /></button>',"attr"=>"style='width:160px'"),
            array("name"=>mxText("_FUNCTIONS"),"attr"=>"style='width:80px'"),
            
            );
     	 
        /* Tabellinhalte aufbereiten */
        $values=array();
        foreach ($dbplugins as $ptype => $parray) {
            
            foreach ($parray as $key=>$value){
				//mxDebugFuncVars($vplugselect,$value);
				if ($vplugselect!="nothing" and $value['type']!=$vplugselect) continue 1;
				
                unset($value['settings']);
                /* aktivieren */
                $action_set=
                    '<a href="admin.php?op=plugins&amp;act='.(($value['active']==0)?"activate":"deactivate").'&amp;id='.$value['id'].'" title="">'.
					(($value['active']==1)?$img_deactivate:$img_activate).'</a>&nbsp;';
                 //mxDebugFuncVars($value);   
                /* Adminlink noch einfügen, wenn vorhanden */
				switch (true)
				{
					case (!file_exists(PMX_PLUGIN_PATH .  $value['plugin_name'] . DS . 'admin' . DS .'admin.php')):
						break;
					case ($value['admin_menu']==1):
						$action_set .='<a href="'.adminUrl($value['plugin_name']).'" title="'._ADMINISTRATION.'">'.$img_admin.'</a>&nbsp;';
						break;
					default:
		                 $action_set .='<a href="admin.php?op=plugins&amp;act=admin&amp;plugin='.$value['plugin_name'].'&amp;id='.$value['id'].'" title="'._ADMINISTRATION.'">'.$img_admin.'</a>&nbsp;';
			
				}
					
                /* zusammensetzen */
                $values[$key]=array(
                    $value['plugin_name'],
                    $value['description'],
                    $value['type'],
                    "<input type='number' name='subposition[".$value['id']."]' value='".$value['position']."' maxlength='3' size='3' min='-1' max='999' step='1'/>",
                    $action_set,
                );
            }
        }    
        //mxDebugFuncVars($values);
        
        
        $tb->add("","table",$fieldname,$values);

        mxIncludeHeader();
        echo "<h2>"._PLUGINS."</h2>";
        echo $tb->show();
        mxIncludeFooter();
    }

	function plugin_admin ($plugin, $act,$mod,$id) {
	
		if (!file_exists(PMX_PLUGIN_PATH .  $plugin . DS . 'admin' . DS .'admin.php')) return;
		
		mxIncludeHeader();
		
		include(PMX_PLUGIN_PATH .  $plugin . DS . 'admin' . DS .'admin.php');
		mxIncludeFooter();
		exit;
	}
	
    /**
     * class::config_save()
     * Konfiguration auslesen ....
     *
     * @param array $temp
     * @return
     */
    function config_save ($temp = array())
    {
        self::$kf->config_save($temp);
    }

    /**
     * class::config_load()
     *
     * @return
     */
    function config_load ()
    {
        $temp = self::$kf->config_load();

        return $temp;
    }

}
if (!isset($mod)) $mod = "";
if (!isset($act)) $act = "";
if (!isset($plugin)) $plugin = "";
$tmp = new plugins_admin(array($act,$plugin, $mod));
$tmp = null;

?>
