<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 135 $
 * $Author: PragmaMx $
 * $Date: 2021-05-25 18:15:57 +0200 (Di, 25. Mai 2021) $
 */

defined('mxMainFileLoaded') or die('access denied');
global $prefix, $blockid;
/* der passende Modulname */



class adminBlock {

	private $_config=array();
	private $_block=array();
	private $_settings=array();
	
	function __construct ($bid) 
	{
		global $bid;
		$this->_config['bid']=$bid;
		$this->_setlanguage();
		$this->_block=mxGetBlock($bid);
		$this->main();
	}

	function main ()
	{
		
		$module_name=basename(dirname(dirname(__FILE__)));
		
		$tb=load_class("AdminForm","adminblock");   
		
		$msg=FALSE;
		$redirect=false;
		switch(pmxAdminform::CheckButton())
		{
			case "save":
				$redirect=true;
			case "accept":
				$config=$_POST['config'];
				//$this->_SetBlockConfig($this->_config['bid'],$config);
				mxSetBlockConfig($this->_config['bid'],$config);
				if ($redirect) mxRedirect(adminUrl("blocks"));
				
				$msg=mxText("_CHANGESAREOK");

				break;

			case "back":
				mxRedirect(adminUrl("blocks"));
				break;
			default:

				break;  
		}

		$this->_block = mxGetBlock($this->_config['bid']);
		$this->_settings = $this->_SetDefault($this->_block['config']);

		pmxHeader::add_jquery();
		pmxHeader::add_script_code("
			$(document).ready(function () {
            		$('#a5546425').css('display', 'block');
            		$('#a5546425').fadeOut(6000);
			});
			"	
		);		
		
		$tb->__set("tb_direction", 'right');
		$tb->__set("infobutton", false);
		$tb->__set("tb_pic_heigth", 25);
		$tb->__set("csstoolbar", "toolbar1");
		$tb->__set("cssform", "a403030");
		$tb->__set('buttontext', false);
		$tb->__set('homelink', false);
		$tb->__set('fieldhomebutton', true);
		$tb->__set('title', mxText("_BLOCK") ." - ". mxText("_SETTINGS")."" );
		$tb->__set('acceptbutton', true);
		
		$tb->addToolbar("save");	
		$tb->addToolbar("accept");	
		
		$tb->addToolbarLink("back","admin.php?op=blocks");

		$config = $this->_settings;

		if ($msg) $tb->add("","output","<div id='a5546425' class='info'>".$msg."</div>");
		
		$tb->addFieldset("blocks",mxText("_BLOCK") . ":  ". $this->_block['title'] . " (".str_replace(".php","",$this->_block['blockfile']).")");
		$tb->add("blocks","output",mxText("_QRC_INFO1"));
				
		$tb->add("blocks","input","config[qrctitle]",$config['qrctitle'],mxText("_BLOCKTITLE"),"",30);
		$tb->add("blocks","select","config[qrcselect]",$config['qrcselect'],mxText("_QRC_SELECT"),"",4, 
				array(	"Home-URL"=>0,
						"Site-URL"=>1,
						mxText("_QRC_TEXT")=>2,));
			
		
		$tb->add("blocks","input","config[qrcurl]",$config['qrcurl'],mxText("_QRC_TEXT2"),"",30);
		
		$tb->add("blocks","range","config[qrcsize]",$config['qrcsize'],mxText("_QRC_SIZE"),"",6,array("min"=>"10","max"=>"500","step"=>1));
		$tb->add("blocks","color","config[qrccolor]",$config['qrccolor'],mxText("_QRC_FRONTCOLOR"),"",6);
		$tb->add("blocks","color","config[qrcbgcolor]",$config['qrcbgcolor'],mxText("_QRC_BACKCOLOR"),"",6);
		$tb->add("blocks","select","config[qrcecc]",$config['qrcecc'],mxText("_QRC_CECC"),"",4, array("High"=>"H","Quality"=>"Q","Middle"=>"M","Low(".mxText("_QRC_RECOMMENDED").")"=>"L"));
		$tb->add("blocks","range","config[qrcqzone]",$config['qrcqzone'],mxText("_QRC_QZONE"),"",6,array("min"=>"0","max"=>"10","step"=>1));
		$tb->add("blocks","range","config[qrcmargin]",$config['qrcmargin'],mxText("_QRC_MARGIN"),"",6,array("min"=>"0","max"=>"50","step"=>1));
		
		
		
	  	/* formular abrufen */
		$form = $tb->Show();
		
		
		/* zusatzinfos abrufen */


		echo $form;
		
		/* Blockvorschau */
		
		$block = mxGetBlockData($this->_block, true);
		//mxDebugFuncVars($this->_block);
		echo '<p>'. _BLOCKPREVIEW .'&nbsp;&nbsp;<b>'. $this->_block['title'] .'&nbsp;('. $this->_block['blockfile'] .')&nbsp;</b>:</p><br /><div class="box">';
		render_blocks($block,true) ;
		echo '	</div><br />';
	}


	private function _SetDefault($config)
	{
		$default = array(
			"qrctitle"=>"",
			"qrcurl"=>PMX_HOME_URL,
			"qrcsize"=>100,	
			"qrccolor"=>"000",
			"qrcbgcolor"=>"FFF",
			"qrcecc"=>"L",			
			"qrcqzone"=>"1",  // in Blocks	
			"qrcmargin"=>"5", // in px
			"qrcselect"=>0,
			);
			
$config=array_merge($default,$config);
		return $config;
	}

	private function _setlanguage()
	{
		// use mxAddLangArray(array $langarray)
		$lang=pmxBase::get("currentlang");
		$langarray=array();
		switch ($lang)
		{
			case "german":
			case "german_du":
				$langarray=array(
				"_QRC_INFO1"=>"Dieser Block erzeugt einen QR-Code aus dem einzugebenden Text oder der URL. dieser Service wird kostenlos von goqr.me bereitgestellt. ",
				"_QRC_INFO2"=>"",
				"_QRC_TITLE"=>"Blocktitel",
				"_QRC_SELECT"=>"Auswahl Blockinhalt",
				"_QRC_TEXT"=>"Eingabetext",
				"_QRC_TEXT2"=>"Eingabetext (siehe vorherige Auswahl)",
				"_QRC_SIZE"=>"Breite in [px]",
				"_QRC_BACKCOLOR"=>"Hintergrundfarbe",
				"_QRC_FRONTCOLOR"=>"Farbe QR-Code",
				"_QRC_QZONE"=>"Größe der QR-Code Umrandung in [blocks]",
				"_QRC_CECC"=>"Qualität",
				"_QRC_MARGIN"=>"Rand um den QR-Code in [px]",
				"_QRC_RECOMMENDED"=>"empfohlen",
				);
			break;
			case "danish":
				$langarray=array(
				"_QRC_INFO1"=>"Denne blok genererer en QR-kode ud fra den tekst eller URL, der skal indtastes. Denne service er gratis og leveres af goqr.me. ",
				"_QRC_INFO2"=>"",
				"_QRC_TITLE"=>"Bloktitel",
				"_QRC_SELECT"=>"Valg af blokindhold",
				"_QRC_TEXT"=>"Bloker indhold ",
				"_QRC_TEXT2"=>"Blokindhold (se forrige valg)",
				"_QRC_SIZE"=>"størrelse i [px]",
				"_QRC_BACKCOLOR"=>"farve på bagsiden",
				"_QRC_FRONTCOLOR"=>"Farve på QR-kode",
				"_QRC_QZONE"=>"Størrelse på QR-kodens kant i [blokke].",
				"_QRC_CECC"=>"Kvalitet",
				"_QRC_MARGIN"=>"Kant omkring QR-koden i [px].",
				"_QRC_RECOMMENDED"=>"anbefalet",
				);						
			break;
			case "french":
				$langarray=array(
				"_QRC_INFO1"=>"Ce bloc génère un code QR à partir du texte ou de l'URL à saisir. Ce service est fourni gratuitement par goqr.me. ",
				"_QRC_INFO2"=>"",
				"_QRC_TITLE"=>"Titre du bloc",
				"_QRC_SELECT"=>"Sélection du contenu du bloc",
				"_QRC_TEXT"=>"Contenu du bloc",
				"_QRC_TEXT2"=>"Contenu du bloc (voir sélection précédente)",
				"_QRC_SIZE"=>"taille en [px]",
				"_QRC_BACKCOLOR"=>"couleur du dos",
				"_QRC_FRONTCOLOR"=>"couleur du QR-Code",
				"_QRC_QZONE"=>"Taille de la bordure du code QR en [blocs]",
				"_QRC_CECC"=>"Qualité",
				"_QRC_MARGIN"=>"Bordure autour du code QR en [px]",
				"_QRC_RECOMMENDED"=>"recommandé",
				);			
			break;
			case "turkish":
				$langarray=array(
				"_QRC_INFO1"=>"Bu blok, girilecek metin veya URL'den bir QR kodu oluşturur. Bu hizmet goqr.me tarafından ücretsiz olarak sağlanmaktadır. ",
				"_QRC_INFO2"=>"",
				"_QRC_TITLE"=>"Blok Başlığı",
				"_QRC_SELECT"=>"Blok içeriği seçimi",
				"_QRC_TEXT"=>"Blok içeriği ",
				"_QRC_TEXT2"=>"Blok içeriği (önceki seçime bakın)",
				"_QRC_SIZE"=>"piksel cinsinden boyut",
				"_QRC_BACKCOLOR"=>"arka renk",
				"_QRC_FRONTCOLOR"=>"QR-Kodunun Rengi",
				"_QRC_QZONE"=>"QR kodu kenarlığının blok cinsinden boyutu",
				"_QRC_CECC"=>"Kalite",
				"_QRC_MARGIN"=>"Piksel cinsinden QR kodunun etrafındaki kenarlık",
				"_QRC_RECOMMENDED"=>"tavsiye edilir",
				);			
			break;
			case "english":
				$langarray=array(
				"_QRC_INFO1"=>"This block generates a QR code from the text or URL to be entered. This service is provided free of charge by goqr.me. ",
				"_QRC_INFO2"=>"",
				"_QRC_TITLE"=>"Blocktitle",
				"_QRC_SELECT"=>"Selection of block content",
				"_QRC_TEXT"=>"Block content ",
				"_QRC_TEXT2"=>"Block content (see previous selection)",
				"_QRC_SIZE"=>"size in [px]",
				"_QRC_BACKCOLOR"=>"back color",
				"_QRC_FRONTCOLOR"=>"Color of QR-Code",
				"_QRC_QZONE"=>"Size of the QR code border in [blocks]",
				"_QRC_CECC"=>"Quality",
				"_QRC_MARGIN"=>"Border around the QR code in [px]",
				"_QRC_RECOMMENDED"=>"recommended",
				);			
			default:
			
		}
		mxAddLangArray($langarray);
		unset ($langarray);
	}

}
global $bid,$blockfile;

//mxDebugFuncVars($bid,$blockfile,$op);

$op=(!isset($op))?"":$op;
$bid=(!isset($bid))?NULL:$bid;
$tmp = new adminBlock($bid);
unset ($tmp);




?>