/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/**
 * @autor Sven Hedstroem-Lang <svenhlang@gmail.com
 * @copyright 2022-04
 * @since pragmaMx 2.8.1
 * @require jQuery, jQueryUI
 * @require for pmxDom()
 */

/**
 * @param {Object} ele - The element like $("#' . $config["uniqId"] . '")
 * @param {String} url 
 * @param {Array} ready
 * * @param {Int} ready[0] - The prozent when will show ready[1] 
 * * @param {String} ready[1] - The test when ready[0] is over
 * @param {Int} seconds 
 */
function addDomProgressbar(ele, url, ready, seconds) {
    ele.progressbar({
        value: false,
        change: function() {
            $(".progress-label").text(ele.progressbar("value") + "%");
             if (ele.progressbar("value") >= ready[0]) {
                $("#progress-ready").text(ready[1]);
            }
        },
        complete: function() {
            if (url !== "") {
                window.location = url;
            }
        }
    });
    function progress() {
        let val = ele.progressbar("value") || 0;
        ele.progressbar("value", val + Math.floor(Math.random() * 2) + 2);
        setTimeout(progress, seconds * 10);
    }
    progress();
}