<?php

/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 718 $
 * $Author: Nouvelle $
 * $Date: 2023-10-31 20:07:51 +0100 (Di, 31 Okt 2023) $
 */

defined('mxMainFileLoaded') or die('access denied');



/* Deprecated */


/**
 * pmx_get_hook()
 *
 * @deprecated
 *
 * @param mixed $hook_name
 * @return array or false
 */
function pmx_get_hook($hook_name)
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '(), use class "pmxHook" instead.', E_USER_NOTICE);
  return load_class('Hook', $hook_name)->get_files();
}

/**
 * pmx_run_hook()
 *
 * @deprecated
 *
 * @param string $hook_name
 * @param mixed $hook_parameters
 * @param mixed $hook_result
 * @return bolean
 */
function pmx_run_hook($hook_name, &$hook_parameters = null, &$hook_result = null)
{
  $hook = load_class('Hook', $hook_name);

  if ($hook_parameters) {
    if (is_numeric($hook_parameters) && (strpos($hook_name, 'user.') === 0)) {
      /* TODO: dieser Sonderfall ist noch dringeblieben, weil viele Aufrufe
           * von user-hooks z.B. user.edit eine direkte $uid übergeben.
           * ->> das muss alles noch umgeschrieben werden
           */
      $hook_parameters = array('uid' => $hook_parameters);
    } else {
      trigger_error('Use of deprecated function ' . __FUNCTION__ . '(), use class "pmxHook" instead.', E_USER_NOTICE);
    }
    $hook->set((array)$hook_parameters);
  }
  // mxDebugFuncVars($hook_name, $hook_parameters, $hook_result);#exit;
  if ($hook_result) {
    $hook->run($hook_result);
  } else {
    $hook_result = $hook->run();
  }

  return true;
}

/**
 * @deprecated
 * @return void
 */
function includeHeader()
{
  /* jetzt in mx_api.php eingebaut */
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '(), use function "mxIncludeHeader()" instead.', E_USER_NOTICE);
  mxIncludeHeader();
}



/**
 * Setzt oder löscht die alten Cookies von phpNuke
 * wenn in config.php entsprechend eingestellt
 * Dies kann für bestimmte phpNuke-Module nötig sein
 *
 * @param string $CookieName Name für den zu erstellenden Cookie
 * @uses mxSetCookie()
 * @param string $CookieValue Wert für den Cookie
 * @param string $inout Gültigkeitsdauer des Cookie's
 * Wenn $inout nicht gesetzt ist, wird der Cookie sofort gelöscht
 * Wenn $inout == 1 wird die Lebensdauer des Cookie auf die Session-Dauer gesetzt.
 *
 * @deprecated
 */
function mxSetNukeCookie($CookieName, $CookieValue = "", $inout = 0)
{
  trigger_error('Use of deprecated phpnuke-function ' . __FUNCTION__ . '()', E_USER_WARNING);
  if (empty($GLOBALS['mxCreateNukeCookie'])) return;
  $inout = (empty($CookieValue)) ? 0 : $inout;
  $CookieTime = ($inout == 1) ? 1 : -1;
  mxSetCookie($CookieName, $CookieValue, $CookieTime);
}



/**
 * mxDemoMode()
 *
 * @deprecated Funktion wird seit pragmaMx 2.0 nicht mehr verwendet.
 * @return
 */
function mxDemoMode()
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);
  return false;
}


/**
 * Prüft ob der User Fotos bzw. Avatare hochgeladen hat.
 * Aufrufbeispiele:
 * $foo = mxIsAvatarUploaded($bar);->false oder den aktuellen Avatar des Users als String
 * $foo = mxIsAvatarUploaded($bar, true);->false oder den aktuellen Avatar des Users als mxCreateImage.
 * $foo = mxIsAvatarUploaded($bar,false,true);->false oder $row als Array mit Zugriff auf alle
 * Spalten (z.B $foo['werist'])
 *
 * @param string $username Username von dem User desses Avatar gesucht wird
 * @param bool $imagereturn Wenn imareturn==true wird der komplette HTML-Tag zum Anzeigen des
 * Avatars zurückgegeben, ansonsten nur der Avatar Dateiname, optional, default value false
 * @param bool $new Wenn $new==true wird ein Array mit den gesamten Daten zum Useravatar
 * zurückgegeben, optional, default value false
 * @return mixed Liefert Image, Avatar-Dateinamen oder Array mit Informationen zum Avatar je nach
 * übergebenen Parametern
 *
 * @deprecated
 */
function mxIsAvatarUploaded($username, $imagereturn = false, $new = false)
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);
  $pici = load_class('Userpic', $username);
  $userdata = mxGetUserDataFromUsername($username);

  switch (true) {
    case !permission_granted($pici->access_upload, $userdata['groups']):
    case !$pici->is_uploaded():
      return false;
    case $imagereturn:
      return $pici->getHtml('small');
    default:
      $img = $pici->get('small');
      if (!$img) {
        return false;
      }
      $info = pathinfo($img);
      if (!defined('MX_PATH_MEMBERAVATAR')) {
        define('MX_PATH_MEMBERAVATAR', $info['dirname']); // path_avatars
      }
      if ($new) {
        return array( // det olle array von 2.4.3...
          'aid' => $username,
          'typ' => $info['basename'],
          'anzahl' => 1,
          'werist' => $info['basename'],
          'fake_zahl' => 1,
          'foto' => '',
          'date' => time(),
          'id' => 0,
        );
      } else {
        return $info['basename'];
      }
  }
}

/**
 * Funktion zum löschen aller Avatare und Einstellungen eines Users.
 *
 * @since pragmaMx 0.1.0
 * @deprecated Diese Funktion wird seit pragmaMx 0.1.11 SP1 nicht mehr verwendet.
 * @param string $xx Username des User, desses Avatar gelöscht werden soll.
 * @return bool Gibt false zurück.
 */
function mxDeleteAvatar($xx = null)
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);
  return false;
}



/**
 * Reinigen von Usereingaben / Erwzingen double oder integer.
 * Nimmt eine globale Variable und modifiziert den Inhalt, erzwingt double bzw. integer.
 *
 * @since pragmaMx 0.1.0
 * @param mixed $var Name der Variablen, es können mehrere Variablen,
 * mittels Komma getrennt, übergeben werden.
 * @return mixed Gibt die modifizierte Variable zurück, wenn nur eine Variable
 * übergeben wurde, ansonsten ein Array mit den modifizierten Werten.
 *
 * @deprecated
 * diese Funktion wird seit pragmaMx 1.12 nicht mehr verwendet
 */
function mxForceInteger()
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);

  $arr = func_get_args();
  foreach ($arr as $i => $v) {
    if (empty($arr[$i])) {
      $arr[$i] = 0;
      continue;
    }
    if (is_array($arr[$i])) {
      foreach ($arr[$i] as $ia => $va) {
        if (empty($arr[$i][$ia])) {
          $arr[$i][$ia] = 0;
          continue;
        }
        $arr[$i][$ia] = mxForceInteger($arr[$i][$ia]);
      }
    } else {
      $arr[$i] = (gettype($arr[$i]) == "double") ? (float)$arr[$i] : (int)$arr[$i];
    }
  }
  $out = (func_num_args() == 1) ? $arr[0] : $arr;
  return $out;
}

/**
 * Rückgängigmachen des SQL-Injection Fixes um die Originalzeichen zurück zu erhalten.
 *
 * @since pragmaMx 0.1.0
 * @deprecated Funktion wird seit pragmaMx 0.1.6 nicht mehr verwendet.
 * Existiert nur noch aus Kompatibilitätsgründen und ist bei neuen
 * Entwicklungen nicht mehr einzusetzen.
 * @param string $ &$value Name der Variablen, deren Inhalt konvertiert werden soll.
 * @return string Gibt den konvertierten String zurück.
 */
function mxUndoSqlInjectFix(&$value)
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);

  if (!empty($value)) {
    if (!is_long($value) && !is_int($value) && !is_double($value) && !is_object($value) && !is_array($value)) {
      $value = str_replace(array('&#41;', '&#124;', '&#45;&#45;', '&#35;'), array(')', '|', '--', '#'), $value);
      $value = str_replace('&amp;#', '&#xxxxxxxx', $value);
    }
  }
  return $value;
}


/**
 * Variablenwert für die Ausgabe aufbereiten / Schutz vor E-Mail-Sammlern.
 * Sucht den Text 'x@y' und ersetzt ihn durch die entsprechenden HTML-Entitäten,
 * was einen gewissen Schutz vor E-Mail-Sammlern bietet.
 *
 * @since pragmaMx 0.1.0
 * @deprecated Funktion wird seit pragmaMx 0.1.6 nicht mehr verwendet.
 * Macht aus Kompatibilitätsgründen dasselbe wie mxPrepareToDisplay()
 * @param mixed $var Variable oder Array, deren Wert(e) modifiziert werden soll(en).
 * @return mixed Gibt die modifizierte Variable zurück, wenn nur eine Variable
 * übergeben wurde, ansonsten ein Array mit den modifizierten Werten.
 */
function mxPrepareToHTMLDisplay()
{
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);
  return call_user_func_array("mxPrepareToDisplay", func_get_args());
}

/**
 * durch die Replace-Plugins und die Ency-Hooks obsolete
 *
 * make_ency_link()
 *
 * @param mixed $string
 * @param integer $count
 * @return
 */
function make_ency_link($string, $count = 0)
{
  global $prefix;
  trigger_error('Use of deprecated function ' . __FUNCTION__ . '()', E_USER_WARNING);

  if (mxModuleAllowed("Encyclopedia") and mxModuleActive("Encyclopedia")) {
    // TODO: in der Datenbankabfrage beachten ob die entsprechenden Daten aktiviert und der aktuellen Sprache entsprechen !!!!
    $result = sql_query("SELECT content.* FROM {$prefix}_encyclopedia_text as content, {$prefix}_encyclopedia as category
							WHERE content.eid = category.eid AND category.active=1 AND category.elanguage='" . $GLOBALS['language'] . "'");
    $temp = array();
    while ($ency = sql_fetch_assoc($result)) {
      $text = (pmx_cutString(htmlspecialchars_decode(strip_tags($ency['text']))));
      $temp[$ency['title']] = "<a href=\"modules.php?name=Encyclopedia&amp;op=content&amp;tid=" . $ency['tid'] . "\" title=\"" . $text . "\" target=\"_blank\" >" . $ency['title'] . "</a>";
    }
    $string = mxChangeContent($string, $temp, $count);
  }
  return $string;
}
