<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radmincontent')) {
    mxErrorScreen('Access Denied');
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);

function content()
{
    global $prefix, $currentlang, $module_name;
    $img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
    $img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
    $img_delete = mxCreateImage("images/delete.gif", _DELETE, 0, 'title="' . _DELETE . '"');
    $img_edit = mxCreateImage("images/edit.gif", _EDIT, 0, 'title="' . _EDIT . '"');
    $editor = load_class('Textarea');
    pmxHeader::add_tabs(false);

    include("header.php");
    // GraphicAdmin();
    title(_CONTENTMANAGER);

    ?>

<div id="tabscontentman">
  <ul class="tabs-nav">
    <li><a href="#content-list"><span><?php echo _LISTCONTENT ?></span></a></li>
    <li><a href="#content-new"><span><?php echo _ADDANEWPAGE ?></span></a></li>
    <li><a href="#content-cat"><span><?php echo _CATEGORIES ?></span></a></li>
  </ul>

  <!-- START: LIST PAGES -->
  <div id="content-list" class="tabs-panel">
<?php
    echo '
    <table class="full list">
      <thead>
        <tr>
          <th>' . _TITLE . '</th>
          <th>' . _CURRENTSTATUS . '</th>
          <th>' . _CATEGORY . '</th>
          <th>' . _FUNCTIONS . '</th>
        </tr>
      </thead>
      <tbody>';
    $class = '';
    $out = '';
    $result = sql_query("select * from " . $prefix . "_pages order by pid");
    while ($mypages = sql_fetch_array($result)) {
        if ($mypages["cid"] == "0" OR $mypages["cid"] == "") {
            $cat_title = _NONE;
        } else {
            $res = sql_query("select title from " . $prefix . "_pages_categories where cid='" . $mypages["cid"] . "'");
            list($cat_title) = sql_fetch_row($res);
        }
        if ($mypages["active"] == 1) {
            $status = _ACTIVE;
            $status_chng = $img_deactivate;
            $active = 1;
        } else {
            $status = "<i>" . _INACTIVE . "</i>";
            $status_chng = $img_activate;
            $active = 0;
        }
        $class = ($class == '') ? ' class="alternate-a"' : '';
        $out .= '
        <tr' . $class . '>
          <td><a href="modules.php?name=' . $module_name . '&amp;pa=showpage&amp;pid=' . $mypages['pid'] . '">' . $mypages['title'] . '</a></td>
          <td>' . $status . '</td>
          <td>' . $cat_title . '</td>
          <td>
            <a href="' . adminUrl($module_name, 'edit', 'pid=' . $mypages['pid']) . '">' . $img_edit . '</a>
            <a href="' . adminUrl($module_name, 'change_status', 'pid=' . $mypages['pid'] . '&amp;active=' . $active) . '">' . $status_chng . '</a>
            <a href="' . adminUrl($module_name, 'delete', 'pid=' . $mypages['pid']) . '">' . $img_delete . '</a>
          </td>
        </tr>';
    }
    if ($out) {
        echo $out;
    } else {
        echo '
        <tr><td colspan="4"></td></tr>';
    }
    echo '
      </tbody>
    </table>';

    ?>

  </div>
  <!-- END: LIST PAGES -->

  <!-- START: ADD PAGE -->
  <div id="content-new" class="tabs-panel">
<?php
    $res = sql_query("select cid, title from " . $prefix . "_pages_categories order by title");
    echo "<fieldset><legend>" . _ADDANEWPAGE . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . ":</b><br />"
     . "<input type=\"text\" name=\"title\" size=\"50\" /><br /><br />";
    if (sql_num_rows($res) > 0) {
        echo "<b>" . _CATEGORY . ":</b>&nbsp;&nbsp;"
         . "<select name=\"cid\">"
         . "<option value=\"0\" selected=\"selected\">" . _NONE . "</option>";
        while (list($cid, $cat_title) = sql_fetch_row($res)) {
            echo "<option value=\"$cid\">$cat_title</option>";
        }
        echo "</select><br /><br />";
    } else {
        echo "<input type=\"hidden\" name=\"cid\" value=\"0\" />";
    }
    echo "<b>" . _CSUBTITLE . ":</b><br />"
     . "<input type=\"text\" name=\"subtitle\" size=\"50\" /><br /><br />"
     . "<b>" . _HEADERTEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'page_header', 'value' => '', 'height' => '150'))
     . "<br /><br />"
     . "<b>" . _PAGETEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'text', 'value' => '', 'height' => '400', 'pagebreak' => true))
     . "<br /><br />"
     . "<b>" . _FOOTERTEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'page_footer', 'value' => '', 'height' => '150'))
     . "<br /><br />"
     . "<b>" . _CONSIGNATURE . ":</b><br />"
     . $editor->getHtml(array('name' => 'signature', 'value' => '', 'height' => '100'))
     . "<br /><br />";
    if ($GLOBALS['multilingual']) {
        echo "<br /><b>" . _LANGUAGE . ": </b>" . mxLanguageSelect('clanguage', $currentlang, 'language', 1) . "<br /><br />";
    } else {
        echo "<input type=\"hidden\" name=\"clanguage\" value=\"" . $currentlang . "\" />";
    }
    echo "<b>" . _ACTIVATEPAGE . "</b><br />"
     . "<input type=\"radio\" name=\"active\" value=\"1\" checked=\"checked\" />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"active\" value=\"0\" />&nbsp;" . _NO . "<br /><br />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/save\" />"
     . "<input type=\"submit\" value=\"" . _ADD . "\" />"
     . "</form></fieldset>";

    ?>

  </div>
  <!-- END: ADD PAGE -->

  <!-- START: CATEGORIES -->
  <div id="content-cat" class="tabs-panel">
<?php
    echo "<fieldset><legend>" . _ADDCATEGORY . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . ":</b><br /><input type=\"text\" name=\"cat_title\" size=\"50\" /><br /><br />"
     . "<b>" . _DESCRIPTION . ":</b><br />"
     . $editor->getHtml(array('name' => 'katcontent', 'value' => '', 'height' => '100'))
     . "<br /><br />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/add_category\" />"
     . "<input type=\"submit\" value=\"" . _ADD . "\" />"
     . "</form></fieldset>";

    $rescat = sql_query("select cid, title from " . $prefix . "_pages_categories order by title");
    if (sql_num_rows($rescat) > 0) {
        echo "<fieldset><legend>" . _EDITCATEGORY . "</legend>"
         . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
         . "<b>" . _CATEGORY . ":</b> "
         . "<select name=\"cid\">";
        while (list($cid, $cat_title) = sql_fetch_row($rescat)) {
            echo "<option value=\"$cid\">$cat_title</option>";
        }
        echo "</select>&nbsp;&nbsp;"
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/edit_category\" />"
         . "<input type=\"submit\" value=\"" . _EDIT . "\" />"
         . "</form></fieldset>";
    }

    ?>
  </div>
  <!-- END: CATEGORIES -->

</div>
<!-- END: #tabscontentman -->

<script type="text/javascript">
/* <![CDATA[ */
$(document).ready(function(){
  var tab_cookie_name = 'tabscontentman';
  $('#tabscontentman').tabs({
    active: ($.cookie(tab_cookie_name) || 0),
    activate: function (event, ui) {
      var newIndex = ui.newTab.parent().children().index(ui.newTab);
      $.cookie(tab_cookie_name, newIndex, {
        path: window.location.pathname,
        expires: 7
      });
    }
  });
});
/* ]]> */
</script>
<?php
    include("footer.php");
}

function add_category($cat_title, $katcontent)
{
    global $prefix;
    sql_query("insert into " . $prefix . "_pages_categories values (NULL, '" . mxAddSlashesForSQL($cat_title) . "', '" . mxAddSlashesForSQL($katcontent) . "')");
    mxRedirect(adminUrl(PMX_MODULE));
}

function edit_category($cid)
{
    global $prefix;
    $result = sql_query("select title, description from " . $prefix . "_pages_categories where cid='" . intval($cid) . "'");
    list($title, $description) = sql_fetch_row($result);
    $editor = load_class('Textarea');

    include("header.php");
    // GraphicAdmin();
    title(_CONTENTMANAGER);
    OpenTable();
    echo "<fieldset><legend>" . _EDITCATEGORY . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . "</b><br />"
     . "<input type=\"text\" name=\"cat_title\" value=\"" . mxentityquotes($title) . "\" size=\"50\" /><br /><br />"
     . "<b>" . _DESCRIPTION . "</b>:<br />"
     . $editor->getHtml(array('name' => 'katcontent', 'value' => $description, 'height' => '100'))
     . "<br /><br />"
     . "<input type=\"hidden\" name=\"cid\" value=\"$cid\" />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/save_category\" />"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" />&nbsp;&nbsp;"
     . "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'del_category', 'cid=' . $cid) . "\">" . _DELETE . "</a>&nbsp;]"
     . "</form></fieldset>";
    CloseTable();
    include("footer.php");
}

function save_category($cid, $cat_title, $katcontent)
{
    global $prefix;
    sql_query("update " . $prefix . "_pages_categories set title='" . mxAddSlashesForSQL($cat_title) . "', description='" . mxAddSlashesForSQL($katcontent) . "' where cid=" . intval($cid));
    mxRedirect(adminUrl(PMX_MODULE));
}

function del_category($cid)
{
    global $prefix;
    if ((!empty($_REQUEST['ok']))) {
        sql_query("delete from " . $prefix . "_pages_categories where cid='" . intval($cid) . "'");
        $result = sql_query("select pid from " . $prefix . "_pages where cid='" . intval($cid) . "'");
        while (list($pid) = sql_fetch_row($result)) {
            sql_query("update " . $prefix . "_pages set cid='0' where pid='" . intval($pid) . "'");
        }
        mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include("header.php");
        // GraphicAdmin();
        title(_CONTENTMANAGER);
        $result = sql_query("select title from " . $prefix . "_pages_categories where cid='" . intval($cid) . "'");
        list($title) = sql_fetch_row($result);
        OpenTable();
        echo "<div class=\"warning\"><b>" . _DELCATEGORY . ": $title</b><br /><br />" . _DELCONTENTCAT . "<br /><br />
         [&nbsp;<a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a> | <a href=\"" . adminUrl(PMX_MODULE, 'del_category', 'cid=' . $cid . '&amp;ok=1') . "\">" . _YES . "</a>&nbsp;]
         </div>";
        CloseTable();
        include("footer.php");
    }
}

function content_edit($pid)
{
    global $prefix;
    $result = sql_query("select * from " . $prefix . "_pages WHERE pid='$pid'");
    $mypages = sql_fetch_array($result);
    if ($mypages["active"] == 1) {
        $sel1 = ' checked="checked"';
        $sel2 = "";
    } else {
        $sel1 = "";
        $sel2 = ' checked="checked"';
    }
    $editor = load_class('Textarea');

    include("header.php");
    // GraphicAdmin();
    title(_CONTENTMANAGER);
    OpenTable();
    echo "<fieldset><legend>" . _EDITPAGECONTENT . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . ":</b><br />"
     . "<input type=\"text\" name=\"title\" size=\"50\" value=\"" . mxentityquotes($mypages["title"]) . "\" /><br /><br />";
    $res = sql_query("select cid, title from " . $prefix . "_pages_categories");
    if (sql_num_rows($res) > 0) {
        echo "<b>" . _CATEGORY . ":</b>&nbsp;&nbsp;"
         . "<select name=\"cid\">";
        if ($mypages["cid"] == 0) {
            $sel = 'selected="selected" class="current"';
        } else {
            $sel = "";
        }
        echo "<option value=\"0\" $sel>" . _NONE . "</option>";
        while (list($cid, $cat_title) = sql_fetch_row($res)) {
            if ($mypages["cid"] == $cid) {
                $sel = 'selected="selected" class="current"';
            } else {
                $sel = "";
            }
            echo "<option value=\"$cid\" $sel>$cat_title</option>";
        }
        echo "</select><br /><br />";
    } else {
        echo "<input type=\"hidden\" name=\"cid\" value=\"0\" />";
    }

    echo "<b>" . _CSUBTITLE . ":</b><br />"
     . "<input type=\"text\" name=\"subtitle\" size=\"50\" value=\"" . mxentityquotes($mypages["subtitle"]) . "\" /><br /><br />"
     . "<b>" . _HEADERTEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'page_header', 'value' => $mypages['page_header'], 'height' => '150'))
     . "<br /><br />"
     . "<b>" . _PAGETEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'text', 'value' => $mypages['text'], 'height' => '400', 'pagebreak' => true))
     . "<br /><br />"
     . "<b>" . _FOOTERTEXT . ":</b><br />"
     . $editor->getHtml(array('name' => 'page_footer', 'value' => $mypages['page_footer'], 'height' => '150'))
     . "<br /><br />"
     . "<b>" . _CONSIGNATURE . ":</b><br />"
     . $editor->getHtml(array('name' => 'signature', 'value' => $mypages['signature'], 'height' => '100'))
     . "<br /><br />";
    if ($GLOBALS['multilingual']) {
        echo "<br /><b>" . _LANGUAGE . ": </b>" . mxLanguageSelect('clanguage', $mypages['clanguage'], 'language', 1) . "<br /><br />";
    } else {
        echo "<input type=\"hidden\" name=\"clanguage\" value=\"$mypages[clanguage]\" />";
    }
    echo "<b>" . _ACTIVATEPAGE . "</b><br />"
     . "<input type=\"radio\" name=\"active\" value=\"1\" $sel1 />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"active\" value=\"0\" $sel2 />&nbsp;" . _NO . "<br /><br />"
     . "<input type=\"hidden\" name=\"pid\" value=\"$pid\" />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/save_edit\" />"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" />"
     . "</form></fieldset>";
    CloseTable();
    include("footer.php");
}

function content_save($title, $subtitle, $page_header, $text, $page_footer, $signature, $clanguage, $active, $cid)
{
    global $prefix;
    if (preg_match('#<body[^>]*>(.+)</body>#is', $text, $matches)) {
        $text = $matches[1];
    }
    sql_query("insert into " . $prefix . "_pages values (NULL,
            '" . intval($cid) . "',
            '" . mxAddSlashesForSQL($title) . "',
            '" . mxAddSlashesForSQL($subtitle) . "',
            '" . intval($active) . "',
            '" . mxAddSlashesForSQL($page_header) . "',
            '" . mxAddSlashesForSQL($text) . "',
            '" . mxAddSlashesForSQL($page_footer) . "',
            '" . mxAddSlashesForSQL($signature) . "',
            now(),
            '0',
            '" . mxAddSlashesForSQL($clanguage) . "'
            )");
    mxRedirect(adminUrl(PMX_MODULE));
}

function content_save_edit($pid, $title, $subtitle, $page_header, $text, $page_footer, $signature, $clanguage, $active, $cid)
{
    global $prefix;
    if (preg_match('#<body[^>]*>(.+)</body>#is', $text, $matches)) {
        $text = $matches[1];
    }
    sql_query("update " . $prefix . "_pages set
               cid='" . intval($cid) . "',
               title='" . mxAddSlashesForSQL($title) . "',
               subtitle='" . mxAddSlashesForSQL($subtitle) . "',
               active='" . intval($active) . "',
               page_header='" . mxAddSlashesForSQL($page_header) . "',
               text='" . mxAddSlashesForSQL($text) . "',
               page_footer='" . mxAddSlashesForSQL($page_footer) . "',
               signature='" . mxAddSlashesForSQL($signature) . "',
               clanguage='" . mxAddSlashesForSQL($clanguage) . "'
               where pid='" . intval($pid) . "'");
    mxRedirect(adminUrl(PMX_MODULE));
}

function content_change_status($pid, $active)
{
    global $prefix;
    sql_query("update " . $prefix . "_pages set active='" . intval(!$active) . "' WHERE pid='" . intval($pid) . "'");
    mxRedirect(adminUrl(PMX_MODULE));
}

function content_delete($pid)
{
    global $prefix;
    if ((!empty($_REQUEST['ok']))) {
        sql_query("delete from " . $prefix . "_pages where pid='" . intval($pid) . "'");
        mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include("header.php");
        // GraphicAdmin();
        title(_CONTENTMANAGER);
        $result = sql_query("select title from " . $prefix . "_pages where pid='" . intval($pid) . "'");
        list($title) = sql_fetch_row($result);
        OpenTableAl();
        echo "<center><b>" . _DELCONTENT . ": $title</b><br /><br />"
         . _DELCONTWARNING . " $title?<br /><br />"
         . "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a> | <a href=\"" . adminUrl(PMX_MODULE, 'delete', 'pid=' . $pid . '&amp;ok=1') . "\">" . _YES . "</a>&nbsp;]</center>";
        CloseTableAl();
        include("footer.php");
    }
}

switch ($op) {
    case PMX_MODULE . "/edit":
        content_edit($pid);
        break;

    case PMX_MODULE . "/delete":
        content_delete($pid);
        break;

    case PMX_MODULE . "/review":
        content_review($title, $subtitle, $page_header, $text, $page_footer, $signature, $clanguage, $active);
        break;

    case PMX_MODULE . "/save":
        content_save($title, $subtitle, $page_header, $text, $page_footer, $signature, $clanguage, $active, $cid);
        break;

    case PMX_MODULE . "/save_edit":
        content_save_edit($pid, $title, $subtitle, $page_header, $text, $page_footer, $signature, $clanguage, $active, $cid);
        break;

    case PMX_MODULE . "/change_status":
        content_change_status($pid, $active);
        break;

    case PMX_MODULE . "/add_category":
        add_category($cat_title, $katcontent);
        break;

    case PMX_MODULE . "/edit_category":
        edit_category($cid);
        break;

    case PMX_MODULE . "/save_category":
        save_category($cid, $cat_title, $katcontent);
        break;

    case PMX_MODULE . "/del_category":
        del_category($cid);
        break;

    default:
        content();
        break;
}

?>