<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */

/* Anzahl der angezeigten Links, 0 um alle Links anzuzeigen */
$limit = 15;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

/* Block kann gecached werden? */
$mxblockcache = true;

global $prefix;

$limit = ($limit) ? ' LIMIT ' . intval($limit) : '';

$result = sql_query("SELECT pid, title FROM " . $prefix . "_pages WHERE active='1' ORDER BY date " . $limit . "");

$links = array();
while (list($pid, $title) = sql_fetch_row($result)) {
    $links[] = '<a href="modules.php?name=' . $module_name . '&amp;pid=' . $pid . '">' . $title . '</a>';
}

if (!$links) {
    return;
}

/* Templateausgabe erstellen */
$tpl = load_class('Template');
$tpl->init_path(__FILE__);
$tpl->init_template(__FILE__);
$tpl->links = $links;
$content = $tpl->fetch();

?>