<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*
# Content

RewriteRule ^Content-.*-category-([0-9]+)(-.*)?\.html$ mod.php?name=Content&cid=$1&_MORE_=$2 [L]
RewriteRule ^Content-.*-item-([0-9]+)(-.*)?\.html$ mod.php?name=Content&pid-$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $cat = array();
    $page = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case (isset($para['cid']) && intval($para['cid'])):
                $cat[0][] = $para['cid'];
                $cat[$key] = $para;
                break;
            case (isset($para['pid'], $para['pa']) && intval($para['pid']) && $para['pa'] == 'showpage'):
                unset($para['pa']); // alte Links mit pa=showpage
            case (isset($para['pid']) && intval($para['pid'])):
                $page[0][] = $para['pid'];
                $page[$key] = $para;
                break;
        }
    }

    /**
     * Content-KATEGORIENAME-cat63.html
     * RewriteRule ^Content-.*-cat([0-9]+)(-.*)?\.html$ mod.php?Content&________________________cid-$1$2 [L]
     */
    if ($cat) {
        $inquery = implode(',', array_unique(array_shift($cat)));
        $qry = "SELECT cid, title FROM {$prefix}_pages_categories WHERE cid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($cid, $title) = sql_fetch_row($result)) {
            $titles[$cid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($cat as $key => $link) {
            if (isset($titles[$link['cid']])) {
                $new_url = pmxModrewrite::title_parameters($link, 'cid');
                $new_url = 'Content-' . $titles[$link['cid']] . '-category-' . $link['cid'] . $new_url;
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /**
     * Content-PAGETITEL-(ID).html
     * RewriteRule ^Content-.*-\(([0-9]+)\)(-.*)?\.html$ mod.php?Content&________________________pid-$1$2 [L]
     */
    if ($page) {
        $inquery = implode(',', array_unique(array_shift($page)));
        $qry = "SELECT pid, title FROM {$prefix}_pages WHERE pid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($id, $title) = sql_fetch_row($result)) {
            $titles[$id] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($page as $key => $link) {
            if (isset($titles[$link['pid']])) {
                $new_url = pmxModrewrite::title_parameters($link, 'pid');
                $new_url = 'Content-' . $titles[$link['pid']] . '-item-' . $link['pid'] . '' . $new_url;
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }
}

?>