<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 695 $
 * $Author: PragmaMx $
 * $Date: 2023-03-30 09:44:50 +0200 (Do, 30. Mrz 2023) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _CONTENT;

        case $options['type'] === 'items':

            extract($options);

            $result = sql_query("
              SELECT p.`pid`, p.`title`, p.`subtitle`, p.`page_header`, p.`text`, p.`page_footer`, UNIX_TIMESTAMP(p.`date`) AS `date`, p.`counter` AS `views`, c.cid, c.title AS ctitle
              FROM `{$prefix}_pages` AS p
                LEFT JOIN `{$prefix}_pages_categories` AS c
                  ON p.cid = c.cid
              WHERE MATCH( p.`title`, p.`subtitle`, p.`page_header`, p.`text`, p.`page_footer`, c.title)
                AGAINST('{$search}' IN BOOLEAN MODE)
                AND p.`active` = 1
              ORDER BY `date` DESC
              LIMIT 0," . intval($limit));  // AND NOT ISNULL(c.`cid`) rausgenommen, damit auch Content ohne Kategorie gefiunden wird

            if ($result) {
                while ($entry = sql_fetch_assoc($result)) {
                    $entry['link'] = "modules.php?name=" . $module_name . "&amp;pid=" . $entry['pid'];
                    if ($entry['cid']) {
                        $entry['path'] = array("modules.php?name=$module_name&amp;cid=$entry[cid]" => $entry['ctitle'],
                            );
                    }
                    $entry['moduletitle'] = _CONTENT;
                    $entry['text'] = $entry['page_header'] . ' ' . $entry['text'] . ' ' . $entry['page_footer'];
                    if ($entry['subtitle']) {
                        // subtitle mit anfügen
                        $entry['title'] .= ', ' . $entry['subtitle'];
                    }
                    $entry['module'] = $module_name;
                    unset($entry['pid'], $entry['cid'], $entry['subtitle'], $entry['page_header'], $entry['page_footer'], $entry['ctitle']);
                    $entries[] = $entry;
                }
            }
    }
} ;

?>