<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* --------- Konfiguration fuer den Block ----------------------------------- */
// anzahl der Artikel mit Einleitung
$preview = 0;
// Anzahl SPalten
$xtabs = 2;
// Anzahl Artikel
$newscount = 6;
// max. ausdehnung Thumbnails
$thumbwidth = 100;
// anzeige Content
$viewcontent=true;

/* --------- Ende der Konfiguration ----------------------------------------- */

extract($block['settings'], EXTR_OVERWRITE);

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));
// mxGetLangfile($module_name,"core.lang-*.php");
if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

/* --- Book-Klasse laden ------- */
$bookmodule = $module_name;
$doc_cfg = array();
$doc = load_class('Book', $bookmodule);
$doc->module_name = $bookmodule;
$doc->modulename = $bookmodule;

$doc_cfg = $doc->getConfig();
$doc->logging = $doc_cfg['logging'];
$doc->insertfirst = $doc_cfg['insertfirst'];
$cat=$doc;
/* ----------------------------- */


$content = "";

$rootid = $cat->getBookRootID();

$news = $cat->getRecords_MostViewed(5);

if ($news === false) {
    // add by Andi: Fehlermeldung vermeiden, falls keine Datensätze vorhanden
    $mxblockcache = false;
    return;
}
$newscount = count($news);
$doc_cfg['cutlen'] = ($doc_cfg['cutlen'] == 0)?100:$doc_cfg['cutlen'];

if ($newscount > 0) {
    $content .= "<div class=\"postcontent\">";
    $content .= "<ul class=\"mainpage\">";
    $i = 0;
    foreach ($news as $cats) {
        $width = ($newscount > 1)?intval((100 - $xtabs * 3) / $xtabs):100;
        $book = $cat->getBookRoot($cats['id']);
        $bookstitle = $book['title'];
        if ($book['parent_id'] == $rootid) continue;

        $node['attachments'] = unserialize($cats['attachment']);
        if (!is_array($node['attachments']))$node['attachments'] = array();

        $node['attachment'] = array();
        $nodemedia = "";
        $fnr = 0;

        $attachments = (is_array($node['attachments']))?$node['attachments']:array();
        $attcount = count($attachments);
        if ($attcount) {
            foreach ($attachments as $file) {
                switch (strtolower($file['type'])) {
                    case "image/png":
                    case "image/jpg":
                    case "image/jpeg":
                    case "image/gif":
                        // $nodemedia=content_getAttachmentLink("temp",$file);
                        $nodemedia = "<a href=\"modules.php?name=$module_name&amp;act=page&amp;id=" . $cats['id'] . "\"
                                        title=\"" . $file['name'] . "\" ><img src=\"" . $file['filename'] . "\" alt=\"" . $file['name'] . "\"
                                        style=\"max-width:" . $thumbwidth . "px;max-height:" . $thumbwidth . "px;\" />" . "</a>";
                        break 2;
                        break;
                }
            }
        }

        if ($nodemedia) $nodemedia = "<span style=\"float:left;padding:5px;border:none;\">" . $nodemedia . "</span>";
        if ($i < $preview) $width = 100;
        $content .= "<li class=\"mainpage\" style=\"display:inline-block;width: " . $width . "%;list-style-type:none;margin:0px;padding:5px;vertical-align:top;\"><div class=\"blogstory\">";
        
        $content .= "<h4><a href=\"modules.php?name=$module_name&amp;act=page&amp;id=" . $cats['id'] . "\">" . $cats['title'] . "</a></h4>";
        $content .= "<p class=\"postcontent\" style=\"text-align:justify;\">" . $nodemedia;
        if ($viewcontent) $content .= pmx_cutString($cats['text1'], $doc_cfg['cutlen'], false);
        $content .= "</p></div></li>";
        $i++;
    }

    $content .= "</ul></div>";
    $content .= "<div class=\"block align-center\"><a class=\"button\" title=\"" . _DOCS_READMORE . "\" href=\"modules.php?name=" . $module_name . "\" >" . _DOCS_READMORE . "</a></div>";
}

?>