<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}
global $doc, $doc_cfg;
extract($block['settings'], EXTR_OVERWRITE);

/* --- Book-Klasse laden ------- */
$bookmodule = $module_name;
$doc_cfg = array();
$doc = load_class('Book', $bookmodule);
$doc->module_name = $bookmodule;
$doc->modulename = $bookmodule;

$doc_cfg = $doc->getConfig();
$doc->logging = $doc_cfg['logging'];
$doc->insertfirst = $doc_cfg['insertfirst'];
$cat=$doc;
/* ----------------------------- */

/* --------- Konfiguration fuer den Block ----------------------------------- */
// Anzahl Artikel
$newscount = $doc_cfg['newscount'];

/* --------- Ende der Konfiguration ----------------------------------------- */

$content = "";
$rootid = $cat->getBookRootID();
$news = $cat->getRecords_New(99, $newscount, 0);

if ($news === false) {
    // add by Andi: Fehlermeldung vermeiden, falls keine Datensätze vorhanden
    $mxblockcache = false;
    return;
}
$newscount = count($news);
$doc_cfg['cutlen'] = ($doc_cfg['cutlen'] == 0)?100:$doc_cfg['cutlen'];

if ($newscount > 0) {
	$blockfiletitle = "" . _DOCS_NEW_DOCUMENTS . "";
    $content .= "<ul class=\"list\">";
    $i = 0;
    $width = 100;
    foreach ($news as $cats) {
        $book = $cat->getBookRoot($cats['id']);
        if (!$book) continue 1;
        $bookstitle = $book['title'];
        $content .= "<li><a href=\"modules.php?name=$module_name&amp;act=page&amp;id=" . $cats['id'] . "\">" . $cats['title'] . "</a>";
        $content .= "</li>";
    }

    $content .= "</ul>";
}

?>