<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

function AddDownload($pvs = array())
{
    global $prefix, $pagetitle;
    if (MX_IS_USER) {
        $udata = mxGetUserData();
    }
    // Daten fuer header aufbereiten
    $title = _ADDNEWDOWNLOAD;
    $pagetitle = strip_tags($title);

    include(PMX_MODULES_DIR . DS . PMX_MODULE . '/includes/header.php');
    if (!empty($pvs['msg'])) {
        openTableAl();
        echo '<div style="text-align: left;"><h2>' . _ERROROCCURS . '</h2><ul><li>' . implode('</li><li>', $pvs['msg']) . '</li></ul></div>';
        closeTableAl();
        echo '<br />';
    }
    OpenTable();
    if (MX_IS_USER || $GLOBALS['downloads_anonadddownloadlock'] != 1 || mxGetAdminPref("radmindownload")) {
        if (empty($pvs)) {
            $pvs['submitter'] = (isset($udata['uname'])) ? $udata['uname'] : $GLOBALS['anonymous'] ;
            $pvs['cid'] = (isset($_REQUEST['cid'])) ? intval($_REQUEST['cid']) : 0;
        }
        echo "<form method=\"post\" action=\"modules.php?name=" . PMX_MODULE . "&amp;op=Add\" name=\"downform\">"
         . "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
         . "<tr><td colspan=\"2\"><b>" . _INSTRUCTIONS . ":</b><br />"
         . "<strong><big>&middot;</big></strong> " . _DSUBMITONCE . '<br />'
         . "<strong><big>&middot;</big></strong> " . _DPOSTPENDING . '<br />'
         . "<strong><big>&middot;</big></strong> " . _USERANDIP . "<br /><br /></td></tr>"
         . modDataForm($pvs, 'AddDownload')
         . "<tr valign=\"top\"><td colspan=\"2\" align=\"center\"><input type=\"hidden\" name=\"op\" value=\"Add\" />"
         . "<br /><br /><input type=\"submit\" value=\"" . _DLADDDOWNLOAD . "\" /></td></tr>"
         . "</table>"
         . "</form>";
    } else {
        echo modMessageNoAnonPost('AddDownload');
    }
    CloseTable();
    include(PMX_MODULES_DIR . DS . PMX_MODULE . '/includes/footer.php');
}

function Add()
{
    global $prefix, $downnotify;
    mxStripSlashes($_POST);
    if (MX_IS_USER) {
        $udata = mxGetUserData();
    }
    if (!MX_IS_USER && $GLOBALS['downloads_anonadddownloadlock'] == 1 && !mxGetAdminPref("radmindownload")) {
        mxErrorScreen(modMessageNoAnonPost('AddDownload'));
    }
    // feed submitter var
    $_POST['submitter'] = (!empty($udata['uname'])) ? $udata['uname'] : $GLOBALS['anonymous'] ;

    $_POST = modCheckData($_POST);

    if (count($_POST['msg'])) {
        AddDownload(mxStripSlashes($_POST));
        exit;
    }

    $qry = "INSERT INTO " . $prefix . "_downloads_newdownload SET
        cid=" . intval($_POST['cid']) . ",
        title='" . mxAddSlashesForSQL($_POST['title']) . "',
        url='" . mxAddSlashesForSQL(mx_urltohtml($_POST['url'])) . "',
        description='" . mxAddSlashesForSQL($_POST['description']) . "',
        name='" . mxAddSlashesForSQL($_POST['auth_name']) . "',
        email='" . mxAddSlashesForSQL($_POST['email']) . "',
        submitter='" . mxAddSlashesForSQL($_POST['submitter']) . "',
        filesize=" . intval($_POST['filesize']) . ",
        version='" . mxAddSlashesForSQL($_POST['version']) . "',
        homepage='" . mxAddSlashesForSQL($_POST['homepage']) . "',
        updated='" . mxAddSlashesForSQL($_POST['updated']) . "'
        ";
    if (sql_query($qry)) {
        // mail an admin senden
        if ($downnotify) {
            $link = PMX_HOME_URL . '/' . adminUrl(PMX_MODULE, '', '', '#waiting');
            $notify_message = ("-- " . _MODUNAME . " --\n" . $GLOBALS['notify_message'] . "\n\n========================================================\n" . $link . "\n\nat: " . mx_strftime(_SHORTDATESTRING . ' H:i', time()) . "\nip/ip:" . MX_REMOTE_ADDR . "\nfrom: " . $_POST['submitter'] . "\n");
            mxMail($GLOBALS['notify_email'], $GLOBALS['notify_subject'] . ' (' . _MODUNAME . ')', $notify_message, $GLOBALS['notify_from']);
        }
        mxRedirect('modules.php?name=' . PMX_MODULE . '&amp;cid=' . intval($_POST['cid']), "<b>" . _DOWNLOADRECEIVED . "</b><br /><br />" . _CHECKFORIT . '<br />', 10);
    } else {
        mxErrorScreen('Database-Error');
    }
}

function modMessageNoAnonPost($op)
{
    $out = '<div align="left">'
     . _DOWNLOADSNOTUSER1 . '<br />'
     . _DOWNLOADSNOTUSER2 . '<br /><br />'
     . _DOWNLOADSNOTUSER3 . '<br /><br />'
     . _DOWNLOADSNOTUSER4 . '<br />'
     . _DOWNLOADSNOTUSER5 . ' '
     . _DOWNLOADSNOTUSER6 . '<br />'
     . _DOWNLOADSNOTUSER7 . '<br /><br />'
     . '<center>';
    if (mxModuleAllowed('Your_Account')) {
        $out .= '&nbsp;<a rel="nofollow" href="modules.php?name=Your_Account&amp;redirect=' . urlencode('modules.php?name=' . PMX_MODULE . '&op=' . $op . '') . '">' . _LOGIN . '</a>&nbsp;';
    }
    if (mxModuleAllowed('User_Registration')) {
        $out .= '&nbsp;<a rel="nofollow" href="modules.php?name=User_Registration">' . _DOWNLOADSNOTUSER8 . '</a>&nbsp;';
    }
    $out .= '</div>';
    return $out;
}

?>