<?php

/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 722 $
 * $Author: Nouvelle $
 * $Date: 2023-11-04 20:16:15 +0100 (Sa, 04 Nov 2023) $
 */

$hook = function ($module_name, $options, &$hook_result) {
  // $options enthält die kompletten Daten des aktuellen Admins
  // $options = Admindaten aus mxGetAdminData()
  global $prefix;

  if ($options['radmindownload']) {

    $counter = [
      "brokendownload_0" => 0,
      "brokendownload_1" => 0
    ];

    list($num) = sql_fetch_row(sql_query("SELECT count(lid) FROM {$prefix}_downloads_newdownload"));
    if ($num) {
      // Eintrag
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name),
        'text' => (($num > 1) ? _AB_UDOWNLOADS : _AB_UDOWNLOAD)
      );
    }

    // Check brokendownload
    $result = sql_system_query("SELECT * FROM {$prefix}_downloads_modrequest");
    while ($value = sql_fetch_assoc($result)) {
      if ($value['brokendownload'] === 0) {
        $counter["brokendownload_0"]++;
      } elseif ($value['brokendownload'] === 1) {
        $counter["brokendownload_1"]++;
      }
    }

    // Eintrag
    if ($counter["brokendownload_0"] > 0) {
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name, 'ListModRequests'),
        'text' => $counter["brokendownload_0"] > 1 ? _AB_MODREQDOWNS : _AB_MODREQDOWN
      );
    }

    // Eintrag
    if ($counter["brokendownload_1"] > 0) {
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name, 'ListBroken'),
        'text' => $counter["brokendownload_1"] > 1 ? _AB_BROKENDOWNS : _AB_BROKENDOWN
      );
    }
  }
};
