<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1024 $
 * $Author: PragmaMx $
 * $Date: 2024-04-06 18:20:45 +0200 (Sa, 06 Apr 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["{$prefix}_downloads_downloads"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_downloads` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `url` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `description` text COLLATE utf8_unicode_ci,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `name` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `email` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `hits` int(11) NOT NULL DEFAULT '0',
  `submitter` varchar(60) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `downloadratingsummary` double(6,4) NOT NULL DEFAULT '0.0000',
  `totalvotes` int(11) NOT NULL DEFAULT '0',
  `totalcomments` int(11) NOT NULL DEFAULT '0',
  `filesize` int(11) NOT NULL DEFAULT '0',
  `version` varchar(20) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `homepage` varchar(200) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `keywords` text COLLATE utf8_unicode_ci,
  PRIMARY KEY  (`lid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_downloads_newdownload"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_newdownload` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `submitter` varchar(60) NOT NULL default '',
  `filesize` int(11) NOT NULL default '0',
  `version` varchar(10) NOT NULL default '',
  `homepage` varchar(200) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`lid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($tables["{$prefix}_downloads_categories"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("{$prefix}_downloads_categories");
    if (!isset($tf['parentid'])) {
        // nuke < 5.5
        $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_categories` ADD `parentid` INT( 11 ) NOT NULL DEFAULT '0'";
        $nukebefore55 = true;
    } else {
        if ($tf['parentid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_categories` CHANGE `parentid` `parentid` INT( 11 ) NOT NULL DEFAULT '0';";
    }
} else {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_categories` (
  `cid` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `cdescription` text NULL,
  `parentid` int(11) NOT NULL default '0',
  `captcha` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_downloads_editorials"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_editorials` (
  `downloadid` int(11) NOT NULL default '0',
  `adminid` varchar(60) NOT NULL default '',
  `editorialtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `editorialtext` text NULL,
  `editorialtitle` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`downloadid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_downloads_modrequest"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_modrequest` (
  `requestid` int(11) NOT NULL auto_increment,
  `lid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `description` text NULL,
  `modifysubmitter` varchar(60) NOT NULL default '',
  `brokendownload` int(3) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `filesize` int(11) NOT NULL default '0',
  `version` varchar(10) NOT NULL default '',
  `homepage` varchar(200) NOT NULL default '',
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`requestid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_downloads_votedata"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_downloads_votedata` (
  `ratingdbid` int(11) NOT NULL auto_increment,
  `ratinglid` int(11) NOT NULL default '0',
  `ratinguser` varchar(60) NOT NULL default '',
  `rating` int(11) NOT NULL default '0',
  `ratinghostname` varchar(60) NOT NULL default '',
  `ratingcomments` text NULL,
  `ratingtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ratingdbid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

// indexe aktualisieren
$indexes = setupGetTableIndexes("{$prefix}_downloads_categories");
if (isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_categories` DROP INDEX `cid` ";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_categories` ADD INDEX `title` ( `title` )";

$indexes = setupGetTableIndexes("{$prefix}_downloads_downloads");
if (!isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` ADD INDEX `cid` ( `cid` )";
if (!isset($indexes['hits'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` ADD INDEX `hits` ( `hits` )";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` ADD INDEX `title` ( `title` )";
if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` ADD INDEX `date` ( `date` )";
if (isset($indexes['ddate'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` DROP INDEX ddate";
if (!isset($indexes['downloadratingsummary'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` ADD INDEX `downloadratingsummary` ( `downloadratingsummary` )";
if (isset($indexes['lid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` DROP INDEX `lid` ";
if (isset($indexes['sid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_downloads` DROP INDEX `sid` ";

$indexes = setupGetTableIndexes("{$prefix}_downloads_modrequest");
if (isset($indexes['requestid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_modrequest` DROP INDEX `requestid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'requestid') {
    $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_modrequest` DROP PRIMARY KEY , ADD PRIMARY KEY ( `requestid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_modrequest` ADD PRIMARY KEY ( `requestid` ) ";
}

$indexes = setupGetTableIndexes("{$prefix}_downloads_editorials");
if (isset($indexes['downloadid'])) $sqlqry[] = "ALTER TABLE `{$prefix}_downloads_editorials` DROP INDEX `downloadid` ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>