<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');
// maximale Groesse des Downloads, so dass das Verstecken
// der normalen URL noch moeglich ist, in mb
$dl_max_hide_length = 10;

function getit($lid)
{
    global $prefix, $module_name, $pagetitle;
    $qry = "SELECT dd.lid, dd.title, dd.url, dc.captcha, dc.cid
        FROM " . $prefix . "_downloads_downloads AS dd INNER JOIN " . $prefix . "_downloads_categories AS dc ON dd.cid = dc.cid
        WHERE dd.lid=" . intval($lid) . "
         AND dd.cid > 0
        LIMIT 1";
    $result = sql_query($qry);
    list($lid, $title, $url, $captcha, $cid) = sql_fetch_row($result);
    if (empty($lid)) {
        mxErrorScreen(_DLFNOTFOUND . ' (1)');
        exit;
    }

    $captcha_object = load_class('Captcha');

    if (!$captcha || !$captcha_object->get_active()) {
        getDownloadNow($lid, $url);
        exit;
    }

    $msg = '';
    if (isset($_POST['captcha'], $_POST['pass'], $_POST['lid'])) {
        if ($captcha_object->check($_POST, 'captcha')) {
            getDownloadNow($lid, $url);
            exit;
        }
        $msg = _CAPTCHAWRONG;
    }
    $captcha_object = null;

    /* Daten fuer header aufbereiten */
    $pagetitle = strip_tags($title . ', ' . _DOWNLOADING);
    $pagesubmenu = modDetailsTopMenu($lid);
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');

    OpenTable();
    echo '<h4 class="option">' . _DOWNLOADING . '</h4>';
    echo "<p>" . _DLFBECAUSE . "</p>";
    if ($msg) {
        openTableAl();
        echo '<div class="align-center bigger"><b>' . $msg . '!</b></div>';
        closeTableAl();
        echo '<br />';
    }
    modFetchForm($lid, $title, $url);
    echo '<p>' . _DLFYOUHAVE . ': &quot;<b>' . trim($title) . '</b>&quot;</p>';
    echo '<p class="align-center">' . _GOBACK . '</p>';
    CloseTable();
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

function getDownloadNow($lid, $url)
{
    global $prefix, $module_name, $pagetitle, $hidepath;
    $result = sql_query("select lid, url, title, cid, filesize from " . $prefix . "_downloads_downloads WHERE lid=" . intval($lid) . " AND cid > 0");
    list($lid, $url, $title, $cid, $filesize) = sql_fetch_row($result);
    if (empty($lid)) {
        mxErrorScreen(_DLFNOTFOUND . ' (2)');
        exit;
    }

    $exists = false;
    // die url aufsplitten
    $url_parsed = parse_url($url);
    // falls url direkt auf eine Datei auf dem eigenen Server verlinkt
    if (empty($url_parsed["scheme"]) || empty($url_parsed["host"])) {
        // und diese Datei wirklich existiert
        if (@is_file($url_parsed['path'])) {
            $exists = true;
            if ($tmp = @filesize($url_parsed['path'])) {
                $filesize = $tmp;
            }
        }
    }

    if ($exists || preg_match('#://#', $url)) {
        if ($hidepath) {
            // den Header abfragen
            $header = modGetResponseHeader($url);
            /**
             * wenn ungueltige URL, diesen Link als ungueltig in der
             * Administration kennzeichnen, aber trotzdem weiterleiten
             */
            if ($header['status'] === 404) {
                modReportFalses($lid);
            }
            // Vorabcheck der Groesse, bei Dateien > 10Mb, $hidepath abschalten
            if (!empty($header['Content-Length'])) {
                $hidepath = ($header['Content-Length'] >= 1024 * 1024 * intval($GLOBALS['dl_max_hide_length'])) ? false : true;
            }
            // wenn gueltige URL und Content-Typ gesendet
            if ($hidepath && $header['status'] >= 200 && $header['status'] < 300 && $header['type']) {
                /* Text-Typen
                'text/html', 'text/xml','application/xhtml+xml', 'application/xml',
                 */
                $type = explode('/', $header['type']);
                // wenn Content-Typ kein Text ist, bzw. keine HTML-Seite
                if ($type[0] != 'text' && (isset($type[1]) && $type[1] != 'xml' && $type[1] != 'xhtml+xml')) {
                    // ab hier die url vom response verwenden, falls innerhalb der Abfrage umgeleitet wurde
                    $url = $header['url'];
                    // wenn gzip-Kompression per ob_gzhandler eingeschaltet, hier wieder abschalten.
                    // Before ob_gzhandler()  actually sends compressed data, it determines what type of content encoding
                    // the browser will accept ("gzip", "deflate" or none at all) and will return its output accordingly.
                    $_SERVER['HTTP_ACCEPT_ENCODING'] = 'none';
                    // eventuell vorhandenen Ausgabepuffer loeschen
                    while (ob_get_length()) {
                        ob_end_clean();
                    }
                    // Rueckgabearray initialisieren
                    $info = array();
                    // Standardtype initialisieren
                    $info['content-type'] = 'application/octet-stream';
                    // Inhalte von Datei auslesen und $info-Array aktualisieren
                    $content = modGetFileContent($url, $info);
                    // Laenge der Inhalte zwischenspeichern
                    $filesize = strlen($content);
                    // wenn Inhalte gelesen werden konnten...
                    if ($filesize) {
                        // den realen Dateinamen fuer den Anhang generieren
                        $filename = (isset($header['attachment-name'])) ? trim($header['attachment-name']) : basename($url);
                        // Zaehlt den Download und aktualisieren der Dateigroesse des Downloads in Datenbank
                        modUpdateCounter($lid, $filesize);
                        // Erfolgsheader senden
                        header("HTTP/1.1 200 OK");
                        // fix for IE
                        header('Cache-control: private');
                        // bin-Files
                        header('Content-type: ' . $info['content-type']);
                        // Downloadfenster erzwingen, NUR den Dateinamen zum Speichern
                        header('Content-disposition: attachment; filename=' . $filename);
                        // Dateigroesse mitsenden
                        header('Content-Length: ' . $filesize);
                        // senden des Fileinhalts an den Browser
                        echo $content;
                        // Script beenden
                        exit;
                    }
                }
            }
        }
        /**
         * wenn das Content-Auslesen misslungen ist, oder abgeschaltet ist,
         * hier normal umleiten...
         */
        header('HTTP/1.1 301 Moved Permanently');
        // Zaehlt den Download und aktualisieren der Dateigroesse des Downloads in Datenbank
        modUpdateCounter($lid, $filesize);
        mxRedirect($url);
        exit;
    }

    /**
     * wenn keine Ausgabe/Umleitung stattgefunden hat, diesen Link als
     * ungueltig in der Administration kennzeichnen
     */
    modReportFalses($lid);
    // Userdaten ermitteln
    $udata = mxGetUserData();
    $username = (empty($udata['uname'])) ? $GLOBALS['anonymous'] : $udata['uname'];
    // Daten fuer header aufbereiten
    $result = sql_query("select title, cid from " . $prefix . "_downloads_downloads WHERE lid=" . intval($lid));
    list($title, $cid) = sql_fetch_row($result);
    $pagetitle = strip_tags($title . ', ' . _DLFNOTFOUND);
    $pagesubmenu = modDetailsTopMenu($lid);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    OpenTable();
    echo '<h4 class="option">' . _DOWNLOADING . '</h4>';
    echo "<p>" . _DLFSORRY1 . " " . $username . " :-(</p><br /><p>" . sprintf(_DLFSORRY2, $title) . "</p>";
    CloseTable();
    echo '<br />';
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

/**
 * Zaehlt den Download und
 * aktualisieren der Dateigroesse des Downloads in Datenbank
 */
function modUpdateCounter($lid, $filesize)
{
    global $prefix;
    sql_query("update " . $prefix . "_downloads_downloads set hits=hits+1, filesize=" . intval($filesize) . " where lid=" . intval($lid));
}

/**
 * fehlerhafte Downloads als Fehler melden
 */
function modReportFalses($lid)
{
    static $run = 0;
    if ($run) {
        // verhindern, dass doppelt ausgefuehrt wird
        return true;
    }
    $run = 1;
    global $prefix, $module_name, $downnotify;
    $result = sql_query("SELECT sid as reported FROM " . $prefix . "_downloads_downloads WHERE lid=" . intval($lid) . " LIMIT 1");
    $row = sql_fetch_assoc($result);
    if ($row && $row['reported']) {
        // wenn bereits informiert, Funktion beenden
        return true;
    } else {
        // als informiert kennzeichnen, damit dieser Link nie wieder gemeldet
        // wird. Dies wird beim naechsten speichern des Links wieder zurueckgesetzt
        sql_query("UPDATE " . $prefix . "_downloads_downloads SET sid=1 WHERE lid=" . intval($lid));
    }
    $modifysubmitter = PMX_MODULE . '-Script at ';
    $result = sql_query("SELECT lid FROM " . $prefix . "_downloads_modrequest WHERE (lid=" . $lid . " AND brokendownload=1 AND modifysubmitter LIKE '" . $modifysubmitter . "%') LIMIT 1");
    $row = sql_fetch_row($result);
    if (empty($row)) {
        $modifysubmitter .= date("Y-m-d g:i");
        $qry = "INSERT INTO " . $prefix . "_downloads_modrequest (lid, modifysubmitter, brokendownload)
                VALUES (
                " . intval($lid) . ",
                '" . mxAddSlashesForSQL($modifysubmitter) . "',
                1)";
        if (sql_query($qry)) {
            // mail an admin senden
            if ($downnotify) {
                $link = PMX_HOME_URL . '/' . adminUrl(PMX_MODULE, 'ListBroken');
                $notify_message = ("-- " . _DUSERREPBROKEN . " --\n" . $GLOBALS['notify_message'] . "\n\n========================================================\n" . $link . "\n\nat: " . mx_strftime(_SHORTDATESTRING . ' H:i', time()) . "\nip/ip:" . MX_REMOTE_ADDR . "\nfrom: " . $modifysubmitter . "\n");
                mxMail($GLOBALS['notify_email'], $GLOBALS['notify_subject'] . ' (' . _MODUNAME . ')', $notify_message, $GLOBALS['notify_from']);
            }
        }
    }
}

/**
 * ermittelt die Referenzdaten anhand der remote Datei auf pragmaMx.org
 * kann diese nicht eingelesen werden, wird die lokale Datei verwendet
 */
function modGetFileContent($url, &$info)
{
    // Die maximale Ausfuehrungszeit in Sekunden
    $timeout = 12; // set to zero for no timeout
    // interne Variablen initialisieren
    $file_contents = "";

    switch (true) {
        case function_exists('curl_init'):
            // wenn moeglich die curl-Biblithek verwenden
            $ch = curl_init();
            curl_setopt ($ch, CURLOPT_URL, $url);
            curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
            $file_contents = curl_exec($ch);
            $info = curl_getinfo($ch);
            $info['status'] = $info['http_code'];
            $info['content-type'] = $info['content_type'];
            $info['content-length'] = $info['download_content_length'];
            $info['method'] = 'curl';
            curl_close($ch);
            break;

        case mxIniGet('allow_url_fopen') && $file_contents = @file_get_contents($url):
            // geht ueber file_get_contents?
            $info['method'] = 'file';
            $info['status'] = 200;
            break;

        case function_exists('fsockopen'):
            // ansonsten die herkoemmliche Methode von nuke/pragmaMx verwenden
            $errno = '';
            $errstr = '';
            $file = parse_url($url);
            $file['host'] = strtolower($file['host']);
            if (isset($file['query'])) {
                $file['query'] .= '?';
            } else {
                $file['query'] = '';
            }
            pmxDebug::pause();
            /**
             * following snipped based on:
             * http://www.php.net/manual/de/function.fsockopen.php
             * comment from jbr at ya-right dot com, 01-Mar-2007 08:17
             */
            if (($fp = fsockopen($file['host'], 80, $errno, $errstr, $timeout)) !== false) {
                $send = "GET " . $file['path'] . $file['query'] . " HTTP/1.1\r\n";
                $send .= "Host: " . $file['host'] . "\r\n";
                $send .= "User-Agent: " . MX_USER_AGENT . "\r\n";
                $send .= "Referer: http://" . $file['host'] . "/\r\n";
                $send .= "Accept: text/xml,application/xml,application/xhtml+xml,";
                $send .= "text/html;q=0.9,text/plain;q=0.8,video/x-mng,image/png,";
                $send .= "image/jpeg,image/gif;q=0.2,text/css,*/*;q=0.1\r\n";
                $send .= "Accept-Language: en-us, en;q=0.50\r\n";
                $send .= "Accept-Encoding: gzip, deflate, compress;q=0.9\r\n";
                $send .= "Connection: Close\r\n\r\n";
                fputs ($fp, $send);
                $send = '';
                do {
                    $send .= fgets ($fp, 4096);
                } while (strpos ($send, "\r\n\r\n") === false);
                $info = modDecodeHeader ($send);
                $file_contents = '';
                while (! feof ($fp)) {
                    $file_contents .= fread ($fp, 8192);
                }
                fclose ($fp);
            }
            pmxDebug::restore();
            $info['method'] = 'socket';
            break;

        default:
            $info['method'] = '';
            trigger_error('no url-wrapper found for: ' . $url, E_USER_NOTICE);
    }
    // $info['content-length'] = $info['content_type'];
    if (empty($info['content-length'])) {
        $info['content-length'] = strlen($file_contents);
    }
    return $file_contents;
}

/**
 * GET Header parsen
 * based on:
 * http://www.php.net/manual/de/function.fsockopen.php
 * comment from jbr at ya-right dot com, 01-Mar-2007 08:17
 */
function modDecodeHeader ($str)
{
    $part = preg_split ("/\r?\n/", $str, -1, PREG_SPLIT_NO_EMPTY);
    $out = array ();
    for ($h = 0; $h < sizeof ($part); $h++) {
        if ($h != 0) {
            $pos = strpos ($part[$h], ':');
            $k = strtolower (str_replace (' ', '', substr ($part[$h], 0, $pos)));
            $v = trim (substr ($part[$h], ($pos + 1)));
        } else {
            $k = 'status';
            $v = explode (' ', $part[$h]);
            $v = $v[1];
        }
        if ($k == 'set-cookie') {
            $out['cookies'][] = $v;
        } else if ($k == 'content-type') {
            if (($cs = strpos ($v, ';')) !== false) {
                $out[$k] = substr ($v, 0, $cs);
            } else {
                $out[$k] = $v;
            }
        } else {
            $out[$k] = $v;
        }
    }
    return $out;
}

?>