<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!$usevoting) {
    mxRedirect('modules.php?name=' . $module_name, _NOTVOTINGWARN, 5);
}

function viewratingdetails($lid)
{
    global $prefix, $module_name, $pagetitle;
    global $useoutsidevoting, $detailvotedecimal, $anonweight, $outsideweight;

    if (!modCheckAndCleanSubdata($lid)) {
        mxRedirect('modules.php?name=' . $module_name);
    }
    $result = sql_query("SELECT lid, title FROM " . $prefix . "_downloads_downloads WHERE lid = " . intval($lid) . " AND cid > 0");
    list($lid, $title) = sql_fetch_row($result);
    // falls fehlerhafte lid uebergeben
    if (empty($lid)) {
        mxErrorScreen('download id ' . intval($lid) . ' not found...');
    }
    $voteresult = sql_query("select rating, ratinguser, ratingcomments FROM " . $prefix . "_downloads_votedata WHERE ratinglid = " . intval($lid));
    $totalvotesDB = sql_num_rows($voteresult);
    $avgOU = 0;
    $avgRU = 0;
    $avgAU = 0;
    $anonvotes = 0;
    $anonvoteval = 0;
    $outsidevotes = 0;
    $outsidevoteval = 0;
    $regvoteval = 0;
    $topanon = 0;
    $bottomanon = 11;
    $topreg = 0;
    $bottomreg = 11;
    $topoutside = 0;
    $bottomoutside = 11;
    $avv = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $rvv = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $ovv = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $truecomments = $totalvotesDB;
    while (list($ratingDB, $ratinguserDB, $ratingcommentsDB) = sql_fetch_row($voteresult)) {
        if ($ratingcommentsDB == "") $truecomments--;
        if ($ratinguserDB == $GLOBALS['anonymous']) {
            $anonvotes++;
            $anonvoteval += $ratingDB;
        }
        if ($useoutsidevoting == 1) {
            if ($ratinguserDB == 'outside') {
                $outsidevotes++;
                $outsidevoteval += $ratingDB;
            }
        } else {
            $outsidevotes = 0;
        }
        if ($ratinguserDB != $GLOBALS['anonymous'] && $ratinguserDB != "outside") {
            $regvoteval += $ratingDB;
        }
        if ($ratinguserDB != $GLOBALS['anonymous'] && $ratinguserDB != "outside") {
            if ($ratingDB > $topreg) $topreg = $ratingDB;
            if ($ratingDB < $bottomreg) $bottomreg = $ratingDB;
            for ($rcounter = 1; $rcounter < 11; $rcounter++) if ($ratingDB == $rcounter) $rvv[$rcounter]++;
        }
        if ($ratinguserDB == $GLOBALS['anonymous']) {
            if ($ratingDB > $topanon) $topanon = $ratingDB;
            if ($ratingDB < $bottomanon) $bottomanon = $ratingDB;
            for ($rcounter = 1; $rcounter < 11; $rcounter++) if ($ratingDB == $rcounter) $avv[$rcounter]++;
        }
        if ($ratinguserDB == "outside") {
            if ($ratingDB > $topoutside) $topoutside = $ratingDB;
            if ($ratingDB < $bottomoutside) $bottomoutside = $ratingDB;
            for ($rcounter = 1; $rcounter < 11; $rcounter++) if ($ratingDB == $rcounter) $ovv[$rcounter]++;
        }
    }
    $regvotes = $totalvotesDB - $anonvotes - $outsidevotes;
    if ($totalvotesDB == 0) {
        $finalrating = 0;
    } else if ($anonvotes == 0 && $regvotes == 0) {
        /**
         * Figure Outside Only Vote
         */
        $finalrating = $outsidevoteval / $outsidevotes;
        $finalrating = number_format($finalrating, $detailvotedecimal);
        $avgOU = $outsidevoteval / $totalvotesDB;
        $avgOU = number_format($avgOU, $detailvotedecimal);
    } else if ($outsidevotes == 0 && $regvotes == 0) {
        /**
         * Figure Anon Only Vote
         */
        $finalrating = $anonvoteval / $anonvotes;
        $finalrating = number_format($finalrating, $detailvotedecimal);
        $avgAU = $anonvoteval / $totalvotesDB;
        $avgAU = number_format($avgAU, $detailvotedecimal);
    } else if ($outsidevotes == 0 && $anonvotes == 0) {
        /**
         * Figure Reg Only Vote
         */
        $finalrating = $regvoteval / $regvotes;
        $finalrating = number_format($finalrating, $detailvotedecimal);
        $avgRU = $regvoteval / $totalvotesDB;
        $avgRU = number_format($avgRU, $detailvotedecimal);
    } else if ($regvotes == 0 && $useoutsidevoting == 1 && $outsidevotes != 0 && $anonvotes != 0) {
        /**
         * Figure Reg and Anon Mix
         */
        $avgAU = $anonvoteval / $anonvotes;
        $avgOU = $outsidevoteval / $outsidevotes;
        if ($anonweight > $outsideweight) {
            /**
             * Anon is 'standard weight'
             */
            $newimpact = $anonweight / $outsideweight;
            $impactAU = $anonvotes;
            $impactOU = $outsidevotes / $newimpact;
            $finalrating = ((($avgOU * $impactOU) + ($avgAU * $impactAU)) / ($impactAU + $impactOU));
            $finalrating = number_format($finalrating, $detailvotedecimal);
        } else {
            /**
             * Outside is 'standard weight'
             */
            $newimpact = $outsideweight / $anonweight;
            $impactOU = $outsidevotes;
            $impactAU = $anonvotes / $newimpact;
            $finalrating = ((($avgOU * $impactOU) + ($avgAU * $impactAU)) / ($impactAU + $impactOU));
            $finalrating = number_format($finalrating, $detailvotedecimal);
        }
    } else {
        /**
         * REG User vs. Anonymous vs. Outside User Weight Calutions
         */
        $impact = $anonweight;
        $outsideimpact = $outsideweight;
        if ($regvotes == 0) {
            $avgRU = 0;
        } else {
            $avgRU = $regvoteval / $regvotes;
        }
        if ($anonvotes == 0) {
            $avgAU = 0;
        } else {
            $avgAU = $anonvoteval / $anonvotes;
        }
        if ($outsidevotes == 0) {
            $avgOU = 0;
        } else {
            $avgOU = $outsidevoteval / $outsidevotes;
        }
        $impactRU = $regvotes;
        $impactAU = $anonvotes / $impact;
        $impactOU = $outsidevotes / $outsideimpact;
        $finalrating = (($avgRU * $impactRU) + ($avgAU * $impactAU) + ($avgOU * $impactOU)) / ($impactRU + $impactAU + $impactOU);
        $finalrating = number_format($finalrating, $detailvotedecimal);
    }
    if (empty($avgOU)) {
        $avgOU = "";
    } else {
        $avgOU = number_format($avgOU, $detailvotedecimal);
    }
    if (empty($avgRU)) {
        $avgRU = "";
    } else {
        $avgRU = number_format($avgRU, $detailvotedecimal);
    }
    if (empty($avgAU)) {
        $avgAU = "";
    } else {
        $avgAU = number_format($avgAU, $detailvotedecimal);
    }
    if ($topanon == 0) $topanon = "";
    if ($bottomanon == 11) $bottomanon = "";
    if ($topreg == 0) $topreg = "";
    if ($bottomreg == 11) $bottomreg = "";
    if ($topoutside == 0) $topoutside = "";
    if ($bottomoutside == 11) $bottomoutside = "";
    $totalchartheight = 70;
    $chartunits = $totalchartheight / 10;
    $avvper = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $rvvper = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $ovvper = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $avvpercent = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $rvvpercent = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $ovvpercent = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $avvchartheight = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $rvvchartheight = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $ovvchartheight = array(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
    $avvmultiplier = 0;
    $rvvmultiplier = 0;
    $ovvmultiplier = 0;
    for ($rcounter = 1; $rcounter < 11; $rcounter++) {
        if ($anonvotes != 0) $avvper[$rcounter] = $avv[$rcounter] / $anonvotes;
        if ($regvotes != 0) $rvvper[$rcounter] = $rvv[$rcounter] / $regvotes;
        if ($outsidevotes != 0) $ovvper[$rcounter] = $ovv[$rcounter] / $outsidevotes;
        $avvpercent[$rcounter] = number_format($avvper[$rcounter] * 100, 1);
        $rvvpercent[$rcounter] = number_format($rvvper[$rcounter] * 100, 1);
        $ovvpercent[$rcounter] = number_format($ovvper[$rcounter] * 100, 1);
        if ($avv[$rcounter] > $avvmultiplier) $avvmultiplier = $avv[$rcounter];
        if ($rvv[$rcounter] > $rvvmultiplier) $rvvmultiplier = $rvv[$rcounter];
        if ($ovv[$rcounter] > $ovvmultiplier) $ovvmultiplier = $ovv[$rcounter];
    }
    if ($avvmultiplier != 0) $avvmultiplier = 10 / $avvmultiplier;
    if ($rvvmultiplier != 0) $rvvmultiplier = 10 / $rvvmultiplier;
    if ($ovvmultiplier != 0) $ovvmultiplier = 10 / $ovvmultiplier;
    for ($rcounter = 1; $rcounter < 11; $rcounter++) {
        $avvchartheight[$rcounter] = ($avv[$rcounter] * $avvmultiplier) * $chartunits;
        $rvvchartheight[$rcounter] = ($rvv[$rcounter] * $rvvmultiplier) * $chartunits;
        $ovvchartheight[$rcounter] = ($ovv[$rcounter] * $ovvmultiplier) * $chartunits;
        if ($avvchartheight[$rcounter] == 0) $avvchartheight[$rcounter] = 1;
        if ($rvvchartheight[$rcounter] == 0) $rvvchartheight[$rcounter] = 1;
        if ($ovvchartheight[$rcounter] == 0) $ovvchartheight[$rcounter] = 1;
    }
    // das Bewertungsbildchen (die Sterne)
    $ratepic = '';
    if ($totalvotesDB) {
        $ratepic = modRateMakeStar($finalrating, $totalvotesDB);
    }
    // Daten fuer header aufbereiten
    $pagetitle = strip_tags($title . ', ' . _DOWNLOADRATINGDET);
    $pagesubmenu = modDetailsTopMenu($lid);

    include(PMX_MODULES_DIR . DS . $module_name . '/includes/header.php');
    OpenTable();
    echo '<h4 class="option">' . _DOWNLOADRATINGDET . '</h4>';
    echo "<p>" . _TOTALVOTES . ": <b>" . $totalvotesDB . "</b> " . _OVERALLRATING . ": <b>" . $finalrating . "</b>&nbsp;&nbsp;" . $ratepic . "</p><br />";
    if ($totalvotesDB || $finalrating) {
        echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\" width=\"455\">"
         . "<tr><td colspan=\"2\" class=\"bgcolor2\">"
         . "<font class=\"content\"><b>" . _REGISTEREDUSERS . "</b></font>"
         . "</td></tr>"
         . "<tr>"
         . "<td class=\"bgcolor1\">"
         . "<font class=\"content\">" . _NUMBEROFRATINGS . ": $regvotes</font>"
         . "</td>"
         . "<td rowspan=\"5\" width=\"200\">";
        if ($regvotes == 0) {
            echo "<center><font class=\"content\">" . _NOREGUSERSVOTES . "</font></center>";
        } else {
            echo "<table border=\"1\" width=\"200\">"
             . "<tr>"
             . "<td valign=\"top\" align=\"center\" colspan=\"10\" class=\"bgcolor2\"><font class=\"content\">" . _BREAKDOWNBYVAL . "</font></td>"
             . "</tr>"
             . "<tr>"
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[1] . ' ' . _LVOTES . ' (' . $rvvpercent[1] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[1] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[2] . ' ' . _LVOTES . ' (' . $rvvpercent[2] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[2] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[3] . ' ' . _LVOTES . ' (' . $rvvpercent[3] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[3] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[4] . ' ' . _LVOTES . ' (' . $rvvpercent[4] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[4] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[5] . ' ' . _LVOTES . ' (' . $rvvpercent[5] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[5] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[6] . ' ' . _LVOTES . ' (' . $rvvpercent[6] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[6] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[7] . ' ' . _LVOTES . ' (' . $rvvpercent[7] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[7] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[8] . ' ' . _LVOTES . ' (' . $rvvpercent[8] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[8] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[9] . ' ' . _LVOTES . ' (' . $rvvpercent[9] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[9] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $rvv[10] . ' ' . _LVOTES . ' (' . $rvvpercent[10] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $rvvchartheight[10] . '"') . '</td>'
             . "</tr>"
             . "<tr><td colspan=\"10\" class=\"bgcolor2\">"
             . "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"200\"><tr>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">1</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">2</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">3</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">4</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">5</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">6</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">7</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">8</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">9</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">10</font></td>"
             . "</tr></table>"
             . "</td></tr></table>";
        }
        echo "</td>"
         . "</tr>"
         . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _DOWNLOADRATING . ": $avgRU</font></td></tr>"
         . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _HIGHRATING . ": $topreg</font></td></tr>"
         . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _LOWRATING . ": $bottomreg</font></td></tr>"
         . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _NUMOFCOMMENTS . ": $truecomments</font></td></tr>"
         . "<tr><td></td></tr>"
         . "<tr><td valign=\"top\" colspan=\"2\"><font class=\"tiny\"><br /><br />" . _WEIGHNOTE . " $anonweight " . _DLTO . " 1.</font></td></tr>"
         . "<tr><td colspan=\"2\" class=\"bgcolor2\"><font class=\"content\"><b>" . _UNREGISTEREDUSERS . "</b></font></td></tr>"
         . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _NUMBEROFRATINGS . ": $anonvotes</font></td>"
         . "<td rowspan=\"5\" width=\"200\">";
        if ($anonvotes == 0) {
            echo "<center><font class=\"content\">" . _NOUNREGUSERSVOTES . "</font></center>";
        } else {
            echo "<table border=\"1\" width=\"200\">"
             . "<tr>"
             . "<td valign=\"top\" align=\"center\" colspan=\"10\" class=\"bgcolor2\"><font class=\"content\">" . _BREAKDOWNBYVAL . "</font></td>"
             . "</tr>"
             . "<tr>"
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[1] . ' ' . _LVOTES . ' (' . $avvpercent[1] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[1] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[2] . ' ' . _LVOTES . ' (' . $avvpercent[2] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[2] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[3] . ' ' . _LVOTES . ' (' . $avvpercent[3] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[3] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[4] . ' ' . _LVOTES . ' (' . $avvpercent[4] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[4] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[5] . ' ' . _LVOTES . ' (' . $avvpercent[5] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[5] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[6] . ' ' . _LVOTES . ' (' . $avvpercent[6] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[6] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[7] . ' ' . _LVOTES . ' (' . $avvpercent[7] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[7] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[8] . ' ' . _LVOTES . ' (' . $avvpercent[8] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[8] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[9] . ' ' . _LVOTES . ' (' . $avvpercent[9] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[9] . '"') . '</td>'
             . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $avv[10] . ' ' . _LVOTES . ' (' . $avvpercent[10] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $avvchartheight[10] . '"') . '</td>'
             . "</tr>"
             . "<tr><td colspan=\"10\" class=\"bgcolor2\">"
             . "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"200\"><tr>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">1</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">2</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">3</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">4</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">5</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">6</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">7</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">8</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">9</font></td>"
             . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">10</font></td>"
             . "</tr></table>"
             . "</td></tr></table>";
        }
        echo "</td>"
         . "</tr>"
         . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _DOWNLOADRATING . ": $avgAU</font></td></tr>"
         . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _HIGHRATING . ": $topanon</font></td></tr>"
         . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _LOWRATING . ": $bottomanon</font></td></tr>"
         . "<tr><td class=\"bgcolor1\"><font class=\"content\">&nbsp;</font></td></tr>";
        if ($useoutsidevoting == 1) {
            echo "<tr><td valign=top colspan=\"2\"><font class=\"tiny\"><br /><br />" . _WEIGHOUTNOTE . " $outsideweight " . _DLTO . " 1.</font></td></tr>"
             . "<tr><td colspan=\"2\" class=\"bgcolor2\"><font class=\"content\"><b>" . _OUTSIDEVOTERS . "</b></font></td></tr>"
             . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _NUMBEROFRATINGS . ": $outsidevotes</font></td>"
             . "<td rowspan=\"5\" width=\"200\">";
            if ($outsidevotes == 0) {
                echo "<center><font class=\"content\">" . _NOOUTSIDEVOTES . "</font></center>";
            } else {
                echo "<table border=\"1\" width=\"200\">"
                 . "<tr>"
                 . "<td valign=\"top\" align=\"center\" colspan=\"10\" class=\"bgcolor2\"><font class=\"content\">" . _BREAKDOWNBYVAL . "</font></td>"
                 . "</tr>"
                 . "<tr>"
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[1] . ' ' . _LVOTES . ' (' . $ovvpercent[1] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[1] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[2] . ' ' . _LVOTES . ' (' . $ovvpercent[2] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[2] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[3] . ' ' . _LVOTES . ' (' . $ovvpercent[3] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[3] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[4] . ' ' . _LVOTES . ' (' . $ovvpercent[4] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[4] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[5] . ' ' . _LVOTES . ' (' . $ovvpercent[5] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[5] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[6] . ' ' . _LVOTES . ' (' . $ovvpercent[6] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[6] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[7] . ' ' . _LVOTES . ' (' . $ovvpercent[7] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[7] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[8] . ' ' . _LVOTES . ' (' . $ovvpercent[8] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[8] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[9] . ' ' . _LVOTES . ' (' . $ovvpercent[9] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[9] . '"') . '</td>'
                 . '<td class="bgcolor1" valign="bottom">' . mxCreateImage('images/blackpixel.gif', $ovv[10] . ' ' . _LVOTES . ' (' . $ovvpercent[10] . '% ' . _LTOTALVOTES . ')', 0, 'width="15" height="' . $ovvchartheight[10] . '"') . '</td>'
                 . "</tr>"
                 . "<tr><td colspan=\"10\" class=\"bgcolor2\">"
                 . "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"200\"><tr>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">1</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">2</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">3</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">4</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">5</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">6</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">7</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">8</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">9</font></td>"
                 . "<td width=\"10%\" valign=\"bottom\" align=\"center\"><font class=\"content\">10</font></td>"
                 . "</tr></table>"
                 . "</td></tr></table>";
            }
            echo "</td>"
             . "</tr>"
             . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _DOWNLOADRATING . ": $avgOU</font></td></tr>"
             . "<tr><td class=\"bgcolor1\"><font class=\"content\">" . _HIGHRATING . ": $topoutside</font></td></tr>"
             . "<tr><td class=\"bgcolor2\"><font class=\"content\">" . _LOWRATING . ": $bottomoutside</font></td></tr>"
             . "<tr><td class=\"bgcolor1\"><font class=\"content\">&nbsp;</font></td></tr>";
        }
        echo "</table>";
    }
    CloseTable();
    include(PMX_MODULES_DIR . DS . $module_name . '/includes/footer.php');
}

?>