<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1018 $
 * $Author: PragmaMx $
 * $Date: 2024-04-01 19:50:50 +0200 (Mo, 01 Apr 2024) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminency')) {
    mxErrorScreen("Access Denied");
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);

/* Alphabet abhängig von Sprache ermitteln */
function get_alphabet()
{
    $alphabet = array();

    if (!_SPECIALCHARS_ONLY) {
        for ($i = 65; $i <= 90; $i++) {
            $alphabet[] = chr($i);;
        }
    }

    /* Sonderzeichen aus Sprachdatei, aber nur die, die auch als Gross-Zeichen existieren, also nicht das ß */
    include_once(UTF8 . DS . 'str_split.php');
    $uppers = (array) utf8_str_split(utf8_strtoupper(_SPECIALCHARS));
    $lowers = (array) utf8_str_split(utf8_strtolower(_SPECIALCHARS));
    $more = array_unique(array_diff($uppers, $lowers));

    $alphabet = array_merge($alphabet, $more, range(1, 9));
    $alphabet[] = 0;

    return $alphabet;
}

/* Builds the alphabetic sorting-options, index-page */
function alpha($eid)
{
    global $module_name, $prefix;

    $alphabet = get_alphabet();
    $num = count($alphabet) - 1;
    $half = ceil($num / 2);

    $result = sql_query("SELECT DISTINCT UPPER(LEFT(title, 1)) from " . $prefix . "_encyclopedia_text WHERE eid=" . intval($eid));
    while (list($letter) = sql_fetch_row($result)) {
        $titles[$letter] = $letter;
    }

    echo "<center>[ ";
    $counter = 0;
    foreach ($alphabet as $ltr) {
        if (isset($titles[$ltr])) {
            echo "<a href=\"" . adminUrl(PMX_MODULE, 'terms', 'eid=' . $eid . '&amp;ltr=' . $ltr) . "\">$ltr</a>";
        } else {
            echo $ltr;
        }
        if ($counter == $half) {
            echo " ]\n<br />\n[ ";
        } elseif ($counter != $num) {
            echo "&nbsp;|&nbsp;";
        }
        $counter++;
    }
    echo " ]</center><br /><br />\n";
}

function encyclopedia()
{
    global $prefix;
    $img_activate = mxCreateImage('images/deactivate.gif', _ACTIVATE, array('title' => _ACTIVATE));
    $img_deactivate = mxCreateImage('images/activate.gif', _DEACTIVATE, array('title' => _DEACTIVATE));
    $img_delete = mxCreateImage("images/delete.gif", _DELETE, 0, 'title="' . _DELETE . '"');
    $img_edit = mxCreateImage("images/edit.gif", _EDIT, 0, 'title="' . _EDIT . '"');
    include('header.php');

    title(_ENCYCLOPEDIAMANAGER);

    echo '
    <table class="full list">
      <thead>
        <tr>
          <th>' . _TITLE . '</th>
          <th>' . _TERMS . '</th>
          <th>' . _CURRENTSTATUS . '</th>
          <th>' . _LANGUAGE . '</th>
          <th>' . _FUNCTIONS . '</th>
        </tr>
      </thead>
      <tbody>';
    $class = '';
    $out = '';
    $result = sql_query("select * from " . $prefix . "_encyclopedia order by eid");
    while ($ency = sql_fetch_array($result)) {
        $num = sql_num_rows(sql_query("select * from " . $prefix . "_encyclopedia_text WHERE eid='$ency[eid]'"));
        $lang = (empty($ency['elanguage'])) ? _ALL : mxGetLanguageString($ency['elanguage']);
        if ($ency["active"] == 1) {
            $status = _ACTIVE;
            $status_chng = $img_deactivate;
            $active = 1;
        } else {
            $status = _INACTIVE;
            $status_chng = $img_activate;
            $active = 0;
        }
        $class = ($class == '') ? ' class="alternate-a"' : '';
        $out .= '
        <tr' . $class . '>
          <td><a href="modules.php?name=' . PMX_MODULE . '&amp;op=list_content&amp;eid=' . $ency['eid'] . '">' . $ency['title'] . '</a></td>
          <td>' . $num . '</td>
          <td>' . $status . '</td>
          <td>' . $lang . '</td>
          <td>
            <a href="' . adminUrl(PMX_MODULE, 'edit', 'eid=' . $ency['eid']) . '">' . $img_edit . '</a>&nbsp;
            <a href="' . adminUrl(PMX_MODULE, 'change_status', 'eid=' . $ency['eid'] . '&amp;active=' . $active) . '">' . $status_chng . '</a>&nbsp;
            <a href="' . adminUrl(PMX_MODULE, 'delete', 'eid=' . $ency['eid']) . '">' . $img_delete . '</a>
          </td>
        </tr>';
    }
    if ($out) {
        echo $out;
    } else {
        echo '
        <tr><td colspan="4"></td></tr>';
    }
    echo '
      </tbody>
    </table>';

    $editor = load_class('Textarea');

    echo "<fieldset><legend>" . _ADDNEWENCYCLOPEDIA . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . ":</b>&nbsp;"
     . "<input type=\"text\" name=\"title\" size=\"50\" /><br /><br />"
     . "<b>" . _DESCRIPTION . ":</b><br />" . $editor->getHtml(array('name' => 'enzydesc', 'height' => '250')) . "<br /><br />";
    if ($GLOBALS['multilingual']) {
        echo '<br /><b>' . _LANGUAGE . ": </b>" . mxLanguageSelect('elanguage', $GLOBALS['currentlang'], 'language', true) . '<br /><br />';
    } else {
        echo "<input type=\"hidden\" name=\"elanguage\" value=\"\" />";
    }
    echo "<b>" . _ACTIVATEPAGE . "</b>&nbsp;"
     . "<input type=\"radio\" name=\"active\" value=\"1\" checked=\"checked\" />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"active\" value=\"0\" />&nbsp;" . _NO . '<br /><br />'
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/save\" />"
     . "<input type=\"submit\" value=\"" . _ADD . "\" />"
     . "</form></fieldset>";

    $result = sql_query("select eid, title from " . $prefix . "_encyclopedia");
    if (sql_num_rows($result) > 0) {
        echo '<br />';

        echo "<fieldset><legend>" . _ADDNEWENCYTERM . "</legend>"
         . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
         . "<b>" . _ENCYCLOPEDIA . ":</b>&nbsp;<select name=\"eid\">";
        while (list($eid, $title) = sql_fetch_row($result)) {
            echo "<option value=\"$eid\">$title</option>";
        }
        echo "</select><br /><br />"
         . "<b>" . _TITLE . ":</b>&nbsp;<input type=\"text\" name=\"title\" size=\"50\" /><br /><br />"
         . "<b>" . _TERMTEXT . ":</b><br />" . $editor->getHtml(array('name' => 'text', 'height' => '250', 'pagebreak' => true)) . "<br /><br />"
         . "<b>" . _AUTOLINK . ":</b>&nbsp;"
         . "<input type=\"radio\" name=\"autolink\" value=\"1\" checked=\"checked\" />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"autolink\" value=\"0\" />&nbsp;" . _NO . '<br /><br />'
         . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/text_save\" />"
         . "<input type=\"submit\" value=\"" . _ADD . "\" />"
         . "</form></fieldset>";
    }

    $result = sql_query("select eid, title from " . $prefix . "_encyclopedia");
    $options = array();
    while (list($eid, $title) = sql_fetch_row($result)) {
        $options[] = "<option value=\"$eid\">$title</option>";
    }
    if (count($options) > 1) {
        echo '<br />';

        echo "<fieldset><legend>" . _MOVETERMS . "</legend>"
         . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
         . _MOVEALLTERMSFROM . ": <select name=\"eid\">" . implode("\n", $options) . "</select>&nbsp;"
         . _TO . ": <select name=\"new_eid\">" . implode("\n", $options) . "</select>"
         . "&nbsp;&nbsp;<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/move_terms\" />"
         . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" />"
         . "</form></fieldset>";
    }
    include("footer.php");
}

function encyclopedia_edit($eid)
{
    global $prefix,$currentlang;
    $result = sql_query("select * from " . $prefix . "_encyclopedia WHERE eid='$eid'");
    $ency = sql_fetch_array($result);
    if ($ency["active"] == 1) {
        $sel1 = 'checked="checked"';
        $sel2 = "";
    } else {
        $sel1 = "";
        $sel2 = 'checked="checked"';
    }
	
	$ency['elanguage']=(trim($ency['elanguage'])=="")?$currentlang:$ency['elanguage'];
	
    $editor = load_class('Textarea', array('name' => 'enzydesc', 'value' => $ency['description'], 'height' => '250'));
    include("header.php");

    title(_ENCYCLOPEDIAMANAGER);

    echo "<fieldset><legend>" . _EDITENCYCLOPEDIA . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _TITLE . ":</b>&nbsp;"
     . "<input type=\"text\" name=\"title\" size=\"50\" value=\"" . mxentityquotes($ency['title']) . "\" /><br /><br />"
     . "<b>" . _DESCRIPTION . ":</b><br />";
    $editor->show();
    echo '<br /><br />';
    if ($GLOBALS['multilingual']) {
        echo '<br /><b>' . _LANGUAGE . ": </b>" . mxLanguageSelect('elanguage', $ency['elanguage'], 'language', true) . '<br /><br />';
    } else {
        echo "<input type=\"hidden\" name=\"elanguage\" value=\"$ency[elanguage]\" />";
    }
    echo "<b>" . _ACTIVATEPAGE . "</b>&nbsp;"
     . "<input type=\"radio\" name=\"active\" value=\"1\" $sel1 />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"active\" value=\"0\" $sel2 />&nbsp;" . _NO . '<br /><br />'
     . "<input type=\"hidden\" name=\"eid\" value=\"$ency[eid]\" />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/edit_save\" />"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" />"
     . "</form></fieldset>";

    echo '<br />';
    echo "<fieldset><legend>" . _ENCYTERMSEDIT . "</legend>";
    alpha($eid);
    echo '</fieldset>';

    include("footer.php");
}

function encyclopedia_terms($eid, $ltr)
{
    global $prefix;
    include("header.php");

    title(_ENCYCLOPEDIAMANAGER);
    $result = sql_query("select title from " . $prefix . "_encyclopedia where eid=" . intval($eid) . " AND UPPER(title) LIKE '%$ltr%'");
    list($title) = sql_fetch_row($result);
    title("$title");

    echo "<center>" . _SELECTONETERM . "</center><br /><br />"
     . "<table align=\"center\">";
    $result = sql_query("select tid, title from " . $prefix . "_encyclopedia_text WHERE UPPER(title) LIKE '$ltr%' AND eid=" . intval($eid) . " ORDER BY title");
    if (sql_num_rows($result) == 0) {
        echo "<center><i>" . _NOCONTENTFORLETTER . " $ltr.</i></center>";
    } while (list($tid, $title) = sql_fetch_row($result)) {
        echo "<tr><td><a href=\"" . adminUrl(PMX_MODULE, 'text_edit', 'tid=' . $tid) . "\">$title</a></td></tr>";
    }
    echo "</table><br /><br />";
    alpha($eid);
    echo "<center>" . _GOBACK . "</center>";

    include("footer.php");
}

function encyclopedia_text_edit($tid)
{
    global $prefix;
    $result = sql_query("select * from " . $prefix . "_encyclopedia_text WHERE tid='$tid'");
    $ency = sql_fetch_array($result);
    switch ($ency['autolink']) {
        case 0:
            $linkon = "";
            $linkof = 'checked="checked"';
            break;
        default:
            $linkon = 'checked="checked"';
            $linkof = "";
    }
    $editor = load_class('Textarea', array('name' => 'text', 'value' => $ency['text'], 'height' => '250', 'pagebreak' => true));

    include("header.php");

    title(_ENCYCLOPEDIAMANAGER);

    echo "<center><b>" . _ENCYTERMSEDIT . "</b></center><br /><br />"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\">"
     . "<b>" . _CHANGETOENCY . ":</b>&nbsp;"
     . "<select name=\"eid\">";
    $result = sql_query("select eid, title from " . $prefix . "_encyclopedia");
    while (list($eid, $title) = sql_fetch_row($result)) {
        if ($eid == $ency['eid']) {
            $sel = 'selected="selected" class="current"';
        } else {
            $sel = "";
        }
        echo "<option value=\"$eid\" $sel>$title</option>";
    }
    echo "</select><br /><br />"
     . "<b>" . _TITLE . ":</b>&nbsp;<input type=\"text\" name=\"title\" size=\"50\" value=\"$ency[title]\" /><br /><br />"
     . "<b>" . _TERMTEXT . ":</b><br />" . $editor->getHtml() . "<br /><br />"
     . "<b>" . _AUTOLINK . ":</b>&nbsp;"
     . "<input type=\"radio\" name=\"autolink\" value=\"1\" $linkon />&nbsp;" . _YES . "&nbsp;&nbsp;<input type=\"radio\" name=\"autolink\" value=\"0\" $linkof />&nbsp;" . _NO . '<br /><br />'
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/text_edit_save\" />"
     . "<input type=\"hidden\" name=\"tid\" value=\"$tid\" />"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\" /> &nbsp;&nbsp; [&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'text_delete', 'tid=' . $tid . '&amp;ok=0') . "\">" . _DELETE . "</a>&nbsp;]"
     . "</form>";

    include("footer.php");
}

function encyclopedia_save($title, $enzydesc, $elanguage, $active)
{
    global $prefix;
    sql_query("insert into " . $prefix . "_encyclopedia values(NULL, '" . mxAddSlashesForSQL($title) . "', '" . mxAddSlashesForSQL($enzydesc) . "', '" . mxAddSlashesForSQL($elanguage) . "', '" . mxAddSlashesForSQL($active) . "')");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function encyclopedia_text_save($eid, $title, $text, $autolink)
{
    global $prefix;
    sql_query("insert into " . $prefix . "_encyclopedia_text set eid=" . intval($eid) . ", title='" . mxAddSlashesForSQL($title) . "', text='" . mxAddSlashesForSQL($text) . "', autolink='" . intval($autolink) . "' ");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function encyclopedia_edit_save($eid, $title, $enzydesc, $elanguage, $active)
{
    global $prefix;
    sql_query("update " . $prefix . "_encyclopedia set title='" . mxAddSlashesForSQL($title) . "', description='" . mxAddSlashesForSQL($enzydesc) . "', elanguage='" . mxAddSlashesForSQL($elanguage) . "', active='" . intval($active) . "' where eid=" . intval($eid));
    return mxRedirect(adminUrl(PMX_MODULE));
}

function encyclopedia_text_edit_save($tid, $eid, $title, $text, $autolink)
{
    global $prefix;
    sql_query("update " . $prefix . "_encyclopedia_text set eid=" . intval($eid) . ", title='" . mxAddSlashesForSQL($title) . "', text='" . mxAddSlashesForSQL($text) . "', autolink='" . intval($autolink) . "' WHERE tid='" . intval($tid) . "'");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function encyclopedia_change_status($eid, $active)
{
    global $prefix;
    if ($active == 1) {
        $new_active = 0;
    } elseif ($active == 0) {
        $new_active = 1;
    }
    sql_query("update " . $prefix . "_encyclopedia set active='$new_active' WHERE eid=" . intval($eid));
    return mxRedirect(adminUrl(PMX_MODULE));
}

function encyclopedia_delete($eid, $ok = 0)
{
    global $prefix;
    if ($ok == 1) {
        sql_query("delete from " . $prefix . "_encyclopedia where eid=" . intval($eid));
        sql_query("delete from " . $prefix . "_encyclopedia_text where eid=" . intval($eid));
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include("header.php");

        title(_ENCYCLOPEDIAMANAGER);
        $result = sql_query("select title from " . $prefix . "_encyclopedia where eid=" . intval($eid));
        list($title) = sql_fetch_row($result);
        OpenTableAl();
        echo "<center><b>" . _DELENCYCLOPEDIA . ": $title</b><br /><br />"
         . _DELENCYCONTWARNING . '<br /><br />'
         . "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a> | <a href=\"" . adminUrl(PMX_MODULE, 'delete', 'eid=' . $eid . '&amp;ok=1') . "\">" . _YES . "</a>&nbsp;]</center>";
        CloseTableAl();
        include("footer.php");
    }
}

function encyclopedia_text_delete($tid, $ok = 0)
{
    global $prefix;
    if ($ok == 1) {
        sql_query("delete from " . $prefix . "_encyclopedia_text where tid='" . intval($tid) . "'");
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include("header.php");

        title(_ENCYCLOPEDIAMANAGER);
        $result = sql_query("select title from " . $prefix . "_encyclopedia_text where tid='" . intval($tid) . "'");
        list($title) = sql_fetch_row($result);

        echo "<center><b>" . _DELENCYCLOPEDIATEXT . ": $title</b><br /><br />"
         . _DELENCYTEXTWARNING . '<br /><br />'
         . "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a> | <a href=\"" . adminUrl(PMX_MODULE, 'text_delete', 'tid=' . $tid . '&amp;ok=1') . "\">" . _YES . "</a>&nbsp;]</center>";

        include("footer.php");
    }
}

function encyclopedia_move_terms($eid, $new_eid)
{
    global $prefix;
    $result = sql_query("select tid from " . $prefix . "_encyclopedia_text WHERE eid=" . intval($eid));
    while (list($tid) = sql_fetch_row($result)) {
        sql_query("update " . $prefix . "_encyclopedia_text set eid='$new_eid' WHERE tid='" . intval($tid) . "'");
    }
    return mxRedirect(adminUrl(PMX_MODULE));
}

$ok = (empty($ok)) ? 0 : 1;
switch ($op) {
    case PMX_MODULE . "/move_terms":
        encyclopedia_move_terms($eid, $new_eid);
        break;

    case PMX_MODULE . "/terms":
        encyclopedia_terms($eid, $ltr);
        break;

    case PMX_MODULE . "/edit":
        encyclopedia_edit($eid);
        break;

    case PMX_MODULE . "/text_edit":
        encyclopedia_text_edit($tid);
        break;

    case PMX_MODULE . "/delete":
        encyclopedia_delete($eid, $ok);
        break;

    case PMX_MODULE . "/text_delete":
        encyclopedia_text_delete($tid, $ok);
        break;

    case PMX_MODULE . "/save":
        encyclopedia_save($title, $enzydesc, $elanguage, $active);
        break;

    case PMX_MODULE . "/text_save":
        encyclopedia_text_save($eid, $title, $text, $autolink);
        break;

    case PMX_MODULE . "/edit_save":
        encyclopedia_edit_save($eid, $title, $enzydesc, $elanguage, $active);
        break;

    case PMX_MODULE . "/text_edit_save":
        encyclopedia_text_edit_save($tid, $eid, $title, $text, $autolink);
        break;

    case PMX_MODULE . "/change_status":
        encyclopedia_change_status($eid, $active);
        break;

    default:
        encyclopedia();
        break;
}

?>