<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*

# Enzyklopedia

RewriteRule ^Encyclopedia-title-.*-([0-9]+)(-.*)?\.html$ mod.php?name=Encyclopedia&op=list_content&eid=$1&_MORE_=$2 [L]
RewriteRule ^Encyclopedia-list-.*-([0-9]+)(-.*)?\.html$ mod.php?name=Encyclopedia&op=terms&eid=$1&_MORE_=$2 [L]
RewriteRule ^Encyclopedia-.*-item-([0-9]+)(-.*)?\.html$ mod.php?name=Encyclopedia&op=content&tid=$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $eidc = array();
    $cid = array();
    $pid = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case ((isset($para['op']) && $para['op'] == 'list_content') && (isset($para['eid']) && intval($para['eid']))):
                $eidc[0][] = $para['eid'];
                $eidc[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'terms') && (isset($para['eid']) && intval($para['eid']))):
                $cid[0][] = $para['eid'];
                $cid[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'content') && (isset($para['tid']) && intval($para['tid']))):
                $pid[0][] = $para['tid'];
                $pid[$key] = $para;
                break;
        }
    }

    /**
     */
    if ($eidc) {
        $inquery = implode(',', array_unique(array_shift($eidc)));
        $qry = "SELECT eid, title FROM {$prefix}_encyclopedia WHERE eid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($eid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$eid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($eidc as $key => $link) {
            if (isset($titles[$link['eid']])) {
                /**
                 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
                 * also getrennt mit den Bindestrichen
                 * Einstellung:
                 * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
                 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
                 * übergeben
                 */
                $new_url = pmxModrewrite::title_parameters($link, 'eid', 'op');
                /**
                 * den neuen URL zusammensetzen
                 * Einstellung:
                 * nach belieben zusammensetzen und entspr. die .htaccess anpassen
                 */
                // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
                $new_url = $name . '-title-' . $titles[$link['eid']] . '-' . $link['eid'] . $new_url;
                /**
                 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
                 * Einstellung: keine, muss exakt so bleiben!
                 */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /**
     */
    if ($pid) {
        $inquery = implode(',', array_unique(array_shift($pid)));
        $qry = "SELECT tid, title FROM {$prefix}_encyclopedia_text WHERE tid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($tid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$tid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($pid as $key => $link) {
            if (isset($titles[$link['tid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'tid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['tid']] . '-item-' . $link['tid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /*
         */

    if ($cid) {
        $inquery = implode(',', array_unique(array_shift($cid)));
        $qry = "SELECT eid, title FROM {$prefix}_encyclopedia WHERE eid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($eid, $title) = sql_fetch_row($result)) {
            $titles[$eid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($cid as $key => $link) {
            if (isset($titles[$link['eid']])) {
                $new_url = pmxModrewrite::title_parameters($link, 'op', 'eid');
                $new_url = $name . '-list-' . $titles[$link['eid']] . '-' . $link['eid'] . $new_url;
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }
}

?>