<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 660 $
 * $Author: PragmaMx $
 * $Date: 2022-12-18 11:34:03 +0100 (So, 18. Dez 2022) $
 *
 * this file based on:
 * Automated FAQ
 * Copyright ©2001 by Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * and Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminfaq')) {
    mxErrorScreen('Access Denied');
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);
// mxSessionSetVar('panel', MX_ADMINPANEL_CONTENT);
function FaqAdmin()
{
    global $prefix, $currentlang, $language;
    $img_content = mxCreateImage("images/clippings.gif", _CONTENT, array('title' => _CONTENT));
    $img_order = mxCreateImage("images/posticon.gif", _ORDER, array('title' => _ORDER));
    $img_delete = mxCreateImage("images/delete.gif", _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage("images/edit.gif", _EDITCATEGORY, array('title' => _EDITCATEGORY));
    include ("header.php");
    mxIncludeHeader();
    title(_FAQADMIN);
    $res = sql_query("select count(faq_id) from {$prefix}_faqnew");
    list($numFaqs) = sql_fetch_row($res);
    if ($numFaqs) {
        OpenTable();
        echo "<br>" . _NEWADD1 . " " . $numFaqs . " " . _NEWADD2 . "<br>\n<a href='" . adminUrl(PMX_MODULE, 'AnswerNew') . "'>" . _NEWADD3 . "</a>";
        CloseTable();
        echo "<br>";
    }

    OpenTable();
    echo '
    <p style="text-align:center"><strong>' . _ACTIVEFAQS . '</strong></p>
    <table class="full list">
      <thead>
        <tr>
          <th>' . _ID . '</th>
          <th>' . _CATEGORIES . '</th>
          <th>' . _LANGUAGE . '</th>
          <th>' . _FUNCTIONS . '</th>
        </tr>
      </thead>
      <tbody>';
    $class = '';
    $out = '';
    $result = sql_query("SELECT id_cat, categories, flanguage FROM {$prefix}_faqcategories ORDER BY id_cat");
    while (list($id_cat, $categories, $flanguage) = sql_fetch_row($result)) {
        if (!$flanguage) {
            $flanguage = _ALL;
        }
        $class = ($class == '') ? ' class="alternate-a"' : '';
        $out .= '
        <tr' . $class . '>
          <td>' . $id_cat . '</td>
          <td>' . $categories . '</td>
          <td>' . $flanguage . '</td>
          <td>
            <a href="' . adminUrl(PMX_MODULE, 'CatGo', 'id_cat=' . $id_cat) . '">' . $img_content . '</a>&nbsp;
            <a href="' . adminUrl(PMX_MODULE, 'CatGo', 'id_cat=' . $id_cat . '&amp;reorder=y') . '">' . $img_order . '</a>&nbsp;
            <a href="' . adminUrl(PMX_MODULE, 'CatEdit', 'id_cat=' . $id_cat) . '">' . $img_edit . '</a>&nbsp;
            <a href="' . adminUrl(PMX_MODULE, 'CatDel', 'id_cat=' . $id_cat . '&amp;ok=0') . '">' . $img_delete . '</a>
          </td>
        </tr>';
    }
    if (strlen($out)) {
        echo $out;
    } else {
        echo '<tr><td colspan="4">&nbsp;</td></tr>';
    }
    echo '
      </tbody>
    </table>';
    CloseTable();
    OpenTable();
    echo '
    <fieldset><legend>' . _ADDCATEGORY . '</legend>
      <form action="' . adminUrl(PMX_MODULE) . '" method="post" style="display:block;width:100%;">
        <table width="100%">
          <tr valign="top">
            <td width="20%">' . _CATEGORIES . ':</td>
            <td><input type="text" name="categories" size="30" maxlength="255" /></td>
          </tr>';
    if ($GLOBALS['multilingual']) {
        echo '
          <tr valign="top">
            <td>' . _LANGUAGE . ':</td>
            <td>' . mxLanguageSelect('flanguage', $flanguage, 'language', 1) . '</td>
          </tr>
          <tr>
            <td colspan="2">';
    } else {
        echo '
          <tr>
            <td colspan="2"><input type="hidden" name="flanguage" value="" />';
    }
    echo '
              <input type="hidden" name="op" value="' . PMX_MODULE . '/CatAdd" />
              <input type="submit" value="' . _SAVE . '" />
            </td>
          </tr>
        </table>
      </form>
    </fieldset>';
    CloseTable();
    mxIncludeFooter();
}

function FaqCatGo($id_cat)
{
    global $prefix, $cut, $paste, $reorder, $movecat, $bgcolor1, $bgcolor2, $bgcolor3;

    if ($cut != '') {
        $reorder = 'y';
        if ($paste != '') {
            FaqCatReorder($id_cat);
        } else if ($movecat != '') {
            FaqMoveCat($id_cat, $cut, $movecat);
        }
    }
    $result = sql_query("SELECT id, question, answer FROM {$prefix}_faqanswer WHERE id_cat='$id_cat' ORDER BY id");

    include('header.php');
    GraphicAdmin();
    title(_FAQADMIN);
    OpenTable();
    if ($reorder) {
        $text = _SHOWALL;
        $link = adminUrl(PMX_MODULE, "CatGo", "id_cat=$id_cat");
    } else {
        $text = _ONLYQUEST;
        $link = adminUrl(PMX_MODULE, "CatGo", "id_cat=$id_cat&amp;reorder=y");
    }
    echo "<p style=\"text-align:center\"><strong>" . _QUESTIONS
     . " [&nbsp;<a href='" . $link . "'>" . $text . "</a>&nbsp;]"
     . "</strong></p>"
     . "<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor1 full\"><tr class=\"bgcolor2\">"
     . "<th class=\"bgcolor2\">" . _CONTENT . "</th>"
     . "<th class=\"bgcolor2\">" . _FUNCTIONS . "</th></tr>";

    while (list($id, $question, $answer) = sql_fetch_row($result)) {
        echo "<tr valign=\"top\" class=\"bgcolor3\"><td>";
        $catstyle = ($cut != '' and $cut == $id) ? " style='color:red'" : "";
        if ($reorder) {
            echo "<span $catstyle>$question</span><br>";
        } else {
            echo "<center><i $catstyle>$question</i></center><br>";
        }
        if ($catstyle) {
            echo "<b>" . _PASTE . "</b>";
        }
        if (!$reorder) {
            echo "<br><p align=justify $catstyle>" . mxNL2BR($answer) . "</p>\n";
        }

        echo "</td>\n"
         . "<td>"
         . "<strong><big>&middot;</big></strong>&nbsp;<a $catstyle href=\"" . adminUrl(PMX_MODULE, 'CatGoEdit', "id=$id") . "\">" . _EDIT . "</a><br>";

        if ($cut == '') {
            echo "<strong><big>&middot;</big></strong>&nbsp;<a $catstyle href=\"" . adminUrl(PMX_MODULE, 'CatGo', "id_cat=$id_cat&amp;cut=$id") . "\">" . _CUT . "</a><br>";
        } else {
            if ($catstyle != '')
                echo "<strong><big>&middot;</big></strong>&nbsp;<a $catstyle href=\"" . adminUrl(PMX_MODULE, 'CatGo', "id_cat=$id_cat&amp;reorder=y") . "\">" . _ABORT . "</a><br>";
            else
                echo "<strong><big>&middot;</big></strong>&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'CatGo', "id_cat=$id_cat&amp;cut=$cut&amp;paste=$id") . "\">" . _PASTE . "</a><br>";
        }

        echo "<strong><big>&middot;</big></strong>&nbsp;<a $catstyle href=\"" . adminUrl(PMX_MODULE, 'CatGoDel', 'id=' . $id . '&amp;ok=0') . "\">" . _DELETE . "</a><br>"
         . "</td></tr>";
    }

    if ($cut != '') {
        echo "<tr valign='top'><td><b>" . _PASTTO . "</b></td>"
         . "<td align=\"center\">"
         . "<a $catstyle href='" . adminUrl(PMX_MODULE, "CatGo", "id_cat=$id_cat&amp;cut=$cut&amp;paste=end") . "'>" . _FAQPASTE . "</a></td></tr>\n";
        if ($movecat == '') FaqMoveCat($id_cat, $cut);
    }

    echo "</table>";
    CloseTable();
    echo "<br>";
    OpenTable();
    $editor = load_class('Textarea', array('name' => 'answer', 'height' => '300'));
    echo "<fieldset><legend>" . _ADDQUESTION . "</legend>"
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\" style=\"display:block;width;100%\">"
     . "<table width=\"100%\"><tr valign='top'><td>"
     . _QUESTION . ":</td><td><input type=\"text\" name=\"question\" size=\"40\" /></td></tr><tr valign='top'>"
     . "<td colspan=\"2\">" . _ANSWER . "<br />" . $editor->getHtml() . "</td>"
     . "</tr></table>"
     . "<input type=\"hidden\" name=\"id_cat\" value=\"$id_cat\" />"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/CatGoAdd\" />"
     . "<input type=\"submit\" value=\"" . _SAVE . "\" /> " . _GOBACK . ""
     . "</form></fieldset>";
    CloseTable();
    include('footer.php');
}

function FaqCatEdit($id_cat)
{
    global $prefix;

    $result = sql_query("SELECT categories, flanguage FROM {$prefix}_faqcategories WHERE id_cat=" . $id_cat);
    list($categories, $flanguage) = sql_fetch_row($result);
    include ('header.php');
    GraphicAdmin();
    title(_FAQADMIN);
    OpenTable();
    echo '<fieldset><legend>' . _EDITCATEGORY . '</legend>'
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\" style=\"display:block;width;100%\">"
     . "<input type=\"hidden\" name=\"id_cat\" value=\"$id_cat\" />"
     . "<table width=\"100%\"><tr valign='top'><td>"
     . _CATEGORIES . ":</td><td><input type=\"text\" name=\"categories\" size=\"31\" value=\"" . mxentityquotes($categories) . "\" /></td>";
    if ($GLOBALS['multilingual']) {
        echo "<tr valign='top'><td>" . _LANGUAGE . ":</td><td>" . mxLanguageSelect('flanguage', $flanguage, 'language', 1) . "</td>";
    } else {
        echo "<input type=\"hidden\" name=\"flanguage\" value=\"\" />";
    }
    echo "</tr></table>"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/CatSave\" />"
     . "<input type=\"submit\" value=\"" . _SAVE . "\" /> " . _GOBACK . ""
     . "</form></fieldset>";
    CloseTable();
    include('footer.php');
}

function FaqCatGoEdit($id)
{
    global $prefix;

    $result = sql_query("SELECT question, answer, id_cat FROM {$prefix}_faqanswer WHERE id='$id'");
    list($question, $answer, $id_cat) = sql_fetch_row($result);
    $editor = load_class('Textarea', array('name' => 'answer', 'value' => $answer, 'height' => '300'));

    include ("header.php");
    GraphicAdmin();
    title(_FAQADMIN);
    OpenTable();
    echo '<fieldset><legend>' . _EDITQUESTIONS . '</legend>'
     . "<form action=\"" . adminUrl(PMX_MODULE) . "\" method=\"post\" style=\"display:block;width;100%\">"
     . "<input type=\"hidden\" name=\"id\" value=\"$id\" />"
     . "<input type=\"hidden\" name=\"id_cat\" value=\"$id_cat\" />"
     . "<table width=\"100%\"><tr valign='top'><td>"
     . _QUESTION . ":</td><td><input type=\"text\" name=\"question\" size=\"31\" value=\"" . mxentityquotes($question) . "\" /></td></tr><tr valign='top'>"
     . "<td colspan=\"2\">" . _ANSWER . "<br />" . $editor->getHtml() . "</td>"
     . "</tr></table>"
     . "<input type=\"hidden\" name=\"op\" value=\"" . PMX_MODULE . "/CatGoSave\" />"
     . "<input type=\"submit\" value=\"" . _SAVE . "\" /> " . _GOBACK . ""
     . "</form></fieldset>";
    CloseTable();
    include("footer.php");
}

function FaqCatSave($id_cat, $categories, $flanguage)
{
    global $prefix;
    $categories = mxAddSlashesForSQL(strip_tags($categories));
    sql_query("update {$prefix}_faqcategories set categories='" . $categories . "', flanguage='$flanguage' where id_cat='$id_cat'");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function FaqCatGoSave($id, $question, $answer, $id_cat = 0)
{
    global $prefix;
    $question = mxAddSlashesForSQL(strip_tags($question));
    $answer = mxAddSlashesForSQL(($answer));
    sql_query("update {$prefix}_faqanswer set question='" . $question . "', answer='$answer' where id='$id'");
    if ($id_cat) {
        return mxRedirect(adminUrl(PMX_MODULE, 'CatGo', "id_cat=$id_cat"));
    }
    return mxRedirect(adminUrl(PMX_MODULE));
}

/**
 * @param string $categories
 */
function FaqCatAdd($categories, $flanguage)
{
    global $prefix;
    $categories = mxAddSlashesForSQL(($categories));
    if (strlen($categories)) {
        sql_query("INSERT INTO {$prefix}_faqcategories VALUES (NULL, '$categories', '$flanguage')");
    }
    return mxRedirect(adminUrl(PMX_MODULE));
}

function FaqCatGoAdd($id_cat, $question, $answer)
{
    global $prefix;
    $question = mxAddSlashesForSQL(strip_tags($question));
    $answer = mxAddSlashesForSQL(($answer));
    sql_query("INSERT INTO {$prefix}_faqanswer VALUES (NULL, '$id_cat', '" . $question . "', '$answer')");
    return mxRedirect(adminUrl(PMX_MODULE, 'CatGo', "id_cat=$id_cat"));
}

function FaqCatDel($id_cat, $ok = 0)
{
    global $prefix;
    if ($ok == 1) {
        sql_query("delete from {$prefix}_faqcategories where id_cat=" . intval($id_cat));
        sql_query("delete from {$prefix}_faqanswer where id_cat=" . intval($id_cat));
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        $result = sql_query("select categories from {$prefix}_faqcategories WHERE id_cat=" . intval($id_cat));
        list($categories) = sql_fetch_row($result);
        include("header.php");
        GraphicAdmin();
        title(_FAQADMIN);
        OpenTableAl();
        echo "<br><center><p><b>" . _FAQDELWARNING . '</b></p><p>"' . $categories . '"</p><br>';
        echo "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'CatDel', 'id_cat=' . $id_cat . '&amp;ok=1') . "\">" . _YES . "</a> | <a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a>&nbsp;]</center><br><br>";
        CloseTableAl();
        include("footer.php");
    }
}

function FaqCatGoDel($id, $ok = 0)
{
    global $prefix;
    if ($ok == 1) {
        sql_query("delete from {$prefix}_faqanswer where id=" . intval($id));
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include("header.php");
        GraphicAdmin();
        title(_FAQADMIN);
        OpenTableAl();
        echo "<br><center><b>" . _QUESTIONDEL . "</b><br><br>";
        echo "[&nbsp;<a href=\"" . adminUrl(PMX_MODULE, 'CatGoDel', 'id=' . $id . '&amp;ok=1') . "\">" . _YES . "</a> | <a href=\"" . adminUrl(PMX_MODULE) . "\">" . _NO . "</a>&nbsp;]</center><br><br>";
        CloseTableAl();
        include("footer.php");
    }
}

function FaqCatReorder($id_cat)
{
    global $cut, $paste, $reorder;
    global $prefix;
    $result = sql_query("select * from {$prefix}_faqanswer where id_cat='" . intval($id_cat) . "' order by id");
    $rows = array();
    while ($row = sql_fetch_array($result))
    array_push($rows, $row);
    $numrows = count($rows);

    $faqdebugging = false;

    if ($faqdebugging) {
        OpenTable();
        echo "id_cat='$id_cat', cut='$cut', paste='$paste'<br><br>\n";
        for ($i = 0; $i < $numrows; $i++)
        echo $rows[$i]['id'] . ") " . $rows[$i]['question'] . "<br>\n";
        CloseTable();
    }

    $cutidx = FaqFindRow($rows, $cut);
    if ($paste != 'end' and $paste < $cut) {
        $pasteidx = FaqFindRow($rows, $paste);
        for ($i = $pasteidx; $i < $cutidx; $i++)
        $rows[$i]['id'] = $rows[$i + 1]['id'];
        $rows[$cutidx]['id'] = $paste;
    } else {
        if ($paste == 'end')
            $pasteidx = $numrows - 1;
        else
            $pasteidx = FaqFindRow($rows, $paste) - 1;
        $paste = $rows[$pasteidx]['id'];
        if ($cutidx >= $pasteidx)
            return;
        for ($i = $pasteidx; $i > $cutidx; $i--)
        $rows[$i]['id'] = $rows[$i-1]['id'];
        $rows[$cutidx]['id'] = $paste;
    }

    if ($faqdebugging) {
        OpenTable();
        for ($i = 0; $i < $numrows; $i++)
        echo $rows[$i]['id'] . ") " . $rows[$i]['question'] . "<br>\n";
        CloseTable();
        $cut = $paste = '';
        $reorder = 'y';
        return;
    }
    for ($i = 0; $i < $numrows; $i++) {
        $query = "UPDATE {$prefix}_faqanswer SET id=" . $rows[$i]['id']
         . " WHERE question='" . mxAddSlashesForSQL(strip_tags($rows[$i]['question'])) . "'"
         . " AND answer='" . mxAddSlashesForSQL($rows[$i]['answer']) . "'"
         . " AND id_cat='" . $rows[$i]['id_cat'] . "'";
        sql_query($query);
    }
    $cut = $paste = '';
    $reorder = 'y';
}

function FaqFindRow(&$rows, $id)
{
    foreach ($rows as $idx => $row)
    if ($row['id'] == $id)
        return $idx;
    die(__FILE__ . '::' . __FUNCTION__ . "(): can't find row id $id<br>\n");
}

function FaqMoveCat($id_cat, $cut, $movecat = '')
{
    global $prefix;
    global $cut, $paste, $reorder;

    if ($movecat == '') {
        $res = sql_query("select id_cat,categories from {$prefix}_faqcategories");
        $rows = array();
        while ($row = sql_fetch_array($res))
        array_push($rows, $row);

        echo "<tr valign='top'><td colspan=2 align=center><i>" . _MOVETO . "</i></td></tr>\n";
        foreach ($rows as $key => $row)
        echo "<tr valign='top'><td><i>" . $row['categories'] . "</i></td>\n"
         . "<td align=center><a href='" . adminUrl(PMX_MODULE, "CatGo", "id_cat=$id_cat&amp;cut=$cut&amp;movecat=" . $row['id_cat']) . "'>" . _PASTE . "</a></td></tr>\n";
    } else {
        sql_query("UPDATE {$prefix}_faqanswer SET id_cat='$movecat' WHERE id='$cut'")
        or mxErrorScreen(__FILE__ . "::" . __FUNCTION__ . "()");
        $cut = $paste = '';
        $reorder = 'y';
    }
}

function FaqAnswerNew()
{
    global $prefix, $sitename, $adminmail;

    if (!empty($_REQUEST['faq_id'])) {
        if ($_REQUEST['faqaction'] == 'decline') {
            sql_query("DELETE FROM {$prefix}_faqnew WHERE faq_id=" . (int)$_REQUEST['faq_id'] . "") or mxErrorScreen("" . _DIE1 . " $faq_id");
        } else if ($_REQUEST['faqaction'] == 'accept') {
            $res = sql_query("SELECT * FROM {$prefix}_faqnew WHERE faq_id='" . (int)$_REQUEST['faq_id'] . "'") or mxErrorScreen("" . _DIE2 . " $faq_id");
            $newq = sql_fetch_array($res, 0);
            $result = sql_query("select id_cat, categories from {$prefix}_faqcategories ORDER BY categories");
            while (list($idcat, $categorie) = sql_fetch_row($result)) {
                $sel = ((int)$newq['id_cat'] == (int)$idcat) ? ' selected="selected" class="current"' : '';
                $options[] = "<option value='" . $idcat . "'" . $sel . ">" . $categorie . "</option>";
            }
            $editor = load_class('Textarea', array('name' => 'faqanswer', 'height' => '300'));
            include("header.php");
            GraphicAdmin();
            title(_FAQADMIN);
            OpenTable();
            echo '<fieldset><legend>' . _ANSWER1 . "</legend>\n"
             . "<form action='" . adminUrl(PMX_MODULE) . "' method='post' style=\"display:block;width;100%\">"
             . "<table border='0' cellspacing='0' cellpadding='5' style=\"width:100%\">\n"
             . "<tr valign='top'><td>" . _QUEST5 . ":</td><td><input type='text' size=80 name='faqquestion' value='" . mxentityquotes($newq['question']) . "' /></td></tr>\n"
             . "<tr valign='top'><td>" . _ANSWER2 . "</td>\n<td>\n" . $editor->getHtml() . "</td></tr>\n"
             . "<tr valign='top'><td>" . _CATEGORY . ":</td><td><select name='faqcat'>" . implode("\n", $options) . "</select></td></tr>\n"
             . "<tr valign='top'><td colspan='2'><input type='submit' name='Save' value='" . _SUBMIT . "' />\n</td></tr>\n"
             . "</table>\n"
             . "<input type='hidden' name='op' value='" . PMX_MODULE . "/AnswerNew' />\n"
             . "<input type='hidden' name='faqaction' value='insertit' />\n"
             . "<input type='hidden' name='faq_id' value='" . $newq['faq_id'] . "' />\n"
             . "<input type='hidden' name='faq_email' value='" . $newq['email'] . "' />\n"
             . "<input type='hidden' name='faq_name' value='" . $newq['name'] . "' />\n"
             . "<input type='hidden' name='faq_ip' value='" . $newq['ip'] . "' />\n"
             . "</form></fieldset>";
            CloseTable();
            include("footer.php");
            return;
        } else if ($_REQUEST['faqaction'] == 'insertit') {
            $res = sql_query("SELECT MAX(id) FROM {$prefix}_faqanswer");
            list($newid) = sql_fetch_row($res, 0);
            $newid++;
            sql_query("INSERT INTO {$prefix}_faqanswer (id, id_cat, question, answer) VALUES (
			" . (int)$newid . ",
			" . (int)$_REQUEST['faqcat'] . ",
			'" . mxAddSlashesForSQL(strip_tags($_REQUEST['faqquestion'])) . "',
			'" . mxAddSlashesForSQL($_REQUEST['faqanswer']) . "'
			)") or mxErrorScreen(_DIE4);
            if (!empty($_REQUEST['faq_email'])) {
                mxMail($_REQUEST['faq_email'], "" . _ANSWER3 . " $sitename",
                    _HELLO . " " . $_REQUEST['faq_name'] . ",\n\n"
                     . _USEMAIL1 . $_REQUEST['faq_ip'] . "," . _USEMAIL2 . "\n"
                     . _USEMAIL3 . "\n"
                     . "$sitename (" . PMX_HOME_URL . ")\n\n"
                     . _QUEST1 . "\n"
                     . "\t" . mxStripSlashes($_REQUEST['faqquestion']) . "\n\n"
                     . _USEMAIL5 . "\n"
                     . PMX_HOME_URL . "/modules.php?name=FAQ&myfaq=yes&id_cat=" . (int)$_REQUEST['faqcat'] . "\n\n"
                     . _SEE1 . "\n\n"
                     . _GREETS . "\n"
                     . "$sitename " . _TEAM);
            }
            sql_query("DELETE FROM {$prefix}_faqnew WHERE faq_id=" . (int)$_REQUEST['faq_id'] . "") or mxErrorScreen("" . _DIE5 . " $faq_id");
        }
    }

    $res = sql_query("SELECT * FROM {$prefix}_faqnew");
    /* Zaehler auf 0 setzen */
    $numfaqs = 0;
    $newfaqs = array();
    while ($newfaqs[$numfaqs] = sql_fetch_array($res, $numfaqs)) {
        $numfaqs++;
    }

    include("header.php");
    GraphicAdmin();
    title(_FAQADMIN);
    OpenTable();
    echo '<p class="option" align="center">' . _NEWADD2 . "</p>\n"
     . "<ol>\n";
    for ($i = 0; $i < $numfaqs; $i++) {
        echo "<li><b>" . $newfaqs[$i]['question'] . "</b>"
         . "<br><span class=\"tiny\"><i>" . _SUBMIT2 . " " . $newfaqs[$i]['name'];
        if ($newfaqs[$i]['email'] != '') echo "&lt;" . $newfaqs[$i]['email'] . "&gt;";
        echo "[" . $newfaqs[$i]['ip'] . "] on " . $newfaqs[$i]['date'] . "</i></span><br>\n"
         . "<a href='" . adminUrl(PMX_MODULE, "AnswerNew", "faq_id=" . $newfaqs[$i]['faq_id'] . "&amp;faqaction=accept") . "'>" . _ACCEPT3 . "</a>"
         . " | <a href='" . adminUrl(PMX_MODULE, "AnswerNew", "faq_id=" . $newfaqs[$i]['faq_id'] . "&amp;faqaction=decline") . "'>" . _DECLINE . "</a>\n";
        if ($newfaqs[$i]['email'] != '') echo " | <a href='mailto:" . $newfaqs[$i]['email'] . "'>" . _REPLY5 . "</a>\n";
        echo "<br><br>\n";
    }
    echo "</ol>\n";
    CloseTable();
    include("footer.php");
}

$ok = (empty($ok)) ? 0 : 1;

switch ($op) {
    case PMX_MODULE . "/CatSave":
        FaqCatSave($id_cat, $categories, $flanguage);
        break;

    case PMX_MODULE . "/CatGoSave":
        FaqCatGoSave($id, $question, $answer, $id_cat);
        break;

    case PMX_MODULE . "/CatAdd":
        FaqCatAdd($categories, $flanguage);
        break;

    case PMX_MODULE . "/CatGoAdd":
        FaqCatGoAdd($id_cat, $question, $answer);
        break;

    case PMX_MODULE . "/CatEdit":
        FaqCatEdit($id_cat);
        break;

    case PMX_MODULE . "/CatGoEdit":
        FaqCatGoEdit($id);
        break;

    case PMX_MODULE . "/CatDel":
        FaqCatDel($id_cat, $ok);
        break;

    case PMX_MODULE . "/CatGoDel":
        FaqCatGoDel($id, $ok);
        break;

    case PMX_MODULE . "/CatGo":
        FaqCatGo($id_cat);
        break;

    case PMX_MODULE . "/AnswerNew":
        FaqAnswerNew();
        break;

    default:
        FaqAdmin();
        break;
}

?>