<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 989 $
 * $Author: PragmaMx $
 * $Date: 2024-02-08 10:58:33 +0100 (Do, 08 Feb 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);


// FAQ Standard
if (!isset($tables["{$prefix}_faqanswer"])) {

    $sqlqry[] = "
CREATE TABLE `{$prefix}_faqanswer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `id_cat` int(11) DEFAULT NULL,
  `question` varchar(255) DEFAULT NULL,
  `answer` text,
  PRIMARY KEY  (`id`),
  KEY `id_cat` (`id_cat`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_faqcategories"])) {

    $sqlqry[] = "
CREATE TABLE `{$prefix}_faqcategories` (
  `id_cat` int(11) NOT NULL auto_increment,
  `categories` varchar(255) default NULL,
  `flanguage` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id_cat`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_faqnew"])) {

    $sqlqry[] = "
CREATE TABLE `{$prefix}_faqnew` (
  `faq_id` int(11) NOT NULL auto_increment,
  `question` varchar(255) default NULL,
  `date` datetime default NULL,
  `name` varchar(255) default 'Anonymous',
  `ip` varchar(40) default NULL,
  `email` varchar(255) default NULL,
  `id_cat` int(11) NOT NULL default '0',
  PRIMARY KEY  (`faq_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

// hier bereits ausfuehren, dass Daten eingefuegt werden koennen
// // alle erstellten Queries ausfuehren
// // und Fehler / Erfolge loggen
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Indexe aktualisieren
$indexes = setupGetTableIndexes("{$prefix}_faqanswer");
if (!isset($indexes['id_cat'])) $sqlqry[] = "ALTER TABLE `{$prefix}_faqanswer` ADD INDEX `id_cat` ( `id_cat` );";
if (isset($indexes['id_cat_2'])) $sqlqry[] = "ALTER TABLE `{$prefix}_faqanswer` DROP INDEX `id_cat_2` ";
if (isset($indexes['id_cat_3'])) $sqlqry[] = "ALTER TABLE `{$prefix}_faqanswer` DROP INDEX `id_cat_3` ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>