<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 * this file based on:
 * CZ Enhanced Feedback
 * Copyright (c) 2004 by ~ Telli ~ (telli@codezwiz.com)
 * http://www.marsishere.net
 * edited by H.Grunert, http://www.marx-city.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(__DIR__);
mxgetlangfile($module_name);


include("modules/".$module_name."/includes/functions.php");
$module_name = basename(__DIR__);

$numdepts = feedback_DeptCount();//count($arraydepts);

$mxfbcfg=feedback_config();
/**
 * rechte Bloecke anzeigen
 */
$index = $mxfbcfg['showrtblks'];
pmxBase::set("plugins",$index);
$mxfbcfg['blockctrl']=0;

$op = (empty($_REQUEST['op'])) ? 'default' : $_REQUEST['op'];
switch ($op) {
    default:
        global $prefix, $mxfbcfg;
        $fname = "";
        $lname = "";
        $email = "";
        if (MX_IS_USER) {
            $row = mxGetUserData();
            if ($row['name'] != "") {
                $fname = $row['name'];
            } else {
                $fname = $row['uname'];
            }
            $email = $row['email'];
        }
        $preselected = "none";
        if (!empty($_GET['pre']) && in_array($_GET['pre'], $arraydepts)) {
            $preselected = $_GET['pre'];
        }
        include("header.php");
        title(_FEEDBACKTITLE);
        echo feedbackform();
        include("footer.php");
        break;

    case "check":
        global $prefix, $mxfbcfg, $numdepts;

        $parms = array('fname', 'email21', 'subject', 'message');
        foreach ($parms as $key) {
            if (!isset($_POST[$key])) {
                die('bad request...');
            }
        }

        if ((empty($_POST['deptemail'])) || (!isset($_POST['deptemail']))) {
            $deid = 0;
        } else {
            $deid = intval($_POST['deptemail']);
        }
        if ($mxfbcfg['deptson'] && ($numdepts >= 1) && empty($deid)) {
            $posterrmsg[] = _ERRORDEPT;
        }
        $email = trim($_POST['email21']);
        switch (true) {
            case empty($email):
            case !mxCheckEmail($email):
                $posterrmsg[] = _ERROREMAILADDRESS;
                break;
            case pmx_is_mail_banned($email):
                $posterrmsg[] = _MAILISBLOCKED;
                break;
        }
        $fname = trim($_POST['fname']);
        if (empty($fname)) {
            $posterrmsg[] = _ERRORNAME;
        }

        if ((empty($_POST['lname'])) || (!isset($_POST['lname']))) {
            $lname = '';
        } else {
            $lname = trim($_POST['lname']);
        }
        if ($mxfbcfg['reqlname'] && empty($lname)) {
            $posterrmsg[] = _ERRORLASTNAME;
        }

        $subject = trim(mxStripSlashes($_POST['subject']));
        if (empty($subject)) {
            $posterrmsg[] = _ERRORSUBJECT;
        }
        $message = trim(mxStripSlashes($_POST['message']));
        if (empty($message)) {
            $posterrmsg[] = _ERRORMESSAGE;
        }

        $captcha_object = load_class('Captcha', 'feedbackon');
        if (!$captcha_object->check($_POST, 'captcha')) {
            $posterrmsg[] = _CAPTCHAWRONG;
        }

        $sendcopy = (isset($_POST['sendcopy']) && $_POST['sendcopy']);

        if (isset($posterrmsg)) {
            $preselected = "none";
            if (!empty($deid) && isset($arraydepts[$deid])) {
                $preselected = $arraydepts[$deid];
            }

            include("header.php");
            title(_FEEDBACKTITLE);
            openTableAl();
            echo '<div style="text-align: left;"><h2>' . _SENDERROR . '</h2><ul><li>' . implode('</li><li>', $posterrmsg) . '</li></ul></div>';
            closeTableAl();
            echo '<br />';
            echo feedbackform();
            include("footer.php");
            exit;
        }

        if (($numdepts < 1) || ($mxfbcfg['deptson'] == "0")) { // Keine Abteilungen oder Abteilungen ausgeschaltet
            $row['demail'] = $mxfbcfg['ademail']; //Wenn Abteilungen aus, Empfänger ist Haupt-Vorgabe Emailadresse
            if (($sendcopy) && ($mxfbcfg['letreceive'] == "1")) { // Parameter setzen, wenn der Absender eine Kopie wünscht
                $row['dname'] = "Administration " . $GLOBALS['sitename'] . "";
                $row['pp'] = $mxfbcfg['mainpp'];
                $row['vvname'] = $mxfbcfg['mainvvname'];
                $row['vname'] = $mxfbcfg['mainvname'];
            } else {
                $row['pp'] = '';
                $row['vvname'] = '';
                $row['vname'] = '';
                $row['dname'] = '';
            }
        }
        $today = date(_TIMESTRING);
        $default_email = trim($mxfbcfg['ademail']);
        if (($numdepts > 0) && ($mxfbcfg['deptson'] == "1")) {
            $sql = "SELECT dname, demail, vvname, vname, pp FROM " . $prefix . "_mxfeedback_depts WHERE did=" . mxAddSlashesForSQL($deid) . "";
            $result = sql_query($sql);
            $row = sql_fetch_array($result);
        }
        // Mail Support
        $messagesupport = replace_placeholder($mxfbcfg['depmail']);
        if (mxMail($row['demail'], $subject, $messagesupport, $email, "", "", $fname)) {
            if (($sendcopy) && ($mxfbcfg['letreceive'] == "1")) {
                // Mail Customer
                $messagecust = replace_placeholder($mxfbcfg['custmail']);
                if (!mxMail($email, $subject, $messagecust, $row['demail'], "", "", $row['dname'])) {
                    mxRedirect('modules.php?name=' . $module_name . '&amp;op=message_sent&amp;stat=nok', '', 0);
                    break;
                }
            }
            mxRedirect('modules.php?name=' . $module_name . '&amp;op=message_sent&amp;stat=ok', '', 0);
        } else {
            mxRedirect('modules.php?name=' . $module_name . '&amp;op=message_sent&amp;stat=nok', '', 0);
        }
        break;

    case 'message_sent':
        switch ($stat) {
            case 'ok':
                $msg = '<p>' . _THANKSFORCONTACT . '</p><p>' . _AREPWILLRESPOND . '</p>';
                mxRedirect('modules.php?name=' . $module_name, $msg, 5);
                break;

            case 'nok':
                $msg = '<p>' . _SENDERROR2 . '</p><p>' . _SENDERROR3 . '</p>';
                mxRedirect('modules.php?name=' . $module_name, $msg, 10);
                break;
        }
}

?>
