<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 *
 * Based on MyPHPortal Modified MembersList
 * Some code taken from MemberList coded by Paul Joseph Thompson
 * of www.slug.okstate.edu
 * In memoriam of Members List War ;)
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);

$index = 0; // Rechte Bloecke? 0 = nein, 1 = ja
$letter = 'all'; // Standardauswahl
$sortby = 'uname'; // Standardsortierung
$pagesize = 25; // Anzahl der Zeilen in der Liste
pmxBase::set("plugins",0);

define('MX_ML_IMAGEPATH', PMX_MODULES_PATH . $module_name . '/images/');

define('IMG_MAIL', mxCreateImage(MX_ML_IMAGEPATH . 'email.png', 'email', array('title' => _ML_SENDMAIL)));
define('IMG_WWW', mxCreateImage(MX_ML_IMAGEPATH . 'www.png', 'www', array('title' => _ML_VISITHP)));
define('IMG_ICQ', mxCreateImage(MX_ML_IMAGEPATH . 'icq.png', 'icq', array('title' => _ML_ICQADD)));
define('IMG_AIM', mxCreateImage(MX_ML_IMAGEPATH . 'aim.png', 'aim', array('title' => _ML_MSEND)));
define('IMG_YIM', mxCreateImage(MX_ML_IMAGEPATH . 'yim.png', 'yim', array('title' => _ML_MSEND)));
define('IMG_MSN', mxCreateImage(MX_ML_IMAGEPATH . 'msn.png', 'msn', array('title' => _ML_MSNNAME)));
define('IMG_PMS', mxCreateImage(MX_ML_IMAGEPATH . 'pm.gif', 'pm', array('title' => _ML_PMSEND)));
define('IMG_EDIT' , mxCreateImage(MX_ML_IMAGEPATH . 'edit.gif', 'edit', array('title' => _EDIT)));
define('IMG_DELE', mxCreateImage(MX_ML_IMAGEPATH . 'delete.gif', 'delete', array('title' => _DELETE)));

$memlist_pmallowed = mxModuleAllowed('Private_Messages');

$memlistletters = array ('all', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'other');
if (isset($_GET['letter'])) {
    $letter = (in_array($_GET['letter'], $memlistletters)) ? $_GET['letter'] : $letter;
}
if (isset($_GET['sortby'])) {
    $memlistsortbys = array('uname', 'name', 'email', 'url');
    $sortby = (in_array($_GET['sortby'], $memlistsortbys)) ? $_GET['sortby'] : $sortby;
    unset($memlistsortbys);
}
$page = (isset($_GET['page'])) ? (int)$_GET['page'] : 1;

function alpha()
{
    /* Creates the list of letters and makes them a link. */
    global $sortby, $module_name, $memlistletters, $letter;
    $num = count($memlistletters) - 1;
    echo "<center>[ ";
    $counter = 0;
    foreach ($memlistletters as $ltr) {
        $ltr_v = mltransletter($ltr);
        if ($ltr == $letter) {
            $ltr_v = '<b class="current">' . $ltr_v . '</b>';
        }
        echo '<a href="modules.php?name=' . $module_name . '&amp;letter=' . $ltr . '&amp;sortby=' . $sortby . '">' . $ltr_v . '</a>';
        if ($counter == round($num / 2)) {
            echo " ]<br />[ ";
        } else if ($counter != $num) {
            echo "&nbsp;|&nbsp;";
        }
        $counter++;
    }
    echo " ]</center><br />";
}

function SortLinks($letter) // Makes order by links..
{
    global $sortby, $module_name;
    echo "<center>"; // Start of HTML
    echo _SORTBY . " [ ";
    if ($sortby == "uname" OR !$sortby) {
        echo _MNICKNAME . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=uname\">" . _MNICKNAME . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "name") {
        echo _MREALNAME . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=name\">" . _MREALNAME . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "email") {
        echo _MEMAIL . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=email\">" . _MEMAIL . "</a>&nbsp;|&nbsp;";
    }
    if ($sortby == "url") {
        echo _MURL . "&nbsp;|&nbsp;";
    } else {
        echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=url\">" . _MURL . "</a>";
    }
    echo " ]</center>"; // end of HTML
}

function mltransletter($ltr)
{
    if ($ltr == 'all') {
        return _MEMALL;
    }
    if ($ltr == 'other') {
        return _MEMOTHER;
    }
    return $ltr;
}

$pagetitle = _MEMBERSLIST;
include("header.php");
title(_MEMBERSLIST);
/* This is the header section that displays the last registered and who's logged in and whatnot */
$result = sql_query("select uname from {$user_prefix}_users WHERE user_stat=1 order by uid DESC limit 0,1");
list($lastuser) = sql_fetch_row($result);
list($numrows) = sql_fetch_row(sql_query("select count(uid) from {$user_prefix}_users WHERE user_stat=1"));

OpenTable();
echo '<center>' . _GREETINGS . ' ' . mxCreateUserprofileLink($lastuser) . '</center><br />';

if (MX_IS_USER || MX_IS_ADMIN) {
    $member_online_num = 0;
    $past = time() - MX_SETINACTIVE_MINS ;
    $result2 = sql_query("SELECT uname FROM {$user_prefix}_users
				WHERE ((user_lastvisit >= " . $past . ") AND (user_stat=1) AND (user_lastmod<>'logout'))
				ORDER BY uname");
    while (list($username) = sql_fetch_row($result2)) {
        $list[] = mxCreateUserprofileLink($username);
        $member_online_num++;
    }
    $who_online = (isset($list)) ? implode(" - ", $list) : "";
    echo "<center>" . _WEHAVE . " <b>" . $numrows . "</b> " . _MREGISTERED . " <b>" . $member_online_num . "</b> " . _MREGONLINE . "</center><br />";
    if ($member_online_num) {
        OpenTable2();
        echo "<center><b>" . _ONLINEREG . " </b><br /><br />" . $who_online . "</center>";
        CloseTable2();
        echo '<br />';
    }
} else {
    echo "<center>" . _WEHAVE . " <b>$numrows</b> " . _REGSOFAR . "</center><br /><br />";
}

alpha();
SortLinks($letter);

$min = $pagesize * ($page - 1); // This is where we start our record set from
$max = $pagesize; // This is how many rows to select

/* All my SQL stuff. DO NOT ALTER ANYTHING UNLESS YOU KNOW WHAT YOU ARE DOING */

/* This is a totaly crap code, any help to re-code this functions will be very appreciated */
/* Need to be database independent */

$count = "SELECT COUNT(uid) AS total FROM {$user_prefix}_users "; // Count all the users in the db..
$select = "SELECT uid, name, uname, user_viewemail, email, url, user_msnm, user_yim, user_aim, user_icq FROM {$user_prefix}_users "; //select our data
$where = "where uname <> 'Anonymous' AND user_stat=1 ";
if (($letter != 'other') && ($letter != 'all')) { // are we listing all or "other" ?
    $where .= "AND uname LIKE '" . $letter . "%' "; // I guess we are not..
} else if ($letter == 'other') { // But other is numbers ?
    $where .= "AND uname REGEXP '^\[1-9]' "; // REGEX :D, although i think its MySQL only
}
$sort = "order by $sortby"; //sorty by .....
$limit = " ASC LIMIT " . $min . ", " . $max; // we only want rows $min  to $max
/* due to how this works, i need the total number of users per
letter group, then we can hack of the ones we want to view */
$count_result = sql_query($count . $where);
list($num_rows_per_order) = sql_fetch_row($count_result);

/* This is where we get our limit'd result set. */
$result = sql_query($select . $where . $sort . $limit); # or die(); // Now lets do it !!

/* Crap code ends here */

echo '<br />';

echo "<table width=\"100%\" border=\"0\" cellspacing=\"1\" class=\"full list\"><tr>";
echo "<th>" . _NICKNAME . "</th>";
echo "<th>" . _REALNAME . "</th>";
echo "<th>" . _EMAIL . "</th>";
echo "<th>" . _ML_URL . "</th>";
echo "<th>" . _ML_ICQ . "</th>";
echo "<th>" . _ML_AIM . "</th>";
echo "<th>" . _ML_YIM . "</th>";
echo "<th>" . _ML_MSNM . "</th>";
$cols = 8;

if ($memlist_pmallowed) {
    $cols++;
    echo "<th>" . _ML_PM . "</th>";
}
if (MX_IS_ADMIN) {
    $cols++;
    echo "<th>" . _FUNCTIONS . "</th>";
}
echo "</tr>";

$num_users = sql_num_rows($result); //number of users per sorted and limit query
if ($num_rows_per_order > 0) {
    $dclass = '';
    while ($theuser = sql_fetch_array($result)) {
        $dclass = ($dclass != 'alternate-a') ? 'alternate-a' : 'alternate-b';
        echo '<tr class="' . $dclass . '"><td>' . mxCreateUserprofileLink($theuser['uname']) . '&nbsp;</td>';
        echo "<td>" . $theuser['name'] . "&nbsp;</td>";
        echo "<td>";

        if ($theuser["user_viewemail"]) {
            echo "<a href=\"mailto:" . mxPrepareToDisplay($theuser["email"]) . "\">" . IMG_MAIL . "</a>";
        }
        echo "</td><td>";

        if ($theuser["url"]) {
            echo "
			<a href=\"" . htmlspecialchars($theuser["url"]) . "\" target=\"_blank\">" . IMG_WWW . "</a>			";
        }

        echo "</td><td>";

        if (is_numeric($theuser["user_icq"])) {
            echo '
            <a href="http://wwp.icq.com/' . $theuser['user_icq'] . '#pager" target="_blank">
            ' . mxCreateImage('http://wwp.icq.com/scripts/online.dll?icq=' . $theuser['user_icq'] . '&amp;img=5', 'icq', array('title' => 'Online Status/Pager', 'width' => 18, 'height' => 18)) . '</a>
            <a href="http://wwp.icq.com/scripts/search.dll?to=' . $theuser['user_icq'] . '" target="_blank">' . IMG_ICQ . '</a>
            ';
        }

        echo "</td>";
        echo "<td>";

        if ($theuser["user_aim"]) {
            echo "<a href=\"aim:goim?screenname=" . urlencode($theuser['user_aim']) . "&amp;message=Hi+" . urlencode($theuser['user_aim']) . ".+Are+you+there?\">" . IMG_AIM . "</a>";
        }
        echo "</td>";

        echo "<td>";
        if ($theuser["user_yim"]) {
            echo "<a href=\"http://edit.yahoo.com/config/send_webmesg?.target=" . urlencode($theuser['user_yim']) . "&amp;.src=pg\" target=\"_blank\">" . IMG_YIM . "</a>";
        }
        echo "</td>";

        echo "<td>";
        if ($theuser["user_msnm"]) {
            echo "<a href=\"http://members.msn.com/" . urlencode($theuser['user_msnm']) . "\" target=\"_blank\">" . IMG_MSN . "</a>";
        }
        echo "</td>";

        if ($memlist_pmallowed) {
            echo "
			<td>
			<a href=\"modules.php?name=Private_Messages&amp;op=send_to&amp;to_user=" . urlencode($theuser["uname"]) . "\">" . IMG_PMS . "</a>
            </td>
			";
        }

        if (MX_IS_ADMIN) {
            echo "
			<td align=\"center\">
			<a href=\"" . adminUrl("users", "modify", "chng_uid=$theuser[uid]") . "\">" . IMG_EDIT . "</a>&nbsp;
			<a href=\"" . adminUrl("users", "delete", "chng_uid=$theuser[uid]") . "\">" . IMG_DELE . "</a>
			</td>";
        }

        echo "</tr>";
    }
} else { // you have no members on this letter, hahaha
    echo "<tr><td class=\"alternate\" colspan=\"$cols\" align=\"center\"><br />";
    echo "<b>" . _NOMEMBERS . " &quot;" . mltransletter($letter) . "&quot;</b>";
    echo "<br /><br /></td></tr>";
}

echo "</table>";

if ($num_rows_per_order > 0) {
    echo "<table class=\"full\" cellspacing=\"0\" cellpadding=\"6\" border=\"0\"><tr>";

    if ($num_rows_per_order > $pagesize) {
        $total_pages = ceil($num_rows_per_order / $pagesize); // How many pages are we dealing with here ??
        $prev_page = $page - 1;

        if ($prev_page > 0) {
            echo "<td align='left' width='15%'><a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$prev_page'>";
            echo mxCreateImage(PMX_IMAGE_PATH . 'previous.png', _PREVIOUS, array('title' => _PREVIOUS . ' (' . $prev_page . ')'));
            echo "</a></td>";
        } else {
            echo "<td width='15%'>&nbsp;</td>";
        }

        echo "<td align='center' width='70%' class='tiny'>";
        echo "$num_rows_per_order " . _USERSFOUND . " <b>&quot;" . mltransletter($letter) . "&quot;</b> ($total_pages " . _PAGES . ", $num_users " . _USERSSHOWN . ")";
        echo "</td>";

        $next_page = $page + 1;
        if ($next_page <= $total_pages) {
            echo "<td align='right' width='15%'><a href='modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$next_page'>";
            echo mxCreateImage(PMX_IMAGE_PATH . 'next.png', _NEXTPAGE, array('title' => _NEXTPAGE . ' (' . $next_page . ')'));
            echo "</a></td>";
        } else {
            echo "<td width='15%'>&nbsp;</td></tr>";
        }
        /* Added a numbered page list, only shows up to 50 pages. */

        echo "<tr><td colspan=\"3\" align=\"center\" class=\"tiny\">";
        echo " [ ";

        for($n = 1; $n < $total_pages; $n++) {
            if ($n == $page) {
                echo "<b>$n</b>";
            } else {
                echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$n\">$n</a>";
            }
            if ($n >= 50) { // if more than 50 pages are required, break it at 50.
                $break = true;
                break;
            } else { // guess not.
                echo " | ";
            }
        }

        if (!isset($break)) { // are we sopposed to break ?
            if ($n == $page) {
                echo "<b>$n</b>";
            } else {
                echo "<a href=\"modules.php?name=" . $module_name . "&amp;letter=$letter&amp;sortby=$sortby&amp;page=$total_pages\">$n</a>";
            }
        }
        echo " ] ";
        echo "</td></tr>";

        /* This is where it ends */
    } else { // or we dont have any users..
        echo "<td align='center' class=\"tiny\">";
        echo "$num_rows_per_order " . _USERSFOUND . " &quot;" . mltransletter($letter) . "&quot;";
        echo "</td></tr>";
    }

    echo "</table>";
}

CloseTable();

include("footer.php");

?>