<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

/* der passende Modulname */
$module_name = basename(dirname(dirname(__FILE__)));

if (!mxModuleAllowed($module_name)) {
    /* Block darf nicht gecached werden und weg... */
    $mxblockcache = false;
    return;
}

if ($module_name == MX_MODULE) {
    return;
}

global $prefix;

include(PMX_MODULES_DIR . DS . $module_name . DS . 'includes' . DS . 'settings.php');
// mxGetLangfile($module_name);
// $blockfiletitle = _new_title;
$exist = array();
if (MX_IS_USER) {
    $mxblockcache = false;
    $userinfo = mxGetUserData();
    $qry = "SELECT * FROM `{$prefix}_newsletter` WHERE uid=" . intval($userinfo['uid']) . " LIMIT 1";
    $result = sql_query($qry);
    $row = sql_fetch_assoc($result);
    if (empty($row['uid'])) {
        $exist['email'] = $userinfo['email'];
    } else {
        $exist = $row;
        $exist['op'] = 'unsubscribe';
    }
} else {
    /* Block kann gecached werden? */
    $mxblockcache = false;
}

$defaults = array(/* Standardwerte */
    'email' => '',
    'type' => $nl_config['default_format'],
    'op' => 'subscribe',
    );

$data = array_merge($defaults, $exist);

ob_start();

?>

<form action="modules.php?name=<?php echo $module_name ?>" method="post" class="letter-block-form">
  <input name="name" value="<?php echo $module_name ?>" type="hidden" />
  <input name="from_block" type="hidden" value="1" />
  <p>
  <?php echo _NL_EMAIL ?><br />
  <input name="email" size="20" maxlength="255" type="text" value="<?php echo $data['email'] ?>" placeholder="<?php echo _NL_YOURADDRESS ?>" /><br />
  </p><p>
  <?php echo _NL_CHOOSE ?><br />
  <select name="op">
    <option<?php echo (('subscribe' == $data['op']) ? ' selected="selected" class="current"' : '') ?> value="subscribe"><?php echo _NL_SUBSCRIBE ?></option>
    <option<?php echo (('unsubscribe' == $data['op']) ? ' selected="selected" class="current"' : '') ?> value="unsubscribe"><?php echo _NL_UNSUBSCRIBE ?></option>
  </select>
  </p><p>
  <?php echo _NL_CHOOSETYPE ?><br />
  <select name="type">
    <option<?php echo ((0 == $data['type']) ? ' selected="selected" class="current"' : '') ?> value="0"><?php echo _NL_TYPETEXT ?></option>
    <option<?php echo ((1 == $data['type']) ? ' selected="selected" class="current"' : '') ?> value="1"><?php echo _NL_TYPEHTML ?></option>
  </select>
  </p><p>
  <input value="<?php echo _NL_SUBMIT ?>" type="submit" />
  </p>
</form>

<?php
$content = ob_get_clean();

?>