<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 989 $
 * $Author: PragmaMx $
 * $Date: 2024-02-08 10:58:33 +0100 (Do, 08 Feb 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

$changeuserdata = false;

unset($sqlqry);


if (!setupTableExist("{$prefix}_newsletter", true)) {
	$sqlqry[] = "
		CREATE TABLE `{$prefix}_newsletter` (
		  `id` int(11) NOT NULL AUTO_INCREMENT,
		  `uid` int(11) DEFAULT NULL,
		  `email` varchar(100) NOT NULL DEFAULT '',
		  `status` int(11) NOT NULL DEFAULT '0',
		  `html` int(11) NOT NULL DEFAULT '0',
		  `checkkey` int(11) NOT NULL DEFAULT '0',
		  `regdate` int(10) NOT NULL DEFAULT '0',
		  `regip` varchar(40) NOT NULL DEFAULT '',
		  `reghost` varchar(100) NOT NULL DEFAULT '',
		  PRIMARY KEY (`id`),
		  KEY `uid` (`uid`)
		) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}


if (!isset($tables["{$prefix}_newsletter_send"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_newsletter_send` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `subject` varchar(255) DEFAULT NULL,
  `text` text,
  `html` text,
  `more` text,
  `send` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} 

if (!isset($tables["{$prefix}_newsletter_sendto"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_newsletter_sendto` (
  `id` int(11) NOT NULL auto_increment,
  `userid` int(11) NOT NULL default '0',
  `newsletterid` int(11) NOT NULL default '0',
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
} 

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

/* User-ID in Newsletter-Tabelle eintragen */
if ($changeuserdata) {
    $result = sql_query("SELECT n.id, u.uid, n.uid
            FROM `{$prefix}_newsletter` AS n
            INNER JOIN `{$user_prefix}_users` AS u
              ON n.email = u.email
            WHERE ISNULL(n.uid)
            ORDER BY u.uid DESC");
    if ($result) {
        while (list($id, $uid) = sql_fetch_row($result)) {
            if ($id && $uid) {
                $sqlqry[$id] = "UPDATE `{$prefix}_newsletter` SET uid=" . intval($uid) . " WHERE id=" . intval($id) . "";
            }
        }
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>