<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 *
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsection')) {
    mxErrorScreen('Access Denied');
    die();
}

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);

$sectionsimagepath = PMX_IMAGE_PATH . 'sections/';

function sections()
{
    global $prefix, $language;
    $img_delete = mxCreateImage('images/delete.gif', _DELETE, array('title' => _DELETE));
    $img_edit = mxCreateImage('images/edit.gif', _EDIT, array('title' => _EDIT));
    $editor = load_class('Textarea', array('name' => 'sec_content', 'height' => '400', 'pagebreak' => true));

    $result = sql_query("SELECT secid, secname FROM " . $prefix . "_sections ORDER BY secid");

    include('header.php');
    title(_SECTIONSADMIN);
    if (sql_num_rows($result) > 0) {
        echo '<br />';
        OpenTable();
        echo '<fieldset>
                <legend>' . _ACTIVESECTIONS . '</legend>
                <p class="align-center">' . _CLICK2EDITSEC . '</p>
              <table border="0" width="100%" cellpadding="1" align="center"><tr><td align="center">';
        while (list($secid, $secname) = sql_fetch_row($result)) {
            echo '<strong><big>&middot;</big></strong>&nbsp;&nbsp;<a href="' . adminUrl(PMX_MODULE, 'edit', 'secid=' . $secid) . '">' . (($secname) ? $secname : '<i class="highlight">' . _NOSUBJECT . '</i>') . '</a>&nbsp;&nbsp;&nbsp;';
        }
        echo '</td></tr></table></fieldset>';
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<fieldset>
                <legend>' . _ADDSECARTICLE . '</legend>
                <form action="' . adminUrl(PMX_MODULE) . '" method="post">
                  <b>' . _TITLE . ':</b><br />
                  <input type="text" name="title" size="60" /><br /><br />
                  <b>' . _SELSECTION . ': </b>';
        $result = sql_query("SELECT secid, secname FROM " . $prefix . "_sections ORDER BY secid");
        echo '<select name="secid">';
        while (list($secid, $secname) = sql_fetch_row($result)) {
            echo '<option value="' . $secid . '">' . $secname . '</option>';
        }
        echo '</select><br />';

        echo '<font class="content">' . _DONTSELECT . '</font><br />';
        if ($GLOBALS['multilingual']) {
            echo '<br /><b>' . _LANGUAGE . ': </b>' . mxLanguageSelect('slanguage', $language, 'language', 1);
        } else {
            echo '<input type="hidden" name="slanguage" value="" />';
        }
        echo '<br /><br /><b>' . _CONTENT . ':</b><br />' . $editor->getHtml() . '<br /><br />
              <input type="hidden" name="op" value="' . PMX_MODULE . '/articleadd" />
              <input type="submit" value="' . _ADDARTICLE . '" />
            </form>
          </fieldset>';
        CloseTable();
        echo '<br />';
        OpenTable();
        echo '<fieldset>
                <legend>' . _LAST . ' 20 ' . _ARTICLES . '</legend>
                <ul>';
        $result = sql_query("SELECT artid, secid, title, content, slanguage FROM " . $prefix . "_seccont ORDER BY artid DESC LIMIT 0,20");
        while (list($artid, $secid, $title, $content, $slanguage) = sql_fetch_row($result)) {
            $result2 = sql_query("SELECT secid, secname FROM " . $prefix . "_sections WHERE secid='$secid'");
            list($secid, $secname) = sql_fetch_row($result2);
            echo '<li>' . $title . ' - (' . $slanguage . ') - (' . $secname . ') &nbsp;<a href="' . adminUrl(PMX_MODULE, 'artedit', 'artid=' . $artid) . '">' . $img_edit . '</a>&nbsp;<a href="' . adminUrl(PMX_MODULE, 'artdelete', 'artid=' . $artid . '&amp;ok=0') . '">' . $img_delete . '</a>';
        }
        echo '</ul>
              <form action="' . adminUrl(PMX_MODULE) . '" method="post">
                ' . _EDITARTID . ': <input type="text" name="artid" size="10" />&nbsp;&nbsp;
                <input type="hidden" name="op" value="' . PMX_MODULE . '/artedit" />
                <input type="submit" value="' . _OK . '" />
              </form>
            </fieldset>';
        CloseTable();
    }
    echo '<br />';
    OpenTable();
    echo '<fieldset>
            <legend>' . _ADDSECTION . '</legend>
            <form action="' . adminUrl(PMX_MODULE) . '" method="post">
              ' . sec_subform('', '') . '
              <input type="hidden" name="op" value="' . PMX_MODULE . '/make" />
              <input type="submit" value="' . _ADDSECTIONBUT . '" />
            </form>
          </fieldset>';
    CloseTable();
    include('footer.php');
}

function secarticleadd($secid, $title, $content, $slanguage)
{
    global $prefix;
    if (preg_match('#<body[^>]*>(.+)</body>#is', $content, $matches)) {
        $content = $matches[1];
    }
    sql_query("INSERT INTO " . $prefix . "_seccont (secid, title, content, counter, slanguage) VALUES ('" . intval($secid) . "', '" . mxAddSlashesForSQL($title) . "', '" . mxAddSlashesForSQL($content) . "', '0', '" . mxAddSlashesForSQL($slanguage) . "')");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function secartedit($artid)
{
    global $prefix;
    include('header.php');
    title(_SECTIONSADMIN);

    $result = sql_query("SELECT artid, secid, title, content, slanguage FROM " . $prefix . "_seccont WHERE artid='$artid'");
    list($artid, $secid, $title, $content, $slanguage) = sql_fetch_row($result);
    $editor = load_class('Textarea', array('name' => 'sec_content', 'value' => $content, 'height' => '400', 'pagebreak' => true));
    OpenTable();
    echo '<fieldset>
            <legend>' . _EDITARTICLE . '</legend>
            <form action="' . adminUrl(PMX_MODULE) . '" method="post">
              <b>' . _TITLE . '</b><br />
              <input type="text" name="title" size="60" value="' . mxEntityQuotes($title) . '" /><br /><br />
              <b>' . _SELSECTION . ': </b>';
    $result2 = sql_query("SELECT secid, secname FROM " . $prefix . "_sections ORDER BY secname");

    echo '<select name="secid">';
    while (list($secid2, $secname) = sql_fetch_row($result2)) {
        $sel = ($secid2 == $secid) ? ' selected="selected" class="current"' : '';
        echo '<option value="' . $secid2 . '"' . $sel . '>' . $secname . '</option>';
    }
    echo '</select><br />';

    if ($GLOBALS['multilingual']) {
        echo '<br /><b>' . _LANGUAGE . ': </b>' . mxLanguageSelect('slanguage', $slanguage, 'language', 1) . '<br />';
    } else {
        echo '<input type="hidden" name="slanguage" value="" />';
    }
    echo '<br /><b>' . _CONTENT . '</b><br />' . $editor->getHtml() . '<br /><br />
          <input type="hidden" name="artid" value="' . $artid . '" />
          <input type="hidden" name="op" value="' . PMX_MODULE . '/artchange" />
          <input type="submit" value="' . _SAVECHANGES . '" />
              <input type="submit" value="' . _CANCEL . '" name="secancel" />
          [&nbsp;<a href="' . adminUrl(PMX_MODULE, 'artdelete', 'artid=' . $artid . '&amp;ok=0') . '">' . _DELETE . '</a>&nbsp;]
        </form>
      </fieldset>';
    CloseTable();
    include('footer.php');
}

function sectionmake($secname, $image)
{
    global $prefix;
    $secname = mxAddSlashesForSQL($secname);
    $image = mxAddSlashesForSQL($image);
    if (!empty($secname)) {
        sql_query("INSERT INTO " . $prefix . "_sections (secname, image) VALUES ('$secname', '$image')");
    }
    return mxRedirect(adminUrl(PMX_MODULE));
}

function sectionedit($secid)
{
    global $prefix;
    include('header.php');
    title(_SECTIONSADMIN);

    $result = sql_query("SELECT secid, secname, image FROM " . $prefix . "_sections WHERE secid=" . intval($secid) . "");
    list($secid, $secname, $image) = sql_fetch_row($result);
    $result2 = sql_query("SELECT artid FROM " . $prefix . "_seccont WHERE secid=" . intval($secid) . "");
    $number = sql_num_rows($result2);
    OpenTable();
    echo '<fieldset>
            <legend>' . _EDITSECTION . ': ' . $secname . '</legend>
            <br />(' . _SECTIONHAS . ' ' . $number . ' ' . _ARTICLESATTACH . ')
            <br /><br />
            <form action="' . adminUrl(PMX_MODULE) . '" method="post">
              ' . sec_subform($secname, $image) . '
              <input type="hidden" name="secid" value="' . $secid . '" />
              <input type="hidden" name="op" value="' . PMX_MODULE . '/change" />
              <input type="submit" value="' . _SAVECHANGES . '" />
              <input type="submit" value="' . _CANCEL . '" name="secancel" />
              [&nbsp;<a href="' . adminUrl(PMX_MODULE, 'delete', 'secid=' . $secid . '&amp;ok=0') . '">' . _DELETE . '</a>&nbsp;]
            </form>
          </fieldset>';
    CloseTable();
    include('footer.php');
}

function sectionchange($secid, $secname, $image)
{
    global $prefix;

    if (!isset($_POST['secancel'])) {
        $secname = mxAddSlashesForSQL(($secname));
        $image = mxAddSlashesForSQL(($image));
        if (empty($secname)) {
            return mxRedirect(adminUrl(PMX_MODULE, 'edit', 'secid=' . $secid));
        }
        sql_query("UPDATE " . $prefix . "_sections SET secname='$secname', image='$image' WHERE secid=" . intval($secid) . "");
    }
    return mxRedirect(adminUrl(PMX_MODULE));
}

function secartchange($artid, $secid, $title, $content, $slanguage)
{
    global $prefix;
    $title = mxAddSlashesForSQL(($title));
    $content = mxAddSlashesForSQL(($content));
    sql_query("UPDATE " . $prefix . "_seccont SET secid='$secid', title='$title', content='$content', slanguage='$slanguage' WHERE artid=$artid");
    return mxRedirect(adminUrl(PMX_MODULE));
}

function sectiondelete($secid, $ok = 0)
{
    global $prefix;
    if ($ok == 1) {
        sql_query("DELETE FROM " . $prefix . "_seccont WHERE secid='$secid'");
        sql_query("DELETE FROM " . $prefix . "_sections WHERE secid='$secid'");
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include('header.php');
        title(_SECTIONSADMIN);

        $result = sql_query("SELECT secname FROM " . $prefix . "_sections WHERE secid=$secid");
        list($secname) = sql_fetch_row($result);
        OpenTableAl();
        echo '<center>
                <b>' . _DELSECTION . ': ' . $secname . '</b><br /><br />
                ' . _DELSECWARNING . ' ' . $secname . '?<br />
                ' . _DELSECWARNING1 . '<br /><br />
                [&nbsp;<a href="' . adminUrl(PMX_MODULE) . '">' . _NO . '</a> | <a href="' . adminUrl(PMX_MODULE, 'delete', 'secid=' . $secid . '&amp;ok=1') . '">' . _YES . '</a>&nbsp;]
              </center>';
        CloseTableAl();
        include('footer.php');
    }
}

function secartdelete($artid, $ok = 0)
{
    global $prefix;

    if (isset($_POST['secancel'])) {
        return mxRedirect(adminUrl(PMX_MODULE));
    }

    if ($ok == 1) {
        sql_query("DELETE FROM " . $prefix . "_seccont WHERE artid='$artid'");
        return mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include('header.php');
        title(_SECTIONSADMIN);

        $result = sql_query("SELECT title FROM " . $prefix . "_seccont WHERE artid=$artid");
        list($title) = sql_fetch_row($result);
        OpenTableAl();
        echo '<center>
                <b>' . _DELARTICLE . ': ' . $title . '</b><br /><br />
                ' . _DELARTWARNING . '<br /><br />
                [&nbsp;<a href="' . adminUrl(PMX_MODULE) . '">' . _NO . '</a> | <a href="' . adminUrl(PMX_MODULE, 'artdelete', 'artid=' . $artid . '&amp;ok=1') . '">' . _YES . '</a>&nbsp;]
              </center>';
        CloseTableAl();
        include('footer.php');
    }
}

function sec_subform($secname, $image)
{
    global $sectionsimagepath;

    $displayimage = ($image) ? $sectionsimagepath . $image : PMX_IMAGE_PATH . 'noimg.png';

    $fb = load_class('Filebrowse');
    if ($fb->is_active()) {
        $fb->set_getback('name');
        $fb->set_root($sectionsimagepath, _SECTIONIMG);
        $fb->set_type('images');
        $fb->dialog();
    }
    ob_start();

    ?>

<label><?php echo _SECTIONNAME ?> <span class="tiny"><?php echo _FORTYCHARSMAX ?></span></label><br />
<input type="text" name="secname" size="40" maxlength="40" value="<?php echo mxEntityQuotes($secname) ?>" required="required" /><br /><br />
<label><?php echo _SECTIONIMG ?></label><br />
<input type="text" name="image" id="sectionimagefield" value="<?php echo $image ?>" size="25" maxlength="100" required="required" /> &nbsp;
<?php if($fb->is_active()){ ?>
  <button id="rtvkhs"><?php echo _BROWSE ?></button> &nbsp;
<?php } //endif ?>
<img align="top" alt="image" id="sectionimage" src="<?php echo $displayimage ?>" style="max-height:100px;max-width:100px;" />
<br /><br />

<script type="text/javascript">
  /*<![CDATA[*/

  $('#rtvkhs').click(function() {
    pmxfilemanager('sectionimagefield', true);
    return false;
  });

  $('#sectionimagefield').change(function() {
    $('#sectionimage').attr('src','<?php echo $sectionsimagepath ?>' + this.value);
  });

  /*]]>*/
</script>

    <?php
    $ret = ob_get_clean();
    return $ret;
}

switch ($op) {
    case PMX_MODULE . '/edit':
        sectionedit($secid);
        break;

    case PMX_MODULE . '/make':
        sectionmake($secname, $image);
        break;

    case PMX_MODULE . '/delete':
        sectiondelete($secid, !empty($_REQUEST['ok']));
        break;

    case PMX_MODULE . '/change':
        sectionchange($secid, $secname, $image);
        break;

    case PMX_MODULE . '/articleadd':
        secarticleadd($secid, $title, $sec_content, $slanguage);
        break;

    case PMX_MODULE . '/artedit':
        secartedit($artid);
        break;

    case PMX_MODULE . '/artchange':
        secartchange($artid, $secid, $title, $sec_content, $slanguage);
        break;

    case PMX_MODULE . '/artdelete':
        secartdelete($artid, !empty($_REQUEST['ok']));
        break;

    default:
        sections();
        break;
}

?>