<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*

#Sections

RewriteRule ^Sections-.*-category-([0-9]+)(-.*)?\.html$ mod.php?name=Sections&secid=$1&_MORE_=$2 [L]
RewriteRule ^Sections-.*-article-([0-9]+)(-.*)?\.html$ mod.php?name=Sections&artid-$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $cid = array();
    $pid = array();
    $pic = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case (isset($para['secid']) && intval($para['secid'])):
                $pic[0][] = $para['secid'];
                $pic[$key] = $para;
                break;

            case (isset($para['artid']) && intval($para['artid'])):
                $pid[0][] = $para['artid'];
                $pid[$key] = $para;
                break;
        }
    }

    /**
     */
    if ($pic) {
        $inquery = implode(',', array_unique(array_shift($pic)));
        $qry = "SELECT secid,secname FROM {$prefix}_sections WHERE secid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($catid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$catid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($pic as $key => $link) {
            if (isset($titles[$link['secid']])) {
                /**
                 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
                 * also getrennt mit den Bindestrichen
                 * Einstellung:
                 * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
                 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
                 * übergeben
                 */
                $new_url = pmxModrewrite::title_parameters($link, 'secid');
                /**
                 * den neuen URL zusammensetzen
                 * Einstellung:
                 * nach belieben zusammensetzen und entspr. die .htaccess anpassen
                 */
                // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
                $new_url = $name . '-' . $titles[$link['secid']] . '-category-' . $link['secid'] . $new_url;
                /**
                 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
                 * Einstellung: keine, muss exakt so bleiben!
                 */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /**
     */
    if ($pid) {
        $inquery = implode(',', array_unique(array_shift($pid)));
        $qry = "SELECT artid, title FROM {$prefix}_seccont WHERE artid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($conid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$conid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($pid as $key => $link) {
            if (isset($titles[$link['artid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'artid');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['artid']] . '-article-' . $link['artid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    /**
     */
}

?>