<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 660 $
 * $Author: PragmaMx $
 * $Date: 2022-12-18 11:34:03 +0100 (So, 18. Dez 2022) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _SECTIONS;

        case $options['type'] === 'items':

            extract($options);

            $result = sql_query("SELECT a.artid, a.secid, a.title, a.content, a.counter, a.stime, UNIX_TIMESTAMP(a.stime) AS `date`, b.secname
              FROM {$prefix}_seccont AS a, {$prefix}_sections AS b
              WHERE a.secid = b.secid
                " . pmx_multilang_query('slanguage', 'AND') . "
                AND MATCH( a.title, a.content, b.secname)
                  AGAINST('{$search}' IN BOOLEAN MODE)
                AND b.secname <> ''
              ORDER BY a.artid DESC
              LIMIT 0," . intval($limit));

            if ($result) {
                while ($node = sql_fetch_assoc($result)) {
                    $path = array('modules.php?name=' . $module_name . '&amp;secid=' . $node['secid'] => $node['secname']
                        );
                    $entry = array();
                    $entry['title'] = $node['title'];
                    $entry['path'] = $path;
                    $entry['link'] = 'modules.php?name=' . $module_name . '&amp;artid=' . $node['artid'];
                    $entry['views'] = $node['counter'];
                    $entry['date'] = $node['date'];
                    $entry['moduletitle'] = _SECTIONS;
                    $entry['text'] = $node['content'];
                    $entry['module'] = $module_name;
                    $entries[] = $entry;
                }
            }
    }
} ;

?>