<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 989 $
 * $Author: PragmaMx $
 * $Date: 2024-02-08 10:58:33 +0100 (Do, 08 Feb 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(__DIR__));

$barcolordefaults = array("336699", "669933", "339966");

unset($sqlqry);
// Umfragen-Tabelle anpassen und Standardwert eintragen
if (!isset($tables["{$prefix}_poll_desc"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_desc` (
  `pollID` int(11) NOT NULL auto_increment,
  `pollTitle` varchar(100) NOT NULL default '',
  `timeStamp` int(11) NOT NULL default '0',
  `voters` mediumint(9) NOT NULL default '0',
  `planguage` varchar(30) NOT NULL default '',
  `artid` int(10) NOT NULL default '0',
  `pollactive` tinyint(1) unsigned NOT NULL default '1',
  `onlyonevote` tinyint(1) unsigned NOT NULL default '1',
  `pollcomments` tinyint(1) unsigned NOT NULL default '0',
  `representative` tinyint(1) unsigned NOT NULL default '1',
  `description` text NULL,
  PRIMARY KEY  (`pollID`),
  KEY `pollactive` (`pollactive`),
  KEY `planguage` (`planguage`),
  KEY `artid` (`artid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_poll_data"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_data` (
  `pollID` int(11) NOT NULL default '0',
  `optionText` varchar(100) NOT NULL default '',
  `optionCount` int(11) NOT NULL default '0',
  `barcolor` varchar(6) NOT NULL default '{$barcolordefaults[0]}',
  `voteID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pollID`,`voteID`),
  KEY `pollID` (`pollID`),
  KEY `voteID` (`voteID`),
  KEY `optionText` (`optionText`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_poll_check"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_poll_check` (
  `ip` varchar(40) NOT NULL default '',
  `uid` int(11) unsigned NOT NULL default '0',
  `time` int(11) unsigned NOT NULL default '0',
  `pollID` int(11) unsigned NOT NULL default '0',
  `voteID` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ip`,`uid`,`pollID`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_pollcomments"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_pollcomments` (
  `tid` int(11) NOT NULL auto_increment,
  `pid` int(11) default '0',
  `pollID` int(11) default '0',
  `date` datetime default NULL,
  `name` varchar(60) NOT NULL default '',
  `email` varchar(60) default NULL,
  `url` varchar(60) default NULL,
  `host_name` varchar(60) default NULL,
  `subject` varchar(60) NOT NULL default '',
  `comment` text NULL,
  `score` tinyint(4) NOT NULL default '0',
  `reason` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`tid`),
  KEY `pollID` (`pollID`),
  KEY `date` (`date`),
  KEY `name` (`name`),
  KEY `host_name` (`host_name`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Daten einfuegen
$numrows = sql_num_rows(sql_query("SELECT `pollID` FROM `{$prefix}_poll_data` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'sehr gut', 0, 1);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'gut', 0, 2);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'ganz nett', 0, 3);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'gewöhnungsbedürftig', 0, 4);";
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_data` (pollID, optionText, optionCount, voteID) VALUES (1, 'na ja ....', 0, 5);";
}

$numrows = sql_num_rows(sql_query("SELECT `voteID` FROM `{$prefix}_poll_data` WHERE `optionText`='' OR ISNULL(`optionText`) LIMIT 1"));
if ($numrows) {
    $sqlqry[] = "DELETE FROM `{$prefix}_poll_data` WHERE `optionText`='' OR ISNULL(`optionText`);";
}


$numrows = sql_num_rows(sql_query("SELECT `pollID` FROM `{$prefix}_poll_desc` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO `{$prefix}_poll_desc` (pollID, pollTitle, timeStamp, voters, planguage, artid, pollactive) VALUES (1, 'Wie gefällt Ihnen diese Seite', " . intval(time()) . ", 0, 'german', 0, 1);";
} else {
    if (!isset($tf['pollactive'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `pollactive` = 1;";
    }
    if (!isset($tf['pollcomments'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `pollcomments` = 1;";
    }
    if (!isset($tf['onlyonevote']) || !isset($tf['representative'])) {
        // wenn die Felder onlyonevote oder representative noch nicht vorhanden war
        // ab pragmaMx 2.0
        $sqlqry[] = "UPDATE `{$prefix}_poll_desc` SET `onlyonevote` = 1, `representative` = 1 ;";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}



if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// aufraeumen
unset($numrows);

?>