<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

$hook = function($module_name, $options, &$entries)
{
    global $prefix;

    switch (true) {
        case $options['type'] === 'modules':
            return $entries[$module_name] = _SURVEYS;

        case $options['type'] === 'items':

            extract($options);

            $polls = array();

            /* alle Umfragen finden, die den Suchtext in der Beschreibung oder im Titel haben */
            $qry = "SELECT `pollID`
              FROM `{$prefix}_poll_desc`
              WHERE MATCH( `pollTitle`, `description` )
                AGAINST('{$search}' IN BOOLEAN MODE)
                AND `pollactive` > 0
                " . pmx_multilang_query('planguage', 'AND') . "
              LIMIT 0," . intval($limit);
            $result = sql_query($qry);
            while (list($id) = sql_fetch_row($result)) {
                $polls[] = $id;
            }

            /* alle Umfragen finden, die den Suchtext in einer Frage haben */
            $qry = "SELECT `pollID`
              FROM `{$prefix}_poll_data`
              WHERE MATCH( `optionText` )
                AGAINST('{$search}' IN BOOLEAN MODE)
              LIMIT 0," . intval($limit * 4);
            $result = sql_query($qry);
            while (list($id) = sql_fetch_row($result)) {
                $polls[] = $id;
            }

            /* wenn keine entspr. Umfragen gefunden, raus hier... */
            if (!$polls) {
                return false;
            }

            /* jetzt die Daten der bisher gefundenen Umfragen auslesen */
            $qry = "SELECT `pollID`, `timeStamp` AS `date`, `pollTitle` AS `title`, `description` AS `text`, `voters` AS `views`
              FROM `{$prefix}_poll_desc`
              WHERE `pollactive` > 0
                " . pmx_multilang_query('planguage', 'AND') . "
                AND `pollID` IN(" . implode(',', $polls) . ")
              ORDER BY `date` DESC, `pollID` DESC
              LIMIT 0," . intval($limit);
            $result = sql_query($qry);
            while ($entry = sql_fetch_assoc($result)) {
                $entry['title'] = _SURVEY . ': ' . $entry['title'];
                $entry['link'] = "modules.php?name=" . $module_name . "&amp;op=poll&amp;pollID=" . $entry['pollID'];
                $entry['moduletitle'] = _SURVEYS;

                /* und noch die zugehörigen Fragen dazupacken */
                $qry = "SELECT `optionText`
                FROM `{$prefix}_poll_data`
                WHERE `pollID`=" . intval($entry['pollID'] . "
                ORDER BY voteID");
                $result2 = sql_query($qry);
                while (list($text) = sql_fetch_row($result2)) {
                    $entry['text'] .= '  &middot; ' . $text;
                }
                $entry['module'] = $module_name;
                unset($entry['pollID']);
                $entries[] = $entry;
            }
    }
} ;

?>