<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 568 $
 * $Author: PragmaMx $
 * $Date: 2022-08-12 10:10:06 +0200 (Fr, 12. Aug 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');

include_once(PMX_SYSTEM_DIR . "/mxNewsFunctions.php");

$module_name = basename(dirname(__FILE__));

//mxGetLangfile($module_name);

$index = (!empty($_GET['index']));
pmxBase::set("plugins",0);


$pagetitle = $module_name;
$themelist = mxGetAvailableThemes();

mxIncludeHeader();
echo '<h3>'.$module_name.'</h3>';
$outputlist="<div class=\"content\">";

$themes=array();
foreach ($themelist as $th_name => $theme) {
   $output=false;
   
   if (file_exists(PMX_THEMES_DIR.DS.$theme.DS."theme_thumbnail.png")) {
     $image=mxCreateImage(PMX_THEMES_DIR.DS.$theme.DS."theme_thumbnail.png");
     $output="<a href=\"".modulesURL($module_name,"themeselect=".$theme)."\" >".$image."<br /><span class=\"align-center tiny\">".$theme."</span></a>";
   }

   if ($output) $outputlist .= "<div style=\"display:inline-block;margin:5px;padding:5px;border:2px solid ".$bgcolor2.";\">". $output . "</div>";
}
echo $outputlist . "</div>";

mxIncludeFooter();

function tt_include_block()
{
    $block['position'] = 'l';
    $block['settings'] = array();
    @include('blocks/block-Themes.php');
    return $content;
}

function getTestBlock()
{
    global $prefix;
    /* einen Block abrufen um sicher zu stellen, dass wirklich alle Felder belegt sind */
    $qry = "SELECT * FROM {$prefix}_blocks WHERE active=1 LIMIT 1";
    $result = sql_system_query($qry);
    $block = sql_fetch_assoc($result);

    $block['bid'] = 1;
    $block['bkey'] = "";
    $block['content'] = 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.';
    $block['url'] = "";
    $block['position'] = "c";
    $block['weight'] = "1";
    $block['active'] = "1";
    $block['refresh'] = "0";
    $block['time'] = "0";
    $block['blanguage'] = "";
    $block['blockfile'] = "block-Modules.php";
    $block['view'] = "0";
    $block['order'] = "1";

    return $block;
}

function getTestStory()
{
    global $tipath, $prefix;
    $path = trim($tipath, ' ;,:./\\');
    $endings = array('gif', 'png', 'jpg', 'jpeg');
    $tmp = (array)glob(str_replace(DS, '/', $path . '/*'));
    $image = 'AllTopics.gif';
    foreach ($tmp as $image) {
        $info = pathinfo($image);
        switch (true) {
            case !isset($info['extension']):
            case !in_array(strtolower($info['extension']), $endings):
            case $info['basename'] === 'AllTopics.gif';
            case $info['basename'] === 'blanktopic.gif';
                continue 2;
            default:
                $image = $info['basename'];
                break 2;
        }
    }

    /* eine Story abrufen um sicher zu stellen, dass wirklich alle Felder belegt sind */
    $qry = "SELECT s.*, s.sid AS s_sid, c.title AS cattitle, t.topicname, t.topicimage, t.topictext
            FROM ({$prefix}_stories AS s
            LEFT JOIN {$prefix}_stories_cat AS c ON s.catid = c.catid)
            LEFT JOIN {$prefix}_topics AS t ON s.topic = t.topicid
            WHERE s.time <= now()
            LIMIT 1";
    $result = sql_query($qry);
    $story = sql_fetch_assoc($result);

    $story = vkpGetStoryDetails($story);

    $story['col'] = 1;
    $story["notes"] = _TTCOMMENTS;
    $story['hometext'] = '<p>' . _TTABSURDEXAMPLETEXT . "</p><p>Iuno, Minerva, Venus deae inter se certaverunt, quae esset pulcherrima.</p><p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet.</p>";
    $story['col'] = '1 ';
    $story['bodytext'] = '<p>' . _TTFURTHERREADMORE . "</p><p>" . _TTFURTHERABSURDEXAMPLETEXT . "</p><p>Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. </p><p>Consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus. </p><p>Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut labore et dolore magna aliquyam erat, sed diam voluptua. At vero eos et accusam et justo duo dolores et ea rebum. Stet clita kasd gubergren, no sea takimata sanctus est Lorem ipsum dolor sit amet. </p><p>Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi. Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. </p>";
    $story['title'] = 'Der Titel';
    $story['more'] = '<a href="#"><b>mehr...</b></a> ';
    $story['score'] = 'Punkte: 0 ';
    $story['datetime'] = '18.09.2008';
    $story['morelink'] = '(<a href="#"><b>mehr...</b></a> | 1224 mehr Zeichen |  | <a href="#" title=\'Druckbare Version\'><img src="images/print.gif" border="0" alt="Druckbare Version" title="Druckbare Version"></a>&nbsp;&nbsp;<a href="#" title=\'Diesen Artikel an einen Freund senden\'><img src="images/friend.gif" border="0" alt="Diesen Artikel an einen Freund senden" title="Diesen Artikel an einen Freund senden"></a> | Punkte: 0) ';
    $story['title_formated'] = _TTFUNCTION . " themeindex()";
    $story['counter'] = '0';
    $story['informant'] = _TTUSERNAME;
    $story['aid'] = _TTADMINNAME;
    $story['topic'] = '1';
    $story['topicname'] = _TTTOPICNAME;
    $story['topictext'] = _TTDESCRIPTIONTOPIC;
    $story['topicimage'] = $image;
    $story['ratings'] = '34';
    $story['sid'] = '0';
    $story['allmorelink'] = vkpTestGetMoreLink($story);
    return $story;
}

function vkpTestGetMoreLink($story)
{
    $formated['homecount'] = strlen(strip_tags($story['hometext']));
    $formated['bodycount'] = strlen(strip_tags($story['bodytext']));
    $formated['totalcount'] = $formated['homecount'] + $formated['bodycount'];
    $formated['storylink'] = "<a href=\"#" . $story['sid'] . "\">";
    $formated['printerlink'] = "<a href=\"#\" title='" . _PRINTER . "'>";
    $formated['friendlink'] = (mxModuleAllowed('Recommend_Us')) ? "<a href=\"#\" title='" . _FRIEND . "'>" : "<a>";
    $formated['datetime'] = _ON . " " . $story['datetime'];
    $formated['counter'] = $story['counter'] . " " . _READS;
    $formated['informantlink'] = (empty($story['informant'])) ? "<a title='" . _BY . ": " . $GLOBALS['anonymous'] . "'>" : "<a href='#' title='" . _BY . ": " . $story['informant'] . "'>";
    $formated['comments'] = "0 " . _COMMENTSQ;
    // $formated['bytemore'] = "".$formated['totalcount']." "._BYTESMORE."";
    if (!empty($story['url'])) {
        $formated['postedby'] = _POSTEDBY . " <a href='#' target='new'>" . $story['aid'] . "</a>";
    } else if (!empty($story['email'])) {
        $formated['postedby'] = _POSTEDBY . " <a href='#'>" . $story['aid'] . "</a>";
    } else {
        $formated['postedby'] = _POSTEDBY . " " . $story['aid'];
    }

    if (($formated['bodycount'] > 0) || ($story['comments'] > 0)) {
        $morelink['more'] = $formated['storylink'] . "<b>" . _READMORE . "</b></a>";
    }
    if ($formated['bodycount'] > 0) {
        $morelink['bytemore'] = $formated['totalcount'] . " " . _BYTESMORE;
    }
    $morelink['comments'] = "";
    // / Kommentare erlaubt?
    if ($GLOBALS['articlecomm'] == 1 && empty($story['acomm'])) { // // Achtung!!! acomm: 0 = Ja , 1 = Nein
        $story['comments'] = (empty($story['comments'])) ? 0 : (int)$story['comments'];
        if (empty($story['comments'])) $formated['comments'] = $story['comments'] . " " . _COMMENTSQ;
        else if ($story['comments'] == 1) $formated['comments'] = $story['comments'] . " " . _COMMENT;
        else $formated['comments'] = $story['comments'] . " " . _COMMENTS;
        $morelink['comments'] = $formated['storylink'] . $formated['comments'] . "</a>";
    }
    // // Achtung!!! acomm: 0 = Ja , 1 = Nein
    $formated['commentslink'] = (!empty($story['acomm']) || empty($GLOBALS['articlecomm'])) ? "<a>" : "<a href=\"#\" title=\"" . $formated['comments'] . "\">";
    if (empty($formated['bodycount']) && $story['acomm'] == 0) {
        $morelink['comments'] .= " " . $formated['storylink'] . "<b>" . _READMORE . "</b></a>";
    }

    $morelink['functions'] = $formated['printerlink'] . "<img src=\"images/print.gif\" border=\"0\" alt=\"" . _PRINTER . "\" title=\"" . _PRINTER . "\" width=\"16\" height=\"11\"></a>";
    $morelink['functions'] .= (mxModuleAllowed('Recommend_Us')) ? "&nbsp;&nbsp;" . $formated['friendlink'] . "<img src=\"images/friend.gif\" border=\"0\" alt=\"" . _FRIEND . "\" title=\"" . _FRIEND . "\" width=\"16\" height=\"11\"></a>" : "";
    if (!empty($story['catid'])) {
        $morelink['categorie'] = "<a href=\"#\" title=\"" . _NEWSCATEGORY . ": " . $story['cattitle'] . "\">" . $story['cattitle'] . "</a>";
    }
    $rated = "2,68";//(empty($story['score'])) ? 0 : substr($story['score'] / $story['ratings'], 0, 4);
    $morelink['score'] = _SCORE . " " . $rated;

    $morelink['formated'] = "(" . implode(" | ", $morelink) . ")";

    $morelink = array_merge($morelink, $formated);

    return $morelink;
}

function getAdminForm(){
	
	$headers=array();
	$values = array();
	$i=0;$k=0;
	for ($i=0;$i<5;$i++) {
		$headers[]['name']="Title ".$i;
		
		for ($k=0 ;$k<8 ;$k++) {
			$values[$k][$i]="Eintrag $i - $k";
		}
	}
	
    $tb = load_class('AdminForm', "adminFormMain");
    $tb->__set("tb_text", "Description");
    $tb->__set("tb_direction", 'right');
    $tb->__set("infobutton", true);
    $tb->__set("cssclass", "toolbar1");
    $tb->__set('homelink', false);
	$tb->__set('checklistflag', true);

	$tb->addToolbar("publishx");
	$tb->addToolbar("Content");
	$tb->addToolbar("Categorys");
    $tb->addToolbar("tools");
    $tb->addToolbar("config");
    $temp=12345.357;
    $tb->addFieldSet("head", "Fieldset 1", "Fieldset Description", false);	
    $tb->addFieldSet("head2", "Fieldset 2", "Fieldset Description", true);	
    $tb->add("head", "output", "HTML-text");
    $tb->add("head", "input", "owner_name", $temp, "Input", "Description");
    $tb->add("head", "yesno", "publish",  $temp,"Yes or No", "Select");
    $tb->add("head", "checkbox", "check",  $temp,"Check", "Checkbox");
    $tb->add("head", "radio", "radio", $temp, "Radio", "Radio");	
    $tb->add("head", "selectlanguage", "lang", $temp, "Language", "select language");	
	
	$tb->add("head","table",$headers,$values);
    $tb->add("head2", "editor", "text1", "lorem Ipsum", "", "", 100,true,true);	
    $form = $tb->Show();

	return $form;
}
?>