<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 * this file based on:
 * User Guestbook
 * Copyright (c)  Jens Ferner - http://www.netz-id.de
 * micro - http://guggemahier.de
 * modified by (c) 2005 by jubilee - http://www.marx-city.de
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
pmxBase::set("plugins",0);
include(PMX_MODULES_DIR . DS . $module_name . DS . 'settings.php');

function ugb_get_smilies()
{
    global $module_name;
    $smilies = array(// Array mit den Smilies sammt Grafikpfaden
        ":1:" => PMX_MODULES_PATH . $module_name . "/smilies/smile.gif",
        ":2:" => PMX_MODULES_PATH . $module_name . "/smilies/cool.gif",
        ":3:" => PMX_MODULES_PATH . $module_name . "/smilies/mad3.gif",
        ":4:" => PMX_MODULES_PATH . $module_name . "/smilies/tongue.gif",
        ":5:" => PMX_MODULES_PATH . $module_name . "/smilies/puzzled.gif",
        ":6:" => PMX_MODULES_PATH . $module_name . "/smilies/cry_smile.gif",
        ":7:" => PMX_MODULES_PATH . $module_name . "/smilies/exclamation_smile.gif",
        ":8:" => PMX_MODULES_PATH . $module_name . "/smilies/mad.gif",
        ":9:" => PMX_MODULES_PATH . $module_name . "/smilies/sad.gif",
        ":10:" => PMX_MODULES_PATH . $module_name . "/smilies/shocked.gif",
        ":11:" => PMX_MODULES_PATH . $module_name . "/smilies/thumbdown.gif",
        ":12:" => PMX_MODULES_PATH . $module_name . "/smilies/thumbup.gif",
        ":13:" => PMX_MODULES_PATH . $module_name . "/smilies/question.gif",
        ":14:" => PMX_MODULES_PATH . $module_name . "/smilies/wink.gif");
    return $smilies;
}

function intro($addlink = false)
{
    global $owner, $is_own_book, $zuvoll, $allow_backup, $userdeniedpost, $module_name;

    ob_start();

    /* modulspezifisches Stylesheet einbinden */
    pmxHeader::add_style(PMX_MODULES_PATH . $module_name . '/style/style.css');

    ?>

<div class="ugb-head-1">

<?php
    switch (true) {
        case $zuvoll:
            echo '<p class="note">' . _USERGB_MAXENTRY . '<br />' . _USERGB_NOMORE . '</p>';
            break;

        case !$is_own_book && empty($owner['user_guestbook']):
            /* Besucher im fremden nicht aktiven Gaestebuch */
            echo '<p class="note">' . _USERGUESTBOOKDEAKT1 . " " . $owner['uname'] . " " . _USERGUESTBOOKDEAKT2 . '</p>';
            break;

        default:
            echo '<p>' . _USERGB_REGUSER . '</p>';
            if ($addlink && MX_IS_USER && !($is_own_book && $userdeniedpost)) {
                echo '<a href="modules.php?name=' . $module_name . '&amp;op=signin&amp;owner=' . $owner['uname'] . '" class="ugb-addlink">' . _USERGB_INPUTHERE . "</a>";
            }
            break;
    }

    if ($allow_backup && $is_own_book && false) {
        echo '
        </div>
        <div class="ugb-head-2">
        <a href="modules.php?name=' . $module_name . '&amp;op=do_backup&amp;owner=' . $owner['uname'] . '" class="ugb-backup">' . _USERGB_BACKUPHERE . '</a>
        ';
    }

    ?>
</div><br class="clear" />
<?php

    return ob_get_clean();
}

function viewguestbook()
{
    global $owner, $is_own_book, $useraddsig, $prefix, $module_name, $user_prefix, $AddSmilies, $anzahl, $umbruch, $userdeniedpost;

    $counter = (isset($_GET['counter'])) ? intval($_GET['counter']) : 0;

    $internal_counter = 0; # Counter um zu Zählen wieviele Eintrage aus der Datenbank ausgelesen wurden
    $query = "SELECT gb.wer, gb.gid, gb.date, gb.text, gb.dummy, gb.fromuserid, u.uid, u.uname, u.user_sig
            FROM " . $prefix . "_userguest AS gb
            LEFT JOIN {$user_prefix}_users AS u ON gb.fromuserid = u.uid
            WHERE gb.touser='" . mxAddSlashesForSQL($owner['uname']) . "'
            ORDER BY gb.date DESC limit " . intval($counter) . "," . intval($anzahl) . "";
    $result1 = sql_query($query);
    if (!$result1) {
        return guestbook_message(_GBERRORTXT1 . " get page of userguestbook entry's");
    }

    ob_start();

    echo intro(true);

    if ($is_own_book || MX_IS_ADMIN) {
        echo "<form action=\"modules.php?name=" . $module_name . "&amp;owner=" . $owner['uname'] . "&amp;op=delete_selected\" method=\"post\">\n";
    }
    echo "<table cellpadding=\"4\" cellspacing=\"1\" class=\"bgcolor2 full\">\n";
    while ($row = sql_fetch_assoc($result1)) {
        $internal_counter ++;
        if ($is_own_book && empty($row['dummy'])) {
            if (!sql_query("UPDATE " . $prefix . "_userguest SET dummy='1' where touser='" . mxAddSlashesForSQL($owner['uname']) . "' AND dummy=0 AND gid=" . intval($row['gid']))) {
                return guestbook_message(_GBERRORTXT1 . " set dummy = true");
            }
        }
        if ($row['date'] < 1208781330) {
            $row['text'] = mxnl2br($row['text']);
        }
        $row['text'] = wordwrap2($row['text'], $umbruch, " ", " ");
        if ($AddSmilies) {
            $row['text'] = de_smiler($row['text']);
        }

        if ($useraddsig && $row['user_sig']) {
            $userssignatur = '<br /><br /><hr />' . pmxSigBbCode($row['user_sig']);
            $row['text'] = str_replace('<!-- ~~USERSIGNATUR~~ -->', $userssignatur, $row['text']);
        }

        $row['gid'] = intval($row['gid']);

        if ($row['uid'] && $row['uname']) {
            $from = mxCreateUserprofileLink($row['uname']);

            /* aktuelles Benutzerbild ermitteln */
            $pici = load_class('Userpic', $row['uid']);
            $ug_img = $pici->getHtml('small');
            if ($ug_img) {
                $ug_img = '<br /><br />' . $ug_img;
            }
        } else {
            $from = $row['wer'];
            $ug_img = '';
        }

        echo "<tr valign=\"top\">\n";
        echo "<td width=\"25%\" valign=\"top\" align=\"left\" class=\"bgcolor1 content\">\n";
        echo "<span class=\"tiny\">" . _USERGB_INPUTDATE . ": <br />" . mx_strftime(_XDATESTRING, $row['date']) . "</span><br />\n";
        echo '<span class="tiny">' . _USERGB_FROM . ': </span><b>' . $from . '</b>' . $ug_img . "\n";
        if ($is_own_book || MX_IS_ADMIN) {
            echo "<br /><br /><input type=\"checkbox\" name=\"check_delete[]\" value=\"" . $row['gid'] . "\" /> <span class=\"tiny\">" . _USERGB_DELMESSAGE . "</span>\n";
        }
        echo "</td>\n";
        echo "<td width=\"75%\" class=\"bgcolor1 content\">" . $row['text'] . "</td>\n";
        echo "</tr>\n";
    }
    if ($is_own_book || MX_IS_ADMIN) {
        echo "<tr><td colspan=\"2\" align =\"center\">";
        echo "<input type=\"hidden\" name=\"counter\" value=\"" . $counter . "\" />\n";
        echo "<input type=\"hidden\" name=\"internal_counter\" value=\"" . $internal_counter . "\" />\n";
        echo "<input type=\"submit\" value=\"" . _USERGB_DELDO . "\" /></td></tr>\n";
    }
    echo "</table></form>\n";
    prevnext($counter, $internal_counter);
}

function guestbookinput()
{
    global $owner, $is_own_book, $visitor, $AddSmilies, $maxchars, $umbruch, $useraddsig, $module_name, $userdeniedpost, $allow_html;

    if ($is_own_book && $userdeniedpost) {
        return guestbook_message(_USERGBTHISISYOURS . ' ' . _USERGBADMINSAYNO);
    }

    if (!MX_IS_USER) {
        return guestbook_message(_USERGBTHISISANONYMOUS);
    }

    if ($AddSmilies && (!($GLOBALS['wysiwyg_userguest']))) {
        pmxHeader::add_script(PMX_MODULES_PATH . $module_name . '/insert_text.js');
    }

    if ($maxchars) {
        pmxHeader::add_script(PMX_MODULES_PATH . $module_name . '/validate.js');
        if ($GLOBALS['wysiwyg_userguest']) {
            $SPAWON = "JA";
        } else {
            $SPAWON = "NEIN";
        }
        $onsubmit = "onsubmit=\"return validate(" . $maxchars . ",'" . $SPAWON . "')\"";
    } else {
        $onsubmit = "";
    }

    echo intro(false);

    echo "<form action=\"modules.php?name=" . $module_name . "&amp;owner=" . $owner['uname'] . "&amp;op=add\" method=\"post\" name=\"coolsus\" id=\"coolsus\" " . $onsubmit . ">\n";
    echo "<br /><b>" . _USERGB_YOURENTRY . "</b>:<br />\n";
    if ($GLOBALS['wysiwyg_userguest']) {
        $toolbar = ($allow_html) ? 'default' : 'mini';
        $editor = load_class('Textarea', array('name' => 'text', 'mode' => $toolbar, 'height' => 250));
        $editor->show();
    } else {
        echo "<textarea name=\"text\" cols=\"60\" rows=\"10\"></textarea><br />";
        if ($AddSmilies) {
            $smilies = ugb_get_smilies();
            foreach ($smilies as $key => $value) {
                echo "<a onclick=\"insert_text(' " . $key . " ');\" class=\"ugb-smilie\"><img src=\"" . $value . "\" border=\"0\" alt=\"\" /></a> \n";
            }
            echo "<br /><br />\n";
        }
    }
    echo "<input type=\"submit\" value=\"" . _USERGB_SUBMIT . "\" />\n";
    echo "</form>\n";
}

function guestbookdbinput()
{
    global $prefix, $visitor, $owner, $useraddsig, $is_own_book, $PMbeiEintrag, $allow_html, $userdeniedpost, $module_name;

    $text = mxStripSlashes($_POST['text']);

    if ($is_own_book && $userdeniedpost) {
        return guestbook_message(_USERGBTHISISYOURS . ' ' . _USERGBADMINSAYNO);
    }

    if (!MX_IS_USER) {
        return guestbook_message(_USERGBTHISISANONYMOUS);
    }

    if (strlen(strip_tags($text)) <= 3) {
        return guestbook_message(_USERGB_SINNVOLL);
    }

    if (!$GLOBALS['wysiwyg_userguest']) {
        $text = mxnl2br($text);
    }

    if (!$allow_html) {
        $text = strip_tags($text, '<b><u><i><br><hr>');
    } else {
        $text = mxPrepareToDisplay($text);
    }

    if ($useraddsig && $visitor['user_sig']) {
        $text .= "\n" . '<!-- ~~USERSIGNATUR~~ -->';
    }

    $qry = "insert into " . $prefix . "_userguest (touser,text,date,wer,dummy,touserid,fromuserid) VALUES ('" . mxAddSlashesForSQL($owner['uname']) . "','" . mxAddSlashesForSQL($text) . "','" . time() . "','" . mxAddSlashesForSQL($visitor['uname']) . "',0," . intval($owner['uid']) . "," . intval($visitor['uid']) . ")";
    if (!sql_query($qry)) {
        return guestbook_message(_GBERROR1 . _GBERRORTEXT . _GBERRORTXT1 . ' (' . sql_errno() . ')');
    }
    if ($PMbeiEintrag == true) {
        $qryxx = "INSERT INTO " . $prefix . "_priv_msgs (msg_image, subject, from_userid, to_userid, msg_time, msg_text) ";
        $qryxx .= "VALUES ('icon1.gif', '" . mxAddSlashesForSQL(_GBGNEWSUBJECT) . "', " . intval($visitor['uid']) . ", " . intval($owner['uid']) . ", now(), '" . mxAddSlashesForSQL(_GBNEWTXT) . "')";
        if (!sql_query($qryxx)) {
            return guestbook_message(_GBERROR2 . _GBERRORTEXT . _GBERRORTXT1 . ' (' . sql_errno() . ')');
        }
    }
    mxRedirect("modules.php?name=" . $module_name . "&owner=" . $owner['uname'], _GBTHX);
}

function delselected()
{
    global $prefix, $owner, $is_own_book, $anzahl, $module_name;

    $counter = intval($_POST['counter']);

    if (!isset($_POST['check_delete'])) {
        return mxRedirect("modules.php?name=" . $module_name . "&owner=" . $owner['uname'] . "&counter=" . $counter);
    }

    $gid_array = (array)$_POST['check_delete'];
    $int_counter = intval($_POST['internal_counter']);

    if (!$is_own_book && !MX_IS_ADMIN) {
        mxRedirect("modules.php?name=" . $module_name . "&owner=" . $owner['uname'] . "&counter=" . $counter);
        return;
    }

    $internal_counter = 0;
    foreach ($gid_array as $key => $delete_gid) {
        $internal_counter++;
        if (!sql_query("DELETE FROM " . $prefix . "_userguest WHERE gid=" . intval($delete_gid))) {
            return guestbook_message(_GBERRORTXT1 . '  delete Userguest-Row');
        }
    }
    if ($internal_counter == $int_counter) {
        $counter = ($counter - $anzahl);
    }
    if ($counter < 0) {
        $counter = 0;
    }
    return mxRedirect("modules.php?name=" . $module_name . "&owner=" . $owner['uname'] . "&counter=" . $counter, _USERGB_DELETEMESSG2);
}

function prevnext ($counter, $int_counter)
{
    global $anzahl, $module_name, $owner;

    $counter_next = ($counter + $anzahl);
    $counter_prev = ($counter - $anzahl);
    $paramto = 'modules.php?name=' . $module_name . '&amp;owner=' . $owner['uname'];
    $parameter_nextlink = $paramto . '&amp;counter=' . $counter_next;
    $parameter_prevlink = $paramto . '&amp;counter=' . $counter_prev;

    switch (true) {
        case ($counter == 0) && ($GLOBALS['menge'] > $counter_next):
            $prev = '&nbsp;';
            $next = '<a href="' . $parameter_nextlink . '">' . _GBNEXT . '&nbsp;' . $anzahl . ' &gt;&gt;&gt;</a>';
            break;
        case ($counter >= $anzahl) && ($GLOBALS['menge'] > $counter_next):
            $prev = '<a href="' . $parameter_prevlink . '">&lt;&lt;&lt; ' . _GBPREV . '&nbsp;' . $anzahl . '</a>';
            $next = '<a href="' . $parameter_nextlink . '">' . _GBNEXT . '&nbsp;' . $anzahl . ' &gt;&gt;&gt;</a>';
            break;
        case ($counter >= $anzahl) && ($GLOBALS['menge'] <= $counter_next):
            $prev = '<a href="' . $parameter_prevlink . '">&lt;&lt;&lt; ' . _GBPREV . '&nbsp;' . $anzahl . '</a>';
            $next = '&nbsp;';
            break;
        default:
            $prev = '&nbsp;';
            $next = '&nbsp;';
    }

    echo '<br /><table width="100%"><tr><td width="50%" align="left">' . $prev . '</td><td width="50%" align="right">' . $next . '</td></tr></table>';
}

/**
 * Standard-Meldungsseite
 */
function guestbook_message($msg)
{
    ob_start();

    ?>
<div class="important content"><?php echo $msg ?><br /><br />
<?php echo _GOBACK ?>
</div>
    <?php
    $out = ob_get_clean();

    echo $out;
}

function is_guestbook_full ()
{
    global $prefix, $maxentrys, $owner;

    $result = sql_query("SELECT COUNT(gid) FROM " . $prefix . "_userguest WHERE touser='" . mxAddSlashesForSQL($owner['uname']) . "'");
    list($GLOBALS['menge']) = sql_fetch_row($result);
    if ($maxentrys) {
        return ($GLOBALS['menge'] >= $maxentrys);
    }
    return false;
}

function de_smiler($message)
{
    $smilies = ugb_get_smilies();
    foreach ($smilies as $key => $value) {
        $message = str_replace($key, "&nbsp;<img src=\"" . $value . "\" alt=\"\" />&nbsp;", $message);
    }
    return $message;
}

switch (true) {
    case !isset($_GET['owner']) && isset($_GET['usernamen']):
        /* Abwaertskompatibilitaet vor 1.12 */
        $owner = mxGetUserDataFromUsername($_GET['usernamen']);
        break;

    case !isset($_GET['owner']) && isset($_GET['touser']):
        /* Abwaertskompatibilitaet vor 1.12 */
        $owner = mxGetUserDataFromUsername($_GET['touser']);
        break;

    case isset($_GET['owner']):
        $owner = mxGetUserDataFromUsername($_GET['owner']);
        break;

    case MX_IS_USER:
        $owner = mxGetUserData();
        break;

    default:
        $owner = array();
}

switch (true) {
    case !$owner:
        /* ungueltigen oder keinen Owner angegeben */
        mxErrorScreen(_USERGB_ERRORMESSAGE);
        return;

    case MX_IS_USER:
        $visitor = mxGetUserData();
        $is_own_book = $visitor['uname'] == $owner['uname'];
        break;

    default:
        $visitor = array();
        $is_own_book = false;
        $_GET['op'] = 'view';
}

/* Gaestebuch voll? Variable setzen */
$zuvoll = is_guestbook_full();

ob_start();

switch (true) {
    case !isset($_GET['op']):
        viewguestbook();
        break;

    case $_GET['op'] == 'signin' && !$zuvoll:
        guestbookinput();
        break;

    case $_GET['op'] == 'add' && !$zuvoll:
        guestbookdbinput();
        break;

    case $_GET['op'] == 'delete_selected':
        delselected();
        break;

    case $_GET['op'] == 'do_backup':
        include(dirname(__FILE__) . DS . 'backup.php');
        uguest_backup();
        return;

    case $_GET['op'] == 'view':
    default:
        viewguestbook();
}

$out = ob_get_clean();

if (!$out) {
    return;
}
require_once(PMX_SYSTEM_DIR . DS . 'mx_userfunctions.php');
$pagetitle = sprintf(_USERGB_VIEWIT, $owner['uname']);
$view = new pmxUserPage($owner);
if ($is_own_book) {
    $view->subtitle = _GUESTBOOKVIEW;
} else {
    $view->subtitle = _GUESTBOOKVIEW . ' - ' . $owner['uname'];
}
$view->tabname = 'pmxugb';
$view->show($out);

?>