<?php

/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 723 $
 * $Author: Nouvelle $
 * $Date: 2023-11-04 20:40:31 +0100 (Sa, 04 Nov 2023) $
 */

$hook = function ($module_name, $options, &$hook_result) {
  // $options enthält die kompletten Daten des aktuellen Admins
  global $prefix, $user_prefix;

  if ($options['radminlink']) {
    list($num) = sql_fetch_row(sql_query("SELECT count(lid) FROM {$prefix}_links_newlink"));
    if ($num) {
      // Eintrag
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name),
        'text' => (($num > 1) ? _AB_WLINKS : _AB_WLINK)
      );
    }

    $counter = [
      "brokenlink_0" => 0,
      "brokenlink_1" => 0
    ];

    // Check brokenlink
    $result = sql_system_query("SELECT * FROM {$prefix}_links_modrequest");
    while ($value = sql_fetch_assoc($result)) {
      if ($value["brokenlink"] === 0) {
        $counter["brokenlink_0"]++;
      } elseif ($value['brokenlink'] === 1) {
        $counter["brokenlink_1"]++;
      }
    }

    // Eintrag
    if ($counter["brokenlink_0"] > 0) {
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name, 'ListModRequests'),
        'text' => $counter["brokenlink_0"] > 1 ? _AB_MODREQLINKS : _AB_MODREQLINK
      );
    }

    // Eintrag
    if ($counter["brokenlink_1"] > 0) {
      $hook_result[] = array(
        'module' => $module_name,
        'count' => $num,
        'link' => adminUrl($module_name, 'ListBroken'),
        'text' => $counter["brokenlink_1"] > 1 ? _AB_BROKENLINKS : _AB_BROKENLINK
      );
    }
  }
};
