<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 989 $
 * $Author: PragmaMx $
 * $Date: 2024-02-08 10:58:33 +0100 (Do, 08 Feb 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["{$prefix}_links_links"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_links` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `date` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `hits` int(11) NOT NULL default '0',
  `submitter` varchar(60) NOT NULL default '',
  `linkratingsummary` double(6,4) NOT NULL default '0.0000',
  `totalvotes` int(11) NOT NULL default '0',
  `totalcomments` int(11) NOT NULL default '0',
  PRIMARY KEY  (`lid`),
  KEY `cid` (`cid`),
  KEY `hits` (`hits`),
  KEY `title` (`title`),
  KEY `date` (`date`),
  KEY `linkratingsummary` (`linkratingsummary`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_newlink"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_newlink` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `submitter` varchar(60) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`lid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_categories"])) {

    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_categories` (
  `cid` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `cdescription` text NULL,
  `parentid` int(11) NOT NULL default '0',
  `captcha` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_editorials"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_editorials` (
  `linkid` int(11) NOT NULL default '0',
  `adminid` varchar(60) NOT NULL default '',
  `editorialtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `editorialtext` text NULL,
  `editorialtitle` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`linkid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_modrequest"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_modrequest` (
  `requestid` int(11) NOT NULL auto_increment,
  `lid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `description` text NULL,
  `modifysubmitter` varchar(60) NOT NULL default '',
  `brokenlink` int(3) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `updated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY  (`requestid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (!isset($tables["{$prefix}_links_votedata"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_links_votedata` (
  `ratingdbid` int(11) NOT NULL auto_increment,
  `ratinglid` int(11) NOT NULL default '0',
  `ratinguser` varchar(60) NOT NULL default '',
  `rating` int(11) NOT NULL default '0',
  `ratinghostname` varchar(60) NOT NULL default '',
  `ratingcomments` text NULL,
  `ratingtimestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`ratingdbid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}


/**
 * feststellen, ob Kategorien vorhanden sind, die als Parent wieder auf sich
 * selbst verweisen und versuchen dies zu aendern, indem bei diesen Kategorien
 * die Parent-Id auf 0 gesetzt wird, also der Hauptkategorie zugeordnet wird
 */
$arr = array();
$qry = "SELECT cid, parentid FROM `{$prefix}_links_categories` ORDER BY cid";
$result = sql_query($qry);
while ($row = sql_fetch_assoc($result)) {
    $arr[$row['cid']] = intval($row['parentid']);
}
if ($arr) {
    $flip = array_flip($arr);
    foreach($flip as $parent => $cid) {
        if (isset($arr[$parent]) && $arr[$parent] == $cid) {
            $sqlqry[] = "UPDATE `{$prefix}_links_categories` SET `parentid` = 0 WHERE cid=" . $cid . " OR cid=" . $parent . "";
        }
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}


?>