<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

/*

# Links

RewriteRule ^Web_Links-.*-category-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&cid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-view-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=view&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-visit-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=visit&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-report-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=reportbroken&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-modify-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=modifyrequest&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-rating-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=rating&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-outsiderating-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=outsiderating&lid=$1&_MORE_=$2 [L]
RewriteRule ^Web_Links-.*-ratingdetails-([0-9]+)(-.*)?\.html$ mod.php?name=Web_Links&op=viewratingdetails&lid=$1&_MORE_=$2 [L]

*/

$hook = function($name, $parameter, &$replaces)
{
    if (!isset($parameter[$name])) {
        return;
    }
    global $prefix;

    $view = array();
    $visit = array();
    $cat = array();
    $modify = array();
    $broken = array();
    $rating = array();
    $outrating = array();
    $ratingdetails = array();

    foreach ($parameter[$name] as $key => $para) {
        switch (true) {
            case (isset($para['cid']) && intval($para['cid'])):
                $cat[0][] = $para['cid'];
                $cat[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'view') && (isset($para['lid']) && intval($para['lid']))):
                $view[0][] = $para['lid'];
                $view[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'visit') && (isset($para['lid']) && intval($para['lid']))):
                $visit[0][] = $para['lid'];
                $visit[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'modifyrequest') && (isset($para['lid']) && intval($para['lid']))):
                $modify[0][] = $para['lid'];
                $modify[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'reportbroken') && (isset($para['lid']) && intval($para['lid']))):
                $broken[0][] = $para['lid'];
                $broken[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'rating') && (isset($para['lid']) && intval($para['lid']))):
                $rating[0][] = $para['lid'];
                $rating[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'outsiderating') && (isset($para['lid']) && intval($para['lid']))):
                $outrating[0][] = $para['lid'];
                $outrating[$key] = $para;
                break;
            case ((isset($para['op']) && $para['op'] == 'viewratingdetails') && (isset($para['lid']) && intval($para['lid']))):
                $ratingdetails[0][] = $para['lid'];
                $ratingdetails[$key] = $para;
                break;
        }
    }

    /**
     * Downloads-KATEGORIENAME-cat63.html
     * RewriteRule ^(Downloads)-.*-cat([0-9]+)(-.*)\.html$ mod.php?$1&________________________cid-$2$3 [L]
     */
    if ($cat) {
        $inquery = implode(',', array_unique(array_shift($cat)));
        $qry = "SELECT cid, title FROM {$prefix}_links_categories WHERE cid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($cid, $title) = sql_fetch_row($result)) {
            /**
             * den aus der DB ausgelesenen Titel als URL tauglich machen
             * - Umlaute werden umgeschrieben
             * - Sonderzeichen werden durch den angegebenen 2ten Parameter ersetzt
             * Einstellung:
             * der zweite Parameter der Funktion, als Sonderzeichenersatz
             */
            $titles[$cid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($cat as $key => $link) {
            if (isset($titles[$link['cid']])) {
                /**
                 * schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format,
                 * also getrennt mit den Bindestrichen
                 * Einstellung:
                 * alle Parameter, die nicht benötigt werden, weil sie z.B. anderweitig
                 * in der URL verwendet werden, als zusätzlichen Parameter der Funktion
                 * übergeben
                 */
                $new_url = pmxModrewrite::title_parameters($link, 'cid');
                /**
                 * den neuen URL zusammensetzen
                 * Einstellung:
                 * nach belieben zusammensetzen und entspr. die .htaccess anpassen
                 */
                // $title = $name . '-lid-' . $title . '-' . $lid . $end; // Original m-t
                $new_url = $name . '-' . $titles[$link['cid']] . '-category-' . $link['cid'] . $new_url;
                /**
                 * die globalen Ersetzungsparameter mit den neuen Werten überschreiben
                 * Einstellung: keine, muss exakt so bleiben!
                 */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($view) {
        $inquery = implode(',', array_unique(array_shift($view)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($view as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-view-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($visit) {
        $inquery = implode(',', array_unique(array_shift($visit)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($visit as $key => $link) {
            if (isset($titles[$link['lid']])) {
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op', 'noJpC');
                $new_url = $name . '-' . $titles[$link['lid']] . '-visit-' . $link['lid'] . $new_url;
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($modify) {
        $inquery = implode(',', array_unique(array_shift($modify)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($modify as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-modify-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($broken) {
        $inquery = implode(',', array_unique(array_shift($broken)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($broken as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-report-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($rating) {
        $inquery = implode(',', array_unique(array_shift($rating)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($rating as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-rating-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($outrating) {
        $inquery = implode(',', array_unique(array_shift($outrating)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($outrating as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-outsiderating-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }

    if ($ratingdetails) {
        $inquery = implode(',', array_unique(array_shift($ratingdetails)));
        $qry = "SELECT lid, title FROM {$prefix}_links_links WHERE lid in ($inquery)";
        $result = sql_system_query($qry);
        $titles = array();
        while (list($lid, $title) = sql_fetch_row($result)) {
            /* den aus der DB ausgelesenen Titel als URL tauglich machen */
            $titles[$lid] = pmxModrewrite::title_entities($title, '-');
        }

        foreach ($ratingdetails as $key => $link) {
            if (isset($titles[$link['lid']])) {
                /* schreibt alle Parameter um in das normale pragmaMx mod_rewrite Format */
                $new_url = pmxModrewrite::title_parameters($link, 'lid', 'op');
                /* den neuen URL zusammensetzen */
                $new_url = $name . '-' . $titles[$link['lid']] . '-ratingdetails-' . $link['lid'] . $new_url;
                /* die globalen Ersetzungsparameter mit den neuen Werten überschreiben */
                $replaces[$key] = $link['prefix'] . $new_url . $link['suffix'];
            }
        }
    }
}

?>