<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 *
 * this file based on:
 * Headline in Page Module: Headlines on page v0.7
 * Copyright (c) 2001 by Christophe Deltheil (trollix@hacknuke.com), http://hacknuke.com
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(dirname(__FILE__)));
mxGetLangfile($module_name);

if (!mxGetAdminPref('radminarticle')) {
    mxErrorScreen("Access Denied");
    die();
}

define('_BASEMOD', 'modules.php?name=' . $module_name . '&amp;file=');
include_once(PMX_MODULES_DIR . DS . $module_name . '/config.inc.php');

function HeadlinesAdmin()
{
    global $refresh, $description, $pos;
    $img_delete = mxCreateImage("images/delete.gif", _HIP_DELETE, array('title' => _HIP_DELETE));
    $img_edit = mxCreateImage("images/edit.gif", _HIP_EDIT, array('title' => _HIP_EDIT));
    include ('header.php');
    GraphicAdmin();
    title(_HIP_ADMIN);
    OpenTable();
    echo '
      <table class="full list">
        <thead>
          <tr>
            <th>' . _HIP_SITENAME . '</th>
            <th>' . _HIP_URL . '</th>
            <th>' . _HIP_POS . '</th>
            <th>' . _HIP_READS . '</th>
            <th>' . _HIP_ACTIVE . '</th>
            <th>' . _HIP_REFRESH . '</th>
            <th>' . _HIP_FUNCTIONS . '</th>
          </tr>
        </thead>
        <tbody>';
    $class = '';
    $out = '';
    $result = sql_query("SELECT hid, sitename, headlinesurl, count, description, active, pos, refresh FROM " . _HIPTABLE_HEADLINES . " ORDER BY active DESC, pos ASC, sitename ASC");
    while (list($hid, $sitename, $headlinesurl, $count, $description, $active, $pos, $refresh) = sql_fetch_row($result)) {
        $description = stripslashes($description);
        $sitename = stripslashes($sitename);
        $viewurl = (strlen($headlinesurl) > 45) ? substr($headlinesurl, 0, 42) . "..." : $headlinesurl;
        $class = ($class == '') ? ' class="alternate-a"' : '';
        $out .= '
          <tr' . $class . '>
            <td>' . $sitename . '</td>
            <td><a href="' . $headlinesurl . '" target="_blank">' . $viewurl . '</a><br /><span class="tiny">' . $description . '</span></td>
            <td>' . $pos . '</td>
            <td>' . $count . '</td>
            <td>' . $active . '</td>
            <td>' . $refresh . '</td>
            <td>
              <a href="' . adminUrl(PMX_MODULE, 'Edit', 'hid=' . $hid) . '">' . $img_edit . '</a>&nbsp;
              <a href="' . adminUrl(PMX_MODULE, 'Suppr', 'hid=' . $hid) . '">' . $img_delete . '</a>
            </td>
          </tr>';
    }
    if ($out) {
        echo $out;
    } else {
        echo '
          <tr><td colspan="7"></td></tr>';
    }
    echo '
      </tbody>
    </table>';
    CloseTable();
    OpenTable();
    echo '
      <br /><br />
      <form action="' . adminUrl(PMX_MODULE) . '" method="post">
        <fieldset>
          <legend>' . _HIP_ADDHEADLINE . '</legend>
          <table width="100%" class="form">
            <tr>
              <td>' . _HIP_SITENAME . ':</td>
              <td><input type="text" name="xsitename" size="31" maxlength="30" /></td>
            </tr>
            <tr>
              <td>' . _HIP_RSSFILE . ':</td>
              <td><input type="text" name="headlinesurl" size="50" maxlength="200" /></td>
            </tr>
            <tr>
              <td>' . _HIP_DESC . ':</td>
              <td><textarea name="description" cols="40" rows="3">' . $description . '</textarea></td>
            </tr>
            <tr>
              <td>' . _HIP_POSITION . ':</td>
              <td><input type="text" name="pos" size="3" maxlength="3" value="' . $pos . '" /></td>
            </tr>
            <tr>
              <td>' . _HIP_ACTIVE . '</td>
              <td><input type="radio" name="active" value="1" checked="checked" />' . _HIP_YES . '
              &nbsp;&nbsp;<input type="radio" name="active" value="0" />' . _HIP_NO . '</td>
            </tr>
            <tr>
              <td>' . _HIP_REFRESHTIME . ':</td>
              <td>
                <select name="refresh">
                  <option value="1800">1/2 ' . _HIP_HOUR . '</option>
                  <option value="3600" selected="selected">1 ' . _HIP_HOUR . '</option>
                  <option value="7200">2 ' . _HIP_HOURS . '</option>
                  <option value="10800">3 ' . _HIP_HOURS . '</option>
                  <option value="21600">6 ' . _HIP_HOURS . '</option>
                  <option value="43200">12 ' . _HIP_HOURS . '</option>
                  <option value="64800">18 ' . _HIP_HOURS . '</option>
                  <option value="86400">24 ' . _HIP_HOURS . '</option>
                </select>
              </td>
            </tr>
          </table>
          <input type="hidden" name="op" value="' . PMX_MODULE . '/Add" />
          <input type="submit" value="' . _HIP_ADD . '" />
          &nbsp;&nbsp;<a href="' . _BASEMOD . 'index">' . _HIP_RETURN . ' ' . _HIP_TITLE . '</a>
        </fieldset>
      </form>';

    CloseTable();
    include('footer.php');
}

function HeadlinesEdit()
{
    global $hid;
    include ('header.php');
    GraphicAdmin();
    title(_HIP_ADMIN);

    OpenTable();
    $result = sql_query("SELECT sitename, headlinesurl, description, count, active, pos, refresh, time FROM " . _HIPTABLE_HEADLINES . " WHERE hid='$hid'");
    list($xsitename, $headlinesurl, $description, $count, $active, $pos, $refresh, $time) = sql_fetch_row($result);

    $description = stripslashes($description);
    $xsitename = stripslashes($xsitename);
    if (empty($active)) {
        $check_yes = '';
        $check_no = 'checked="checked"';
    } else {
        $check_yes = 'checked="checked"';
        $check_no = '';
    }
    echo '
      <fieldset>
        <legend>' . _HIP_EDIT_HEADLINE . '</legend>
        <form action="' . adminUrl(PMX_MODULE) . '" method="post">
          <table width="100%" class="form">
            <tr>
              <td>' . _HIP_SITENAME . ':</td>
              <td><input type="text" name="xsitename" size="31" maxlength="30" value="' . htmlspecialchars($xsitename) . '" /></td>
            </tr>
            <tr>
              <td>' . _HIP_RSSFILE . ':</td>
              <td><input type="text" name="headlinesurl" size="50" maxlength="200" value="' . mx_urltohtml($headlinesurl) . '" /></td>
            </tr>
            <tr>
              <td>' . _HIP_DESC . ':</td>
              <td><textarea name="description" cols="40" rows="3">' . htmlspecialchars($description) . '</textarea></td>
            </tr>
            <tr>
              <td>' . _HIP_READS . ':</td>
              <td><input type="text" name="count" size="3" maxlength="3" value="' . $count . '" /></td>
              </tr>
              <tr>
                <td>' . _HIP_POSITION . ':</td>
                <td><input type="text" name="pos" size="3" maxlength="3" value="' . $pos . '" /></td>
              </tr>
              <tr>
                <td>' . _HIP_ACTIVE . '</td>
                <td><input type="radio" name="active" value="1" ' . $check_yes . ' />' . _HIP_YES . '
                &nbsp;&nbsp;<input type="radio" name="active" value="0" ' . $check_no . ' />' . _HIP_NO . '</td>
              </tr>
              <tr>
                <td>' . _HIP_REFRESHTIME . ':</td>
                <td>
                  <select name="refresh">
                    <option value="1800">1/2 ' . _HIP_HOUR . '</option>
                    <option value="' . $refresh . '" selected="selected">' . ($refresh / 3600) . ' ' . _HIP_HOURS . '</option>
                    <option value="3600">1 ' . _HIP_HOUR . '</option>
                    <option value="7200">2 ' . _HIP_HOURS . '</option>
                    <option value="10800">3 ' . _HIP_HOURS . '</option>
                    <option value="21600">6 ' . _HIP_HOURS . '</option>
                    <option value="43200">12 ' . _HIP_HOURS . '</option>
                    <option value="64800">18 ' . _HIP_HOURS . '</option>
                    <option value="86400">24 ' . _HIP_HOURS . '</option>
                  </select>
                </td>
              </tr>
              <tr>
                <td>' . _HIP_TIMECACHE . ':</td>
                <td><input type="text" name="cachetime" size="14" maxlength="3" value="' . $time . '" /></td>
              </tr>
            </table>
            <input type="hidden" name="hid" value="' . $hid . '" />
            <input type="hidden" name="op" value="' . PMX_MODULE . '/Save" />
            <input type="submit" value="' . _HIP_SAVECHANGES . '" />
          </form>
        </fieldset>';

    CloseTable();
    include('footer.php');
}

function HeadlinesSave()
{
    global $hid, $xsitename, $headlinesurl, $description, $count, $active, $pos, $refresh, $cachetime;

    $xsitename = trim(mxAddSlashesForSQL($xsitename));
    $description = mxAddSlashesForSQL($description);

    sql_query("UPDATE " . _HIPTABLE_HEADLINES . " SET sitename='$xsitename', headlinesurl='" . mx_urltohtml($headlinesurl) . "', description='$description', count='$count', active='$active', pos='$pos', refresh='$refresh', time='$cachetime', content='' WHERE hid='$hid'");
    mxRedirect(adminUrl(PMX_MODULE));
}

function HeadlinesSuppr($hid, $ok = 0)
{
    if ($ok == 1) {
        sql_query("DELETE FROM " . _HIPTABLE_HEADLINES . " WHERE hid=" . intval($hid));
        mxRedirect(adminUrl(PMX_MODULE));
    } else {
        include('header.php');
        GraphicAdmin();
        title(_HIP_ADMIN);
        OpenTableAl();
        echo '
          <center>
            ' . _HIP_SURE2DELHEADLINE . '
            <br /><br />
            [&nbsp;<a href="' . adminUrl(PMX_MODULE) . '">' . _NO . '</a> | <a href="' . adminUrl(PMX_MODULE, 'Suppr', 'hid=' . $hid . '&amp;ok=1') . '">' . _YES . '</a>
            &nbsp;]
          </center>';
        CloseTableAl();
        include('footer.php');
    }
}

function HeadlinesAdd()
{
    global $xsitename, $headlinesurl, $description, $pos, $active, $refresh;
    $xsitename = trim(mxAddSlashesForSQL($xsitename));
    $description = mxAddSlashesForSQL($description);

    sql_query("INSERT INTO " . _HIPTABLE_HEADLINES . " (sitename, headlinesurl, count, description, pos, active, refresh) VALUES ('$xsitename', '" . mx_urltohtml($headlinesurl) . "', '0', '$description', '$pos', '$active', '$refresh')");
    mxRedirect(adminUrl(PMX_MODULE));
}

$ok = (empty($ok)) ? 0 : 1;
switch ($op) {
    case PMX_MODULE . '/Edit':
        HeadlinesEdit();
        break;

    case PMX_MODULE . '/Save':
        HeadlinesSave();
        break;

    case PMX_MODULE . '/Suppr':
        HeadlinesSuppr($hid, $ok);
        break;

    case PMX_MODULE . '/Add':
        HeadlinesAdd();
        break;

    default:
        HeadlinesAdmin();
        break;
}

?>
