<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 989 $
 * $Author: PragmaMx $
 * $Date: 2024-02-08 10:58:33 +0100 (Do, 08 Feb 2024) $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// Headlines-Tabellen
if (!isset($tables["{$prefix}_hip_headlines"])) {
    $sqlqry[] = "
CREATE TABLE `{$prefix}_hip_headlines` (
  `hid` int(11) NOT NULL auto_increment,
  `sitename` varchar(30) NOT NULL default '',
  `content` text NULL,
  `headlinesurl` varchar(200) NOT NULL default '',
  `count` mediumint(8) unsigned NOT NULL default '0',
  `description` text NULL,
  `catid` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '0',
  `refresh` int(10) NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `pos` smallint(10) NOT NULL default '0',
  PRIMARY KEY  (`hid`)
) ENGINE=MyISAM DEFAULT CHARACTER SET utf8  COLLATE utf8_unicode_ci;";
}



if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Headlines importieren?
$result = sql_query("SELECT COUNT(hid) FROM `{$prefix}_hip_headlines`");
list($counthip) = sql_fetch_row($result);
if (empty($counthip)) {
    // Achtung, ohne Feld hid
    $sqlqry[] = "INSERT INTO `{$prefix}_hip_headlines` (`sitename`, `content`, `headlinesurl`, `count`, `description`, `catid`, `active`, `refresh`, `time`, `pos`) VALUES ('pragmaMx.org', 'http://www.pragmamx.org/backend.php', 'http://www.pragmamx.org/backend.php', 2, 'Home of pragmaMx', 0, 1, 0, 0, 1);";
}

$result = sql_query("SELECT COUNT(hid) FROM `{$prefix}_headlines`");
list($counthead) = sql_fetch_row($result);
if (empty($counthead) && !empty($counthip) && isset($tables["{$prefix}_headlines"])) {
    // eindeutigen Index erstellen, dass nicht doppelt angefuegt wird
    $sqlqry[] = "ALTER TABLE `{$prefix}_headlines` ADD UNIQUE xxheadlinesurl(`headlinesurl`);";
    // alle headlines aus hip-Tabelle auch an normale headlines-Tabelle anfuegen
    $sqlqry[] = "INSERT INTO {$prefix}_headlines( sitename, headlinesurl ) SELECT {$prefix}_hip_headlines.sitename, {$prefix}_hip_headlines.headlinesurl FROM {$prefix}_hip_headlines";
    // eindeutigen Index wieder entfernen
    $sqlqry[] = "ALTER TABLE `{$prefix}_headlines` DROP INDEX `xxheadlinesurl`;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// aufraeumen:
unset($counthip, $counthead);

?>