<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 499 $
 * $Author: PragmaMx $
 * $Date: 2022-05-11 14:15:10 +0200 (Mi, 11. Mai 2022) $
 */

defined('mxMainFileLoaded') or die('access denied');
pmxBase::set("plugins",0);
$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
$pagetitle = _HIP_TITLE;

include(dirname(__FILE__) . DS . 'config.inc.php');
include_once(PMX_SYSTEM_DIR . DS . 'class_RSS_feed.php');

if (intval($HIP_items) < 1) {
    $HIP_items = 6;
}

$part = array();
$result = sql_query("SELECT hid, sitename, description, content, headlinesurl AS url, refresh, time, pos, count FROM " . _HIPTABLE_HEADLINES . " WHERE  active='1' ORDER BY pos ASC");
while ($row = sql_fetch_object($result)) {
    $row->content = trim($row->content);
    // $row->refresh = 0;
    if (!$row->content || !$row->refresh || ((time() - $row->refresh) > $row->time)) {
        $feed_parser = new RSS_feed();
        $feed_parser->Set_URL($row->url);
        // die Konfigwerte die an die Klasse übermittelt werden, sollte auch noch im Konfig-File eingebunden werden
        $feed_parser->Set_Limit($HIP_items); // 0 = Default = Alle. Anzahl der Einträge in der Liste
        $feed_parser->Show_Image(false); // Default = false. Zeige Bilddaten (bei höheren Versionen als 0.91)
        $feed_parser->Show_Description(false); // Default = false. Zeige Description-Data (bei höheren Versionen als 0.91)
        $feed_parser->Set_Encoding('utf-8');
        // Ende der Konfiguration
        $row->content = $feed_parser->Get_Results();
        if ($row->content) {
            sql_query("UPDATE " . _HIPTABLE_HEADLINES . " SET content='" . mxAddSlashesForSQL($row->content) . "', count=count+1, time='" . time() . "' WHERE hid='$row->hid'");
        } else {
            $row->content = _HIP_RSSPROBLEM;
            sql_query("UPDATE " . _HIPTABLE_HEADLINES . " SET content='" . mxAddSlashesForSQL($row->content) . "', time='" . time() . "' WHERE hid='$row->hid'");
        }
    }

    $row->sitename = preg_replace('~&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)~', '&amp;', $row->sitename); // & durch &amp; ersetzen
    if ($row->description) {
        $row->description = '<p>' . preg_replace('~&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)~', '&amp;', $row->description) . '</p>'; // & durch &amp; ersetzen
    }

    if (preg_match('#<p>(<a href[^>]+>)(.*)</a>.*</p>#', $row->content, $matches)) {
        $link = $matches[1];
        $title = ' title="' . $matches[2] . '"';
        $row->content = str_replace($matches[0], '', $row->content);
    } else {
        $link = parse_url($row->url);
        $link = ((isset($link['scheme'])) ? $link['scheme'] : 'http') . '://' . $link['host'];
        $link = '<a href="' . $link . '" target="_blank">';
        $title = '';
    }
    $row->content .= '<p' . $title . ' class="align-right">' . $link . _HIP_READMORE . '</a></p>';
    $row->content = preg_replace('~&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)~', '&amp;', $row->content); // & durch &amp; ersetzen
    $part[] = '<div class="box"><h3>' . $row->sitename . '</h3>' . $row->description . $row->content . '</div>';
}

$out = '';
if (MX_IS_ADMIN) {
    $out = '<div class="align-right"><a href="' . adminUrl($module_name) . '">' . _HIP_ADMIN . '</a></div>';
}

$rows = count($part);
if ($rows < 4) {
    $HIP_nbcols = 1;
}

$HIP_nbcols = intval($HIP_nbcols);
if ($rows > 1 && $HIP_nbcols > 1) {
    $percent = floor(100 / $HIP_nbcols);

    $out .= '<table class="full" cellpadding="0" cellspacing="0"><tr valign="top">';
    $cnt = 0;
    foreach ($part as $entry) {
        $cnt++;
        $rest = $cnt % $HIP_nbcols;
        $out .= '<td width="' . $percent . '%">' . $entry . '</td>';
        if (!$rest && $cnt < $rows) {
            $out .= '</tr><tr valign="top">';
        }
        if ($rest && $cnt == $rows) {
            $out .= '<td colspan="' . ($HIP_nbcols - $rest) . '"></td>';
        }
    }
    $out .= '</tr></table>';
} else if ($rows) {
    $out .= implode("\n", $part);
}

include('header.php');
title(_HIP_TITLE);
OpenTable();
echo $out;
CloseTable();
include('footer.php');

?>
