<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 584 $
 * $Author: PragmaMx $
 * $Date: 2022-08-29 21:51:21 +0200 (Mo, 29. Aug 2022) $
 */

$hook = function($module_name)
{
    $cfg_class = load_class('Config', 'pmx.rss');
    $config = $cfg_class->get();
    if (!$config['header_sections']) {
        return true;
    }

    $cachetime = intval($config['cachetime']);
    if ($cachetime) {
        $cacheid = __FILE__;
        $cache = load_class('Cache');
        // Die Dateierweiterung für die Cache-Dateien (z.B. ".cache")
        $cache->sFileExtension = ".{$module_name}.php";
    }

    if ((!$cachetime) || (($linkrel = $cache->read($cacheid)) === false)) {
        global $prefix;

        $linkrel = array();

        /* nur die ausgewählten Module anzeigen */
        $where = " AND title IN('" . implode("','", (array)$config['header_sections']) . "')";

        /* und auch nur die erlaubten, wenn leer, sind alle Module erlaubt */
        if ($config['active_sections']) {
            $where .= " AND title IN('" . implode("','", (array)$config['active_sections']) . "')";
        }

        $modlist = array();
        $allmods = sql_query("SELECT title, active
                  FROM {$prefix}_modules
                  WHERE view=0
                    AND active=1" . $where);
        while (list($modulename) = sql_fetch_row($allmods)) {
            $modlist[] = $modulename;
        }

        $hook = load_class('Hook', 'backend');
        $hook->type = 'modules';
        $hook->modlist = $modlist;
        $hook->only_allowed = false;
        $hookitems = $hook->get(array());

        if ($hookitems && is_array($hookitems)) {
            if ($config['header_sections_join'] && count($hookitems) > 1) {
                $section = urlencode(implode('.', array_keys($hookitems)));
                $title = _RSS_MODULE;
                $linkrel[] = '<link rel="alternate" type="application/rss+xml" title="' . htmlspecialchars($GLOBALS['sitename'] . ' - ' . $title) . '" href="modules.php?name=' . $module_name . '&amp;feed=' . $section . '" />';
            } else {
                foreach ($hookitems as $section => $title) {
                    $linkrel[] = '<link rel="alternate" type="application/rss+xml" title="' . htmlspecialchars($GLOBALS['sitename'] . ' - ' . $title) . '" href="modules.php?name=' . $module_name . '&amp;feed=' . $section . '" />';
                }
            }
        }

        if ($cachetime) {
            $cache->write($linkrel, $cacheid, ($cachetime * 3600)); // x Stunden Cachezeit
        }
    }

    if ($linkrel) {
        pmxHeader::add($linkrel);
    }

    return true;
}

?>