<?php

/**

 * pragmaMx - Web Content Management System.

 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org

 * $Id: layout.fluid.css.php 499 2022-05-11 12:15:10Z PragmaMx $

 */



define('mxMainFileLoaded', 1);



/* CSS Header senden */

header('Content-Type: text/css');

header('X-Powered-By: pragmaMx-cms');

header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 3600 * 24) . ' GMT'); // 1 day

header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime('../theme.settings.php')) . ' GMT');

header('Etag: ' . md5(filemtime('../theme.settings.php')));



/* default widths - fluid - 100%  */

$defaults = array(/* Breiten */

    'page' => 100,

    'left' => 21,

    'right' => 21,

    'min' => 780,

    'max' => 1200,

    );



error_reporting(0);

include('../theme.settings.php');

error_reporting(E_ALL);

// Einstellungen aus settings.php in Zahlenwert konvertieren

$widths = array_map('floatval', $themesetting['layoutwidth']['fluid']);

// leere Werte aus settings.php entfernen

$widths = array_filter($widths);

// �brige korrigierte Werte aus settings.php �berschreiben Standardwerte

$widths = array_merge($defaults, $widths);

extract($widths, EXTR_OVERWRITE);



if ($page > 100 || $page < 60) {

    $page = $defaults['page'];

}

if ($left > 50) {

    $left = $defaults['left'];

}

if ($right > 50) {

    $right = $defaults['right'];

}



/* Padding in EM unabh�ngig von Gesamt-Breite */

$colpadding = '1em';



/* minimalen Seitenrand belassen, sonst sieht das doof aus */

$page -= 10;



ob_start();



?>

<style>

<!--

<?php ob_end_clean(); ob_start(); ?>



/* Breiten und Position der Layoutspalten */



#sidebar-left {

	width: <?php echo $left ?>%;

}



#sidebar-right {

	width: <?php echo $right ?>%;

}



.page {

	max-width: <?php echo $max ?>px;

	min-width: <?php echo $min ?>px;

	width: <?php echo $page ?>%;

}



.col-1 #mainbar {

	left: 0;

	width: <?php echo $page ?>%;

}



.col-1 #sidebar-right,

.col-1 #sidebar-left {

	display: none;

}



.col-1 .block .block.__BLOCK_ID__ {

<?php /* z.B. Blockvorschau im Adminmenue */ ?>

	width: <?php echo $left ?>%;

}



.col-2-left #mainbar {

	left: <?php echo $left ?>%;

	width: <?php echo 100 - $left ?>%;
	

}



.col-2-left #sidebar-left {

	display: block;

	right: <?php echo 100 - $left ?>%;

}



.col-2-left #sidebar-right {

	display: none;

}



.col-2-left.col-to-right #mainbar {

	left: 0;

}



.col-2-left.col-to-right #sidebar-left {

	right: 0;

}



.col-2-right #mainbar {

	left: 0;

	width: <?php echo 100 - $right ?>%;

}



.col-2-right #sidebar-left {

	display: none;

}



.col-2-right #sidebar-right {

	right: 0;

}



.col-2-right.col-to-left #mainbar {

	left: <?php echo $right ?>%;

}



.col-2-right.col-to-left #sidebar-right {

	right: <?php echo 100 - $right ?>%;

}



.col-3 #mainbar {

	left: <?php echo $left ?>%;

}



.col-3 #mainbar,

.col-3-left #mainbar,

.col-3-right #mainbar {

	width: <?php echo 100 - $left - $right ?>%;

}



.col-3 #sidebar-left,

.col-3-left #sidebar-right,

.col-3-left #sidebar-left {

	left: -<?php echo 100 - $left - $right ?>%;

}



.col-3 #sidebar-right {

	right: 0;

}



.col-3-left #mainbar {

	left: <?php echo $left + $right ?>%;

}



.col-3-right #mainbar {

	left: 0;

}



.col-3-right #sidebar-left {

	left: <?php echo $right ?>%;

}



.col-3-right #sidebar-right {

	left: -<?php echo $left ?>%;

}



/* Margins der Layoutspalten */



#sidebar-left-inside,

#sidebar-right-inside,

#mainbar-inside {

	padding-left: <?php echo $colpadding ?>;

	padding-right:  <?php echo $colpadding ?>;

}



.col-1 #mainbar-inside {

	padding-left: 0;

	padding-right: 0;

}



.col-2-left #mainbar-inside {

	/*padding-right: 3em;<?php //echo $colpadding ?>;*/

}



.col-2-left.col-to-right #mainbar-inside {

	padding-left: <?php echo $colpadding ?>;

	padding-right: <?php echo $colpadding ?>;

}



.col-2-left.col-to-right #sidebar-left-inside {

	padding-left: <?php echo $colpadding ?>;

	padding-right: <?php echo $colpadding ?>;

}



.col-2-right.col-to-left #sidebar-right-inside {

	padding-left: 0;

	padding-right: <?php echo $colpadding ?>;

}



.col-3-left #mainbar-inside {

	padding-right: <?php echo $colpadding ?>;

}



.col-3-left #sidebar-left-inside {

	padding-right: <?php echo $colpadding ?>;

}



.col-3-left #sidebar-right-inside {

	padding-left: 0;

	padding-right: <?php echo $colpadding ?>;

}



.col-3-right #mainbar-inside {

	padding-left: <?php echo $colpadding ?>;

}



.col-3-right #sidebar-left-inside {

	padding-left: <?php echo $colpadding ?>;

	padding-right: <?php echo $colpadding ?>;

}



.col-3-right #sidebar-right-inside {

	padding-left: <?php echo $colpadding ?>;

}





/* Position der vertikalen Linie zwischen den Layoutspalten */



.col-1 #main,

.col-1 #main-inside,

.col-2-right #main-inside,

.col-2-left #main-inside,

.col-3-right #main-inside,

.col-3-left #main-inside {

	background-image: none;

}



.col-3 #main,

.col-2-left #main {

	background-position: <?php echo $left ?>%;

}



.col-3 #main-inside {

	background-position: <?php echo 100 - $right ?>%;

}



.col-3-left #main {

	background-position: <?php echo $left + $right ?>%;

}



.col-3-right #main {

	background-position: <?php echo 100 - $right - $left ?>%;

}



.col-2-left.col-to-right #main {

	background-position: <?php echo 100 - $left ?>%;

}



.col-2-right.col-to-left #main {

	background-position: <?php echo $right ?>%;

}



/* Untere rechte Bl�cke */



#bottom .block-inside {

	padding-left: 8%;

	padding-right: 8%;

}



#bottom .first .block-inside {

	padding-left: <?php echo $colpadding ?>;

}



#bottom .last .block-inside {

	padding-right: <?php echo $colpadding ?>;

}



<?php

$out = ob_get_clean();

$out = preg_replace('#/\*.+\*/#', ' ', $out);

$out = preg_replace('#\s+#', ' ', $out);

$out = preg_replace('#\s*([{:;,}])\s*#', '$1', $out);

$out = trim(str_replace('}', "}\n", $out));

die($out);

?>

-->

</style>

