<?php
/**
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * $Revision: 638 $
 * $Author: PragmaMx $
 * $Date: 2022-11-13 17:58:50 +0100 (So, 13. Nov 2022) $
 */

/* diese Zeile nicht ändern!! */
defined('mxMainFileLoaded') or die('access denied');

/**
 * der Titel im Kopfbereich der Seite
 * es sollte der global eingestellte Seitentitel sein
 */
$themesetting['title'] = $GLOBALS['sitename'];
$themesetting['perex'] = false;

/**
 * Layout-Columns: default, left, right, right-bottom, left-bottom
 * .                 |X|     ||X    X||       X|           |X
 * .                                          -             -
 */
$themesetting['layoutcols'] = 'default';

/**
 * Layout-Type: fluid oder fixed
 */
$themesetting['layouttype'] = 'fluid';

/**
 * Navigation Type: nav-1, nav-2 ...
 */
$themesetting['navigation'] = 'nav-1';

/**
 * Layout-Breiten
 */
$themesetting['layoutwidth'] = array(/* Breiten */
    'fluid' => array(/*  wenn Typ = fluid eingestellt: */
        'page' => 100,/*  Seitenbreite, in Prozent */
        'left' => 21,/*   linke Blockspalte, in Prozent */
        'right' => 21,/*  rechte Blockspalte, in Prozent */
        'min' => 780,/*   minimale Seitenbreite, immer in Pixel! */
        'max' => 1200,/*  maximale Seitenbreite, immer in Pixel! */
        ),
    'fixed' => array(/*  wenn Typ = fixed eingestellt: */
        'page' => 1200,/*  Seitenbreite, in Pixel */
        'left' => 220,/*  linke Blockspalte, in Pixel */
        'right' => 210,/* rechte Blockspalte, in Pixel */
        ),
    );

/**
 * Anzahl der (rechten) Blöcke, wenn rechte Blöcke unterhalb des Inhalts
 * angezeigt werden sollen. Layout-Columns right-bottom oder left-bottom
 * Anzahl bis maximal 6, oder 'auto'
 */
$themesetting['bottomblocks'] = 'auto';

/**
 * das Menü im Kopfbereich
 * - den Menünamen aus dem Menümanager angeben, oder
 * - leer lassen (false) um kein Menü anzuzeigen
 */
$themesetting['head_css_menu'] = '{CSS-MENU}'; // z.B.: {CSS-MENU}

/**
 * Links und Inhalte in der oberen Linkleiste anzeigen
 * true = ja, false = nein
 */
$themesetting['footmenu'] = array(
    // User relevante Links (z.B. Login)
    'user' => true,
    // Link zu RSS-Feeds
    'backend' => true,
    // Link zum Impressum
    'impres' => true,
    // Link zu dieser Themekonfiguration, nur sichtbar für Admins!
    'help' => true,
    );

/* folgendes nur, wenn Module geladen */
if (defined('MX_MODULE')) {
    /* Hilfsvariablen für das SMF-Forum */
    global $context; // vom SMF
    $current_action = isset($context['current_action']) ? $context['current_action'] : false;

    /**
     * Seiten, bei denen, die linken Blöcke nicht gezeigt werden sollen
     */
    $themesetting['hide-left'] = array(/* Seiten/Module */
        // MX_MODULE == 'Downloads',
        // MX_MODULE == 'News' && !defined('MX_HOME_FILE'),
        // MX_MODULE == 'FAQ',
        // MX_MODULE == 'Downloads' && $_REQUEST['cid'] == 61, // Downloads, Kategorie 61
        // $_REQUEST['name'] == 'Content' && $_REQUEST['pid'] == 28, // Contentmodul Id 28
        );

    /**
     * Seiten, bei denen beide Blockspalten nicht angezeigt werden sollen
     */
    $themesetting['hide-both'] = array(/* Seiten/Module */
        MX_MODULE == 'admin',
        // MX_MODULE == 'Forum' && $current_action != 'profile' && $current_action != 'pm' ,
        // weitere Beispiele:
        // MX_MODULE === 'Gallery',
        //MX_MODULE == 'eBoard',
        //MX_MODULE == 'Board',
        //MX_MODULE == 'mxBoard',
        // MX_MODULE == 'Downloads' && $_REQUEST['cid'] == 61, // Downloads, Kategorie 61
        // $_REQUEST['name'] == 'Content' && $_REQUEST['pid'] == 28, // Contentmodul Id 28
        );
}
/* Ende nur Module */

/**
 * Banner im Theme anzeigen
 * true = ja, false = nein
 */
$themesetting['banner'] = array(
    // im Kopfbereich
    'head' => false,
    // im Fussbereich
    'foot' => false,
    );

/**
 * /////////////////////////////////////////////////////////////////////////////
 * folgende Einstellungen sollten nicht verändert werden
 */

/* Modul-Blöcke im passenden Design anzeigen */
$themesetting['blocknav']['style'] = 'menu';
$themesetting['blocknav']['current'] = 'current';

/* definieren ob die Templates des Themes gecached werden können */
define('MX_THEME_CACHABLE', false);

/* Dateiname des templates */
define('MX_THIS_THEMEFILE', 'theme.html');

?>
