<?php
/**
 * This file is part of Theme for 
 * pragmaMx - Web Content Management System.
 *
 * $template : [THEMENAME] $
 * $Revision: [TEMPLATEVERSION] $
 * 
 * $Author: [TEMPLATEAUTHOR] $
 * $Date: [TEMPLATEDATE] $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * theme_functions
 *
 * @package
 * @author ????
 * @copyright Copyright (c) 2014
 * @version $Id: functions.php,v 1.2 2014-03-07 13:28:11 tora60 Exp $
 * @access public
 */
class theme_functions {
    private static $config;
    private static $__set = array(); // Konfigurtion

    /**
     * class::__construct()
     *
     * @param mixed $parameter
     */
    function __construct ($parameter = null)
    {
        $this->themename = $parameter;
        self::$config = load_class("Config", $this->themename);
		
    }

    /**
     * class::GetDefaultConfig()
     *
     * @return
     */
    static function GetDefaultConfig()
    {
        $temp = array(
            'colorschema' => 'default',
			'rightblocks' => true,
			'sitename'=>$GLOBALS['sitename'],
			'slogan'=>$GLOBALS['slogan'],
			'head_css_menu'=>'MENU',
			'top_css_menu'=>'',
			'foot_css_menu'=>'',
			'facebooklink' => '',
            'rsslink' => 'modules.php?name=rss',
            'twitterlink' => '',
			'perex'=>'0',
			'banner'=> array('head'=>0,'foot'=>0),
			'breadcrump'=>1,
			'top_text' => '',
			'foot_text' =>'',
            'headrow' =>'',
			'content_foot_text' =>'',
			'headertext'=>'',
			'blocks_left'=>'Admin',
			'blocks_right'=>'',
			'blocks_both'=>'',
			'socialsets'=>'default',
			'sociallinks'=>array(
						'rss' => 'modules.php?name=rss',
						'facebook' => '',
						'flickr'=>'',
						'instagram'=>'',
						'twitter' => '',
						'vimeo'=>'',
						'youtube'=>'',
						'tumblr'=>'',	
						'linkedin'=>'',	
						'xing'=>'',	
						'pinterest'=>'',
						'tiktok'=>'',
					),			
            			
            );
        return $temp;
    }

    /**
     * class::config_save()
     * Konfiguration auslesen ....
     *
     * @param array $temp
     * @return
     */
    public function config_save ($temp = array())
    {
        $themename = $this->themename;
        self::$config->setSection($themename, $temp);
        return;
    }

    /**
     * class::config_load()
     *
     * @return
     */
    public function config_load ()
    {
        $themename = $this->themename;
		$temp1 = $this->GetDefaultConfig();
		//
		$temp2=self::$config->getSection($themename);
        $temp = array_merge($temp1,$temp2);
		if (array_key_exists('socilalinks',$temp)) $temp['sociallinks']=array_merge($temp1['sociallinks'],$temp2['sociallinks']);

        return $temp;
    }
    /**
     * class::__get()
     *
     * @param mixed $value_name
     * @return
     */
    public function __get($value_name)
    {
        if (isset(self::$__set[$value_name])) {
            return self::$__set[$value_name];
        }
        return false;
    }

    /**
     * class::__set()
     *
     * @param mixed $name
     * @param mixed $val
     * @return
     */
    public function __set($name, $val)
    {
        self::$__set[$name] = $val ;
    }
}



function atx_save_hmenu($colors = array()) {
	
	global $themeoptions;
	$temp='';
    $temp .="";
	
	/* fonts laden */
	$temp=file_get_contents(_THISTHEME_ ."/style/hmenu.css");
	
	
	
	foreach ($colors as $color=>$value) {
		if (!is_array($value))$temp= str_replace("[".strtoupper($color)."]",$value,$temp);
	}
	

	file_put_contents (_THISTHEME_ ."/style/hmenu.css",$temp);
}


function getFontURL($url="") {
		if ($url=="") return;
		$useragent=$_SERVER['HTTP_USER_AGENT'];
	    $result=false;
	if (function_exists("curl_init")) {
        /**
        * cURL-Session initialisieren
        */
        $ch = curl_init($url);
        /**
        * Weiter Parameter der cURL-Session übergeben
        */
        curl_setopt ($ch, CURLOPT_URL, $url);
        curl_setopt ($ch, CURLOPT_HEADER, 0);
        /**
        * cURL Anweisen, das die Übergabe
            zurückgegeben werden soll
        */
        curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
        /**
        * cURL mitteilen, welcher Useragent übergeben
            werden soll.
        */
        curl_setopt ($ch, CURLOPT_USERAGENT, $useragent);
        /**
        * cURL Rückgabe in $result speichern
        */
        $result = @curl_exec ($ch);
        curl_close ($ch);
	}
		//if (trim($result)=="FORBIDDEN") return false;


    return $result;
}

function getAtxColor ($mcss, $color=array(), $default="#000000") {
		
		$ct="";
		foreach ($color as $key=>$value) {
			$ct=$mcss->Get($key,$value);
			if ($ct !="") return $ct;
		}
			
		return $default;
		
}


function mxUnlink ($filename) {
	if (file_exists($filename) and is_writable($filename)) unlink($filename);
}

function mxCopy ($source,$destination) {
	if (file_exists($source) and is_writable($destination)) copy($source,$destination);
	if (file_exists($destination)) return true;
	return false;
}

function copyFolder($source, $dest, $recursive = false)
{

    if (!is_dir($dest)) 
    { 
        mkdir($dest); 
  } 
 
    $handle = @opendir($source);
    
    if(!$handle)
        return false;
    
    while ($file = @readdir ($handle))
    {
        if (preg_match("#^\.{1,2}$#i",$file))
        {
            continue;
        }
        
        if(!$recursive && $source != $source.$file."/")
        {
            if(is_dir($source.$file))
                continue;
        }
        
        if(is_dir($source.$file))
        {
            copyFolder($source.$file."/", $dest.$file."/", $recursive);
            
        }
        else
        {
            copy($source.$file, $dest.$file);
            
        }
    }

    @closedir($handle);
    
} 
function rrmdir($src) {
    $dir = opendir($src);
    while(false !== ( $file = readdir($dir)) ) {
        if (( $file != '.' ) && ( $file != '..' )) {
            $full = $src . '/' . $file;
            if ( is_dir($full) ) {
                rrmdir($full);
            }
            else {
                unlink($full);
            }
        }
    }
    closedir($dir);
    rmdir($src);
}

function color_trim($color, $default="#efefef")
{
	$color=trim($color);
	if ($color=="transparent") return $default;
	if (substr($color,0,4)=="rgba") 
	{
		$color1=substr($color,5);
		$col=explode(",",$color1);
		$r=$col[1];
		$g=$col[2];
		$b=$col[3];
		//mxDebugFuncVars($col);
		//die();
		return "#".$r.$g.$b;
	}
	return $color=substr($color,0,7);
}

function colordarker($color, $c = 10)
    {
       // $rgb = str_split(trim($color, '#'), 2);
		$color=substr($color,0,7);
		
		$rgb = sscanf($color, "#%02x%02x%02x");
		
		if (is_array($rgb)) {
			foreach ($rgb as $i => $value) {
				$hex = hexdec($rgb[$i]) - $c;
				if ($hex > 255) {
					$rgb[$i] = 'ff';
				} else if ($hex < 0) {
					$rgb[$i] = '00';
				} else {
					$rgb[$i] = substr('00' . dechex($hex), -2);
				}
			}
		
			return '#' . $rgb[0] . $rgb[1] . $rgb[2];
		}
		return "#000000";
    }



 
 function CSSparse($css){
    //$css = file_get_contents($file);
    preg_match_all( '/(?ims)([a-z0-9\s\.\:#_\-@,]+)\{([^\}]*)\}/', $css, $arr);
    $result = array();
    foreach ($arr[0] as $i => $x){
        $selector = trim($arr[1][$i]);
        $rules = explode(';', trim($arr[2][$i]));
        $rules_arr = array();
        foreach ($rules as $strRule){
            if (!empty($strRule)){
                $rule = explode(":", $strRule);
                $rules_arr[trim($rule[0])] = trim($rule[1]);
            }
        }

        $selectors = explode(',', trim($selector));
        foreach ($selectors as $strSel){
            $result[$strSel] = $rules_arr;
        }
    }
    return $result;
}

/*
<div class="blockcontent">
	<div class="both_sideblocks">
		<!-- START blocks_left_container -->	
		<!-- START blocks_left_loop -->
		<!-- START block_left -->
		<div id="__BLOCK_ID__" class="blocks_left" >
		<div class="blockheader t">  
		<h3 class="t">{BLOCK_TITLE}</h3>
		</div>
		<div class="blockcontent">
		{BLOCK_CONTENT}
		</div>
		</div>
		<!-- END block_left -->
		
		<!-- END blocks_left_loop -->
		
		<!-- END blocks_left_container --> 
		
		<!-- START blocks_right_container -->
		<!-- START blocks_right_loop -->
		<!-- START block_right -->
		<div id="__BLOCK_ID__" class="blocks_right">
		<div class="blockheader t"> 
		<h3 class="t">{BLOCK_TITLE}</h3>
		</div>
		<div class="blockcontent">
		{BLOCK_CONTENT}
		</div>
		</div>
		<!-- END block_right -->
		<!-- END blocks_right_loop -->
		<!-- END blocks_right_container -->		
	</div>
</div>
*/



function atx_download_font($font)
{
	/* wird übergeben : https://fonts.googleapis.com/css?family=Bitter|Work+Sans&subset=latin"
	/* ergibt dann 
	 - https://google-webfonts-helper.herokuapp.com/api/fonts/bitter?download=zip&subsets=latin&variants=regular
	 - https://google-webfonts-helper.herokuapp.com/api/fonts/work-sans?download=zip&subsets=latin&variants=regular
	
	*/
	$baselink="https://gwfh.mranftl.com/api/fonts/";//"https://google-webfonts-helper.herokuapp.com/api/fonts/";
	$family="Open Sans";
	$subsets="latin";
	$variants="&vairants=regular";

	/* link zerlegen */
	$font=str_replace("https://","",$font);
	$font=str_replace("http://","",$font);
	$fonts = str_replace("fonts.googleapis.com/css?family=","",$font);
	//mxDebugFuncVars($font,$fonts);
	$subsetpos=strpos($fonts,"&");
	$fonts=substr($fonts,0,$subsetpos);
	$fonts=explode("|",$fonts); // hier sollten dann alle Fonts drin sein
	$css="";
	$cssfont=array();
	foreach ($fonts as $font) 
	{
		$link="";
		$family=strtolower( str_replace("+","-",$font));
		$family2=str_replace("+"," ",$font);
		$link= $baselink . $family . "?download=zip&subsets=latin&variants=regular";
		//mxDebugFuncVars($font,$family);
		$zipfile=__DIR__ ."/fonts/fonts_".$family.".zip";
		atx_save_from_ext_url($link,$zipfile);	
		$zip = new ZipArchive;
		
		if ($zip->open($zipfile) === TRUE) {
			$i=0;
			
			$filename=$zip->getNameIndex(0);
			$cssfont[$family2]=$filename;

			$zip->extractTo(__DIR__ ."/fonts/");
			$zip->close();
			unlink($zipfile);

			//return $css;
		} else {
			return 'Fehler';
		}
	}
	foreach($cssfont as $family =>$filename) {
		$file2css=substr($filename,0,strpos($filename,".",0));
		$css .=atx_css_font ($family,$file2css);
	}
	return $css;
}
function atx_save_from_ext_url($url,$dest)
{
	// Initialize a file URL to the variable
  //$url = 'https://media.geeksforgeeks.org/wp-content/uploads/gfg-40.png';
  
  // Initialize the cURL session
  $ch = curl_init($url);
  
  // Initialize directory name where
  // file will be save
  $dir = $dest;
  
  // Use basename() function to return
  // the base name of file
  $file_name = basename($url);
  
  // Save file into file location
  $save_file_loc = $dir ;//. $file_name;
  
  // Open file
  $fp = fopen($save_file_loc, 'wb');
  
  // It set an option for a cURL transfer
  curl_setopt($ch, CURLOPT_FILE, $fp);
  curl_setopt($ch, CURLOPT_HEADER, 0);
  
  // Perform a cURL session
  curl_exec($ch);
  
  // Closes a cURL session and frees all resources
  curl_close($ch);
  
  // Close file
  fclose($fp);
  //file_put_contents(__DIR__ ."/fonts/"."fonts_log.txt",$url." - ".$dest."/n");
}

function atx_css_font ($family,$filename)
{
	/* CSS-Eintrag erstellen */
	
	$a="\n
	/*".$family." - latin */ 
	  @font-face {
	  font-family: '".$family."';
	  font-style: normal;
	  font-weight: 400;
	  src: url('../fonts/".$filename.".eot'); /* IE9 Compat Modes */
	  src: local('".$family."'),
		   url('../fonts/".$filename.".eot?#iefix') format('embedded-opentype'), /* IE6-IE8 */
		   url('../fonts/".$filename.".woff2') format('woff2'), /* Super Modern Browsers */
		   url('../fonts/".$filename.".woff') format('woff'), /* Modern Browsers */
		   url('../fonts/".$filename.".ttf') format('truetype'); /* Safari, Android, iOS */
	} \n
	";
	return $a;

}

// HTML/XML Tag Attribute ermitteln 
function get_tag_attributes($code, $tag_search = false) {
  // Einzelnen Tagnamen in ein Array packen
  if ($tag_search && !is_array($tag_search)) {
    $tag_search = array($tag_search);
  }

  // Alle Tags auslesen
  $matches = array();
  preg_match_all('/<([a-z]*?) (.*?)\>/is', $code, $matches);

  // Funde durchlaufen und Attribute ermitteln
  $tags = array();
  foreach ($matches[1] as $key => $tag_name) {
    // Nicht zugelassene Tags überspringen
    if ($tag_search) {
      if (!in_array(strtolower($tag_name), $tag_search)) {
        continue;
      }
    }

    // Attribute austrennen
    $attributes = array();
    preg_match_all('/([a-z]*?)=(".*?"|\'.*?\')/is',
      $matches[2][$key], $attributes);

    // Attribute abspeichern
    $tag = array('tag' => $tag_name);
    foreach ($attributes[1] as $key => $value) {
      $tag[$value] = substr($attributes[2][$key], 1, -1);
    }
    $tags[] = $tag;
  }

  // Daten zurückgeben
  return $tags;
}

function replaceHeaderGraphics()
{
	$a="themes/"._THISTHEMENAME_."";
	
	if ( mxCopy ($a."/style/images/header.jpg",$a."/images/header.jpg")) {
	
		
		$cssfiles=array(
			$a."/style/style.css",
			$a."/style/style.ie7.css",
			$a."/style/style.responsive.css",
			$a."/style/pragma.css",
			$a."/style/news.css",
			$a."/style/hmenu.css",
			$a."/style/script.js",
			$a."/style/script.responsive.js"
		);
		$search = "images/header.jpg";
		$replace= "../images/header.jpg";
		
		
		foreach($cssfiles as $key) {
			$myatx2="";
			$myatx2=file_get_contents($key);
			
			$myatx2= str_replace($search,$replace,$myatx2);
			
			file_put_contents ($key,$myatx2);
		}
		return true;
	}
	return false;
}
 
?>